
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "obj/conf/cf-parse.y"

/* Headers from conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from conf/confbase.Y */

static void
check_u16(uint val)
{
  if (val > 0xFFFF)
    cf_error("Value %u out of range (0-65535)", val);
}

/* Headers from conf/flowspec.Y */

#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"


/* Defines from conf/flowspec.Y */

struct flow_builder *this_flow;


/* Headers from filter/config.Y */

/* Defines from filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
  case T_RD:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if ((val->type == T_IP) && ipa_is_ip4(val->val.ip)) {
      ipv4_used = 1; key = ipa_to_u32(val->val.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = f_new_inst(FI_LC_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
    rv->a3.p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  for (struct f_path_mask *tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}

/*
 * Remove all new lines and doubled whitespaces
 * and convert all tabulators to spaces
 * and return a copy of string
 */
char *
assert_copy_expr(const char *start, size_t len)
{
  /* XXX: Allocates maybe a little more memory than we really finally need */
  char *str = cfg_alloc(len + 1);

  char *dst = str;
  const char *src = start - 1;
  const char *end = start + len;
  while (++src < end)
  {
    if (*src == '\n')
      continue;

    /* Skip doubled whitespaces */
    if (src != start)
    {
      const char *prev = src - 1;
      if ((*src == ' ' || *src == '\t') && (*prev == ' ' || *prev == '\t'))
	continue;
    }

    if (*src == '\t')
      *dst = ' ';
    else
      *dst = *src;

    dst++;
  }
  *dst = '\0';

  return str;
}

/*
 * assert_done - create f_instruction of bt_assert
 * @expr: expression in bt_assert()
 * @start: pointer to first char of test expression
 * @end: pointer to the last char of test expression
 */
static struct f_inst *
assert_done(struct f_inst *expr, const char *start, const char *end)
{
  struct f_inst *i;
  i = f_new_inst(FI_ASSERT);
  i->a1.p = expr;

  if (end >= start)
  {
    i->a2.p = assert_copy_expr(start, end - start + 1);
  }
  else
  {
    /* this is a break of lexer buffer */
    i->a2.p = "???";
  }

  return i;
}

/* Headers from nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from nest/config.Y */

static struct proto_config *this_proto;
static struct channel_config *this_channel;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
/* static struct roa_table_config *this_roa_table; */
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->prefix.type)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

static void
proto_postconfig(void)
{
  CALL(this_proto->protocol->postconfig, this_proto);
  this_channel = NULL;
  this_proto = NULL;
}


#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)

/* Headers from proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)
#define BGP_CC ((struct bgp_channel_config *) this_channel)

/* Headers from proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

/* Headers from proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if (ospf_cfg_is_v2() && (ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;

      if (ospf_cfg_is_v3() && ip->autype && (pass->alg < ALG_HMAC))
	cf_error("Keyed hash algorithms are not allowed, use HMAC algorithms");
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;
  struct ospf_area_config *ac;
  struct ospf_iface_patt *ic;

  /* Define default channel */
  if (EMPTY_LIST(this_proto->channels))
  {
    uint net_type = this_proto->net_type = ospf_cfg_is_v2() ? NET_IP4 : NET_IP6;
    channel_config_new(NULL, net_label[net_type], net_type, this_proto);
  }

  /* Propagate global instance ID to interfaces */
  if (cf->instance_id_set)
  {
    WALK_LIST(ac, cf->area_list)
      WALK_LIST(ic, ac->patt_list)
	if (!ic->instance_id_set)
	{ ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }

    WALK_LIST(ic, cf->vlink_list)
      if (!ic->instance_id_set)
      { ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }
  }

  if (ospf_cfg_is_v3())
  {
    uint ipv4 = (this_proto->net_type == NET_IP4);
    uint base = (ipv4 ? 64 : 0) + (cf->af_mc ? 32 : 0);

    /* RFC 5838 - OSPFv3-AF */
    if (cf->af_ext)
    {
      /* RFC 5838 2.1 - instance IDs based on AFs */
      WALK_LIST(ac, cf->area_list)
	WALK_LIST(ic, ac->patt_list)
	{
	  if (!ic->instance_id_set)
	    ic->instance_id = base;
	  else if (ic->instance_id >= 128)
	    log(L_WARN "Instance ID %d from unassigned/private range", ic->instance_id);
	  else if ((ic->instance_id < base) || (ic->instance_id >= (base + 32)))
	    cf_error("Instance ID %d invalid for given channel type", ic->instance_id);
	}

      /* RFC 5838 2.8 - vlinks limited to IPv6 unicast */
      if ((ipv4 || cf->af_mc) && !EMPTY_LIST(cf->vlink_list))
	cf_error("Vlinks not supported in AFs other than IPv6 unicast");
    }
    else
    {
      if (ipv4 || cf->af_mc)
	cf_error("Different channel type");
    }
  }

  if (EMPTY_LIST(cf->area_list))
    cf_error("No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (proto_cf_main_channel(this_proto)->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%u", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Plaintext authentication not supported in OSPFv3");
}


/* Headers from proto/perf/config.Y */

#include "filter/filter.h"
#include "proto/perf/perf.h"

/* Defines from proto/perf/config.Y */

#define PERF_CFG ((struct perf_config *) this_proto)

/* Headers from proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_snh;
static struct f_inst **this_srt_last_cmd;

static struct static_route *
static_nexthop_new(void)
{
  struct static_route *nh = this_srt;

  if (this_snh)
  {
    /* Additional next hop */
    nh = cfg_allocz(sizeof(struct static_route));
    nh->net = this_srt->net;
    this_snh->mp_next = nh;
  }

  nh->dest = RTD_UNICAST;
  nh->mp_head = this_srt;
  return nh;
};

static void
static_route_finish(void)
{
  if (net_type_match(this_srt->net, NB_DEST) == !this_srt->dest)
    cf_error("Unexpected or missing nexthop/type");
}

/* Headers from sysdep/linux/netlink.Y */

/* Headers from sysdep/unix/config.Y */

#include "sysdep/unix/unix.h"
#include <stdio.h>

/* Defines from sysdep/unix/config.Y */

static struct log_config *this_log;

/* Headers from sysdep/unix/krt.Y */

#include "sysdep/unix/krt.h"

/* Defines from sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)
#define KIF_IFACE ((struct kif_iface_config *) this_ipatt)

static void
kif_set_preferred(ip_addr ip)
{
  if (ipa_is_ip4(ip))
    KIF_IFACE->pref_v4 = ip;
  else if (!ipa_is_link_local(ip))
    KIF_IFACE->pref_v6 = ip;
  else
    KIF_IFACE->pref_ll = ip;
}



/* Line 189 of yacc.c  */
#line 919 "obj/conf/cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     IP4 = 272,
     IP6 = 273,
     VPN_RD = 274,
     SYM = 275,
     TEXT = 276,
     PREFIX_DUMMY = 277,
     NMA = 278,
     DEFINE = 279,
     ON = 280,
     OFF = 281,
     YES = 282,
     NO = 283,
     S = 284,
     MS = 285,
     US = 286,
     PORT = 287,
     VPN = 288,
     MPLS = 289,
     FROM = 290,
     FLOW4 = 291,
     FLOW6 = 292,
     DST = 293,
     SRC = 294,
     PROTO = 295,
     NEXT = 296,
     HEADER = 297,
     DPORT = 298,
     SPORT = 299,
     ICMP = 300,
     TYPE = 301,
     CODE = 302,
     TCP = 303,
     FLAGS = 304,
     LENGTH = 305,
     DSCP = 306,
     DONT_FRAGMENT = 307,
     IS_FRAGMENT = 308,
     FIRST_FRAGMENT = 309,
     LAST_FRAGMENT = 310,
     FRAGMENT = 311,
     LABEL = 312,
     OFFSET = 313,
     FUNCTION = 314,
     PRINT = 315,
     PRINTN = 316,
     UNSET = 317,
     RETURN = 318,
     ACCEPT = 319,
     REJECT = 320,
     ERROR = 321,
     QUITBIRD = 322,
     INT = 323,
     BOOL = 324,
     IP = 325,
     PREFIX = 326,
     RD = 327,
     PAIR = 328,
     QUAD = 329,
     EC = 330,
     LC = 331,
     SET = 332,
     STRING = 333,
     BGPMASK = 334,
     BGPPATH = 335,
     CLIST = 336,
     ECLIST = 337,
     LCLIST = 338,
     IF = 339,
     THEN = 340,
     ELSE = 341,
     CASE = 342,
     TRUE = 343,
     FALSE = 344,
     RT = 345,
     RO = 346,
     UNKNOWN = 347,
     GENERIC = 348,
     GW = 349,
     NET = 350,
     MASK = 351,
     SOURCE = 352,
     SCOPE = 353,
     DEST = 354,
     IFNAME = 355,
     IFINDEX = 356,
     PREFERENCE = 357,
     ROA_CHECK = 358,
     ASN = 359,
     IS_V4 = 360,
     IS_V6 = 361,
     LEN = 362,
     MAXLEN = 363,
     DEFINED = 364,
     ADD = 365,
     DELETE = 366,
     CONTAINS = 367,
     RESET = 368,
     PREPEND = 369,
     FIRST = 370,
     LAST = 371,
     LAST_NONAGGREGATED = 372,
     MATCH = 373,
     EMPTY = 374,
     FILTER = 375,
     WHERE = 376,
     EVAL = 377,
     ATTRIBUTE = 378,
     BT_ASSERT = 379,
     BT_TEST_SUITE = 380,
     FORMAT = 381,
     ROUTER = 382,
     ID = 383,
     PROTOCOL = 384,
     TEMPLATE = 385,
     DISABLED = 386,
     DEBUG = 387,
     ALL = 388,
     DIRECT = 389,
     INTERFACE = 390,
     IMPORT = 391,
     EXPORT = 392,
     NONE = 393,
     VRF = 394,
     TABLE = 395,
     STATES = 396,
     ROUTES = 397,
     FILTERS = 398,
     IPV4 = 399,
     IPV6 = 400,
     VPN4 = 401,
     VPN6 = 402,
     ROA4 = 403,
     ROA6 = 404,
     SADR = 405,
     RECEIVE = 406,
     LIMIT = 407,
     ACTION = 408,
     WARN = 409,
     BLOCK = 410,
     RESTART = 411,
     DISABLE = 412,
     KEEP = 413,
     FILTERED = 414,
     PASSWORD = 415,
     PASSIVE = 416,
     TO = 417,
     EVENTS = 418,
     PACKETS = 419,
     PROTOCOLS = 420,
     INTERFACES = 421,
     ALGORITHM = 422,
     KEYED = 423,
     HMAC = 424,
     MD5 = 425,
     SHA1 = 426,
     SHA256 = 427,
     SHA384 = 428,
     SHA512 = 429,
     PRIMARY = 430,
     STATS = 431,
     COUNT = 432,
     BY = 433,
     FOR = 434,
     COMMANDS = 435,
     PREEXPORT = 436,
     NOEXPORT = 437,
     GENERATE = 438,
     BGP = 439,
     PASSWORDS = 440,
     DESCRIPTION = 441,
     SORTED = 442,
     RELOAD = 443,
     IN = 444,
     OUT = 445,
     MRTDUMP = 446,
     MESSAGES = 447,
     RESTRICT = 448,
     MEMORY = 449,
     IGP_METRIC = 450,
     CLASS = 451,
     TIMEFORMAT = 452,
     ISO = 453,
     SHORT = 454,
     LONG = 455,
     ROUTE = 456,
     BASE = 457,
     LOG = 458,
     GRACEFUL = 459,
     WAIT = 460,
     MAX = 461,
     FLUSH = 462,
     AS = 463,
     IPV4_MC = 464,
     IPV4_MPLS = 465,
     IPV6_MC = 466,
     IPV6_MPLS = 467,
     IPV6_SADR = 468,
     VPN4_MC = 469,
     VPN4_MPLS = 470,
     VPN6_MC = 471,
     VPN6_MPLS = 472,
     PRI = 473,
     SEC = 474,
     SHOW = 475,
     STATUS = 476,
     SUMMARY = 477,
     SYMBOLS = 478,
     DUMP = 479,
     RESOURCES = 480,
     SOCKETS = 481,
     NEIGHBORS = 482,
     ATTRIBUTES = 483,
     ECHO = 484,
     ENABLE = 485,
     BFD = 486,
     MIN = 487,
     IDLE = 488,
     RX = 489,
     TX = 490,
     INTERVAL = 491,
     MULTIPLIER = 492,
     MULTIHOP = 493,
     NEIGHBOR = 494,
     DEV = 495,
     LOCAL = 496,
     AUTHENTICATION = 497,
     SIMPLE = 498,
     METICULOUS = 499,
     SESSIONS = 500,
     BABEL = 501,
     METRIC = 502,
     RXCOST = 503,
     HELLO = 504,
     UPDATE = 505,
     WIRED = 506,
     WIRELESS = 507,
     BUFFER = 508,
     PRIORITY = 509,
     CHECK = 510,
     LINK = 511,
     HOP = 512,
     BABEL_METRIC = 513,
     ENTRIES = 514,
     RANDOMIZE = 515,
     HOLD = 516,
     TIME = 517,
     CONNECT = 518,
     RETRY = 519,
     KEEPALIVE = 520,
     STARTUP = 521,
     VIA = 522,
     SELF = 523,
     DEFAULT = 524,
     PATH = 525,
     START = 526,
     DELAY = 527,
     FORGET = 528,
     AFTER = 529,
     BGP_PATH = 530,
     BGP_LOCAL_PREF = 531,
     BGP_MED = 532,
     BGP_ORIGIN = 533,
     BGP_NEXT_HOP = 534,
     BGP_ATOMIC_AGGR = 535,
     BGP_AGGREGATOR = 536,
     BGP_COMMUNITY = 537,
     BGP_EXT_COMMUNITY = 538,
     BGP_LARGE_COMMUNITY = 539,
     ADDRESS = 540,
     RR = 541,
     RS = 542,
     CLIENT = 543,
     CLUSTER = 544,
     AS4 = 545,
     ADVERTISE = 546,
     CAPABILITIES = 547,
     PREFER = 548,
     OLDER = 549,
     MISSING = 550,
     LLADDR = 551,
     DROP = 552,
     IGNORE = 553,
     REFRESH = 554,
     INTERPRET = 555,
     COMMUNITIES = 556,
     BGP_ORIGINATOR_ID = 557,
     BGP_CLUSTER_LIST = 558,
     IGP = 559,
     GATEWAY = 560,
     RECURSIVE = 561,
     MED = 562,
     TTL = 563,
     SECURITY = 564,
     DETERMINISTIC = 565,
     SECONDARY = 566,
     ALLOW = 567,
     PATHS = 568,
     AWARE = 569,
     EXTENDED = 570,
     SETKEY = 571,
     STRICT = 572,
     BIND = 573,
     CONFEDERATION = 574,
     MEMBER = 575,
     MULTICAST = 576,
     LIVED = 577,
     STALE = 578,
     IBGP = 579,
     EBGP = 580,
     CEASE = 581,
     HIT = 582,
     ADMINISTRATIVE = 583,
     SHUTDOWN = 584,
     PEER = 585,
     CONFIGURATION = 586,
     CHANGE = 587,
     DECONFIGURED = 588,
     CONNECTION = 589,
     REJECTED = 590,
     COLLISION = 591,
     OF = 592,
     MRT = 593,
     FILENAME = 594,
     PERIOD = 595,
     ALWAYS = 596,
     OSPF = 597,
     V2 = 598,
     V3 = 599,
     OSPF_METRIC1 = 600,
     OSPF_METRIC2 = 601,
     OSPF_TAG = 602,
     OSPF_ROUTER_ID = 603,
     AREA = 604,
     RFC1583COMPAT = 605,
     STUB = 606,
     TICK = 607,
     COST = 608,
     COST2 = 609,
     RETRANSMIT = 610,
     TRANSMIT = 611,
     DEAD = 612,
     BROADCAST = 613,
     BCAST = 614,
     NONBROADCAST = 615,
     NBMA = 616,
     POINTOPOINT = 617,
     PTP = 618,
     POINTOMULTIPOINT = 619,
     PTMP = 620,
     CRYPTOGRAPHIC = 621,
     ELIGIBLE = 622,
     POLL = 623,
     NETWORKS = 624,
     HIDDEN = 625,
     VIRTUAL = 626,
     ONLY = 627,
     LARGE = 628,
     NORMAL = 629,
     STUBNET = 630,
     TAG = 631,
     EXTERNAL = 632,
     LSADB = 633,
     ECMP = 634,
     WEIGHT = 635,
     NSSA = 636,
     TRANSLATOR = 637,
     STABILITY = 638,
     GLOBAL = 639,
     LSID = 640,
     INSTANCE = 641,
     REAL = 642,
     NETMASK = 643,
     MERGE = 644,
     LSA = 645,
     SUPPRESSION = 646,
     RFC5838 = 647,
     PE = 648,
     TOPOLOGY = 649,
     STATE = 650,
     PERF = 651,
     EXP = 652,
     REPEAT = 653,
     THRESHOLD = 654,
     MODE = 655,
     PIPE = 656,
     RADV = 657,
     RA = 658,
     MANAGED = 659,
     OTHER = 660,
     CONFIG = 661,
     LINGER = 662,
     MTU = 663,
     REACHABLE = 664,
     RETRANS = 665,
     TIMER = 666,
     CURRENT = 667,
     VALID = 668,
     PREFERRED = 669,
     MULT = 670,
     LIFETIME = 671,
     SKIP = 672,
     ONLINK = 673,
     AUTONOMOUS = 674,
     RDNSS = 675,
     DNSSL = 676,
     NS = 677,
     DOMAIN = 678,
     TRIGGER = 679,
     SENSITIVE = 680,
     LOW = 681,
     MEDIUM = 682,
     HIGH = 683,
     PROPAGATE = 684,
     RA_PREFERENCE = 685,
     RA_LIFETIME = 686,
     RIP = 687,
     NG = 688,
     INFINITY = 689,
     TIMEOUT = 690,
     GARBAGE = 691,
     VERSION = 692,
     SPLIT = 693,
     HORIZON = 694,
     POISON = 695,
     REVERSE = 696,
     ZERO = 697,
     PLAINTEXT = 698,
     RIP_METRIC = 699,
     RIP_TAG = 700,
     STATIC = 701,
     PROHIBIT = 702,
     BLACKHOLE = 703,
     UNREACHABLE = 704,
     KERNEL = 705,
     KRT_PREFSRC = 706,
     KRT_REALM = 707,
     KRT_SCOPE = 708,
     KRT_MTU = 709,
     KRT_WINDOW = 710,
     KRT_RTT = 711,
     KRT_RTTVAR = 712,
     KRT_SSTRESH = 713,
     KRT_CWND = 714,
     KRT_ADVMSS = 715,
     KRT_REORDERING = 716,
     KRT_HOPLIMIT = 717,
     KRT_INITCWND = 718,
     KRT_RTO_MIN = 719,
     KRT_INITRWND = 720,
     KRT_QUICKACK = 721,
     KRT_LOCK_MTU = 722,
     KRT_LOCK_WINDOW = 723,
     KRT_LOCK_RTT = 724,
     KRT_LOCK_RTTVAR = 725,
     KRT_LOCK_SSTRESH = 726,
     KRT_LOCK_CWND = 727,
     KRT_LOCK_ADVMSS = 728,
     KRT_LOCK_REORDERING = 729,
     KRT_LOCK_HOPLIMIT = 730,
     KRT_LOCK_RTO_MIN = 731,
     KRT_FEATURE_ECN = 732,
     KRT_FEATURE_ALLFRAG = 733,
     SYSLOG = 734,
     TRACE = 735,
     INFO = 736,
     REMOTE = 737,
     WARNING = 738,
     AUTH = 739,
     FATAL = 740,
     BUG = 741,
     STDERR = 742,
     SOFT = 743,
     NAME = 744,
     CONFIRM = 745,
     UNDO = 746,
     LATENCY = 747,
     WATCHDOG = 748,
     CONFIGURE = 749,
     DOWN = 750,
     PERSIST = 751,
     SCAN = 752,
     LEARN = 753,
     DEVICE = 754,
     KRT_SOURCE = 755,
     KRT_METRIC = 756
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 840 "obj/conf/cf-parse.y"

  uint i;
  u32 i32;
  u64 i64;
  ip_addr a;
  ip4_addr ip4;
  ip6_addr ip6;
  net_addr net;
  net_addr *net_ptr;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct channel_config *cc;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  void *g;
  btime time;
  struct f_prefix px;
  struct proto_spec ps;
  struct channel_limit cl;
  struct timeformat *tf;
  mpls_label_stack *mls;



/* Line 214 of yacc.c  */
#line 1494 "obj/conf/cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1506 "obj/conf/cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  69
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4359

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  523
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  390
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1315
/* YYNRULES -- Number of states.  */
#define YYNSTATES  2401

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   756

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    33,     2,     2,     2,    32,     2,     2,
     514,   515,    30,    28,   516,    29,    34,    31,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   519,   513,
      24,    23,    25,   520,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   521,     2,   522,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   517,     2,   518,    26,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    27,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    17,    23,
      25,    29,    31,    34,    37,    40,    42,    44,    46,    48,
      50,    51,    53,    55,    57,    58,    61,    64,    67,    71,
      79,    82,    85,    91,    97,   100,   102,   104,   106,   108,
     110,   112,   114,   116,   118,   120,   122,   124,   126,   128,
     130,   132,   134,   136,   138,   140,   142,   144,   146,   148,
     150,   154,   156,   158,   160,   162,   163,   165,   167,   169,
     171,   173,   175,   177,   179,   181,   183,   185,   188,   190,
     192,   194,   197,   200,   202,   204,   206,   209,   211,   213,
     215,   217,   220,   225,   227,   231,   233,   237,   239,   243,
     248,   255,   262,   263,   265,   267,   269,   271,   273,   276,
     281,   286,   289,   292,   295,   298,   301,   306,   309,   312,
     315,   318,   319,   323,   324,   328,   329,   330,   331,   338,
     345,   347,   349,   351,   352,   357,   359,   362,   364,   369,
     371,   378,   380,   382,   384,   386,   388,   390,   392,   394,
     396,   398,   400,   402,   404,   406,   408,   411,   414,   415,
     419,   421,   425,   427,   429,   431,   434,   438,   441,   446,
     448,   449,   455,   456,   458,   460,   463,   465,   469,   471,
     473,   475,   477,   479,   481,   485,   487,   489,   493,   495,
     497,   499,   505,   513,   519,   527,   537,   545,   551,   559,
     565,   577,   579,   581,   584,   586,   594,   604,   612,   620,
     630,   638,   648,   656,   666,   674,   690,   692,   694,   696,
     698,   702,   704,   706,   708,   710,   714,   716,   720,   722,
     726,   728,   731,   734,   741,   743,   747,   748,   753,   757,
     759,   763,   767,   770,   775,   778,   781,   784,   785,   787,
     789,   791,   793,   795,   797,   799,   803,   807,   809,   815,
     823,   831,   833,   834,   839,   841,   843,   845,   847,   849,
     851,   853,   855,   857,   859,   863,   867,   871,   875,   879,
     883,   887,   891,   895,   899,   903,   907,   911,   915,   919,
     922,   927,   929,   931,   933,   935,   938,   941,   945,   949,
     953,   957,   961,   965,   969,   973,   980,   984,   988,   992,
     996,  1000,  1006,  1014,  1021,  1028,  1035,  1042,  1047,  1056,
    1061,  1066,  1068,  1070,  1072,  1074,  1076,  1078,  1080,  1081,
    1083,  1087,  1089,  1093,  1094,  1096,  1101,  1108,  1113,  1117,
    1123,  1129,  1134,  1141,  1145,  1148,  1154,  1160,  1169,  1178,
    1187,  1196,  1204,  1205,  1207,  1212,  1218,  1220,  1224,  1226,
    1228,  1230,  1236,  1238,  1240,  1243,  1245,  1247,  1249,  1251,
    1253,  1255,  1257,  1259,  1260,  1262,  1267,  1269,  1271,  1273,
    1274,  1276,  1279,  1283,  1284,  1287,  1290,  1293,  1297,  1300,
    1303,  1305,  1308,  1311,  1314,  1318,  1322,  1326,  1329,  1334,
    1335,  1339,  1340,  1344,  1345,  1349,  1351,  1354,  1356,  1358,
    1360,  1361,  1364,  1367,  1370,  1373,  1376,  1378,  1380,  1384,
    1388,  1390,  1392,  1394,  1396,  1398,  1401,  1406,  1410,  1415,
    1420,  1424,  1429,  1434,  1438,  1439,  1441,  1444,  1445,  1447,
    1451,  1453,  1457,  1459,  1460,  1463,  1466,  1469,  1472,  1475,
    1479,  1483,  1487,  1491,  1497,  1498,  1502,  1504,  1506,  1510,
    1512,  1516,  1518,  1520,  1522,  1524,  1526,  1528,  1530,  1532,
    1536,  1538,  1542,  1544,  1546,  1551,  1553,  1554,  1558,  1563,
    1565,  1568,  1569,  1575,  1581,  1587,  1593,  1598,  1603,  1608,
    1613,  1616,  1619,  1622,  1625,  1628,  1631,  1634,  1637,  1640,
    1643,  1645,  1649,  1651,  1655,  1657,  1662,  1664,  1670,  1672,
    1673,  1675,  1679,  1681,  1686,  1688,  1693,  1694,  1697,  1701,
    1705,  1709,  1716,  1720,  1723,  1726,  1729,  1732,  1736,  1742,
    1746,  1749,  1752,  1754,  1756,  1758,  1760,  1763,  1766,  1770,
    1772,  1774,  1776,  1778,  1780,  1782,  1784,  1786,  1788,  1790,
    1792,  1794,  1796,  1798,  1800,  1802,  1804,  1806,  1808,  1810,
    1812,  1814,  1816,  1818,  1820,  1822,  1824,  1826,  1828,  1833,
    1834,  1837,  1840,  1843,  1846,  1849,  1852,  1854,  1858,  1860,
    1864,  1866,  1870,  1872,  1876,  1878,  1882,  1884,  1888,  1890,
    1894,  1896,  1900,  1902,  1906,  1908,  1913,  1915,  1917,  1921,
    1922,  1924,  1926,  1931,  1933,  1938,  1940,  1945,  1947,  1951,
    1953,  1958,  1960,  1965,  1967,  1972,  1974,  1979,  1981,  1984,
    1986,  1988,  1990,  1992,  1993,  1995,  1997,  1999,  2002,  2004,
    2007,  2010,  2013,  2014,  2018,  2024,  2025,  2026,  2029,  2034,
    2039,  2044,  2047,  2050,  2053,  2055,  2057,  2059,  2062,  2065,
    2069,  2073,  2074,  2078,  2079,  2083,  2088,  2092,  2093,  2096,
    2099,  2100,  2103,  2104,  2107,  2112,  2114,  2120,  2122,  2125,
    2127,  2129,  2132,  2137,  2138,  2142,  2148,  2149,  2150,  2151,
    2154,  2157,  2160,  2163,  2166,  2170,  2174,  2178,  2182,  2185,
    2189,  2193,  2198,  2203,  2204,  2208,  2209,  2213,  2218,  2220,
    2222,  2229,  2231,  2238,  2240,  2247,  2249,  2256,  2259,  2262,
    2263,  2267,  2271,  2272,  2276,  2280,  2282,  2286,  2288,  2292,
    2294,  2298,  2301,  2304,  2307,  2310,  2313,  2316,  2320,  2324,
    2328,  2332,  2337,  2344,  2349,  2356,  2361,  2368,  2374,  2380,
    2385,  2391,  2397,  2404,  2408,  2412,  2417,  2423,  2429,  2435,
    2441,  2447,  2453,  2459,  2465,  2471,  2478,  2485,  2492,  2498,
    2505,  2514,  2521,  2528,  2535,  2541,  2548,  2553,  2558,  2563,
    2568,  2574,  2580,  2587,  2593,  2599,  2605,  2612,  2620,  2628,
    2636,  2642,  2648,  2653,  2658,  2660,  2662,  2665,  2668,  2671,
    2674,  2677,  2680,  2683,  2686,  2688,  2690,  2692,  2694,  2696,
    2698,  2700,  2705,  2710,  2715,  2719,  2723,  2727,  2730,  2733,
    2736,  2740,  2746,  2752,  2757,  2761,  2765,  2769,  2773,  2777,
    2778,  2782,  2783,  2787,  2788,  2792,  2794,  2796,  2798,  2800,
    2802,  2804,  2806,  2808,  2810,  2812,  2814,  2816,  2818,  2821,
    2823,  2826,  2829,  2832,  2834,  2837,  2840,  2845,  2846,  2850,
    2856,  2858,  2863,  2864,  2868,  2872,  2876,  2879,  2883,  2886,
    2888,  2891,  2894,  2897,  2901,  2905,  2906,  2908,  2911,  2915,
    2917,  2919,  2922,  2925,  2929,  2933,  2936,  2941,  2945,  2948,
    2952,  2954,  2957,  2962,  2963,  2967,  2970,  2972,  2975,  2979,
    2983,  2987,  2991,  2994,  2998,  2999,  3005,  3006,  3012,  3015,
    3018,  3020,  3025,  3027,  3029,  3030,  3034,  3037,  3040,  3043,
    3049,  3052,  3053,  3057,  3058,  3061,  3064,  3068,  3071,  3074,
    3078,  3081,  3084,  3087,  3089,  3093,  3096,  3099,  3102,  3105,
    3108,  3111,  3115,  3118,  3121,  3124,  3127,  3130,  3133,  3136,
    3139,  3143,  3147,  3151,  3154,  3158,  3161,  3165,  3169,  3174,
    3179,  3182,  3185,  3188,  3192,  3196,  3200,  3203,  3207,  3211,
    3215,  3220,  3223,  3225,  3226,  3229,  3233,  3235,  3236,  3238,
    3241,  3242,  3245,  3246,  3248,  3252,  3253,  3254,  3257,  3258,
    3262,  3263,  3267,  3268,  3272,  3276,  3278,  3280,  3282,  3284,
    3286,  3291,  3293,  3300,  3302,  3309,  3311,  3318,  3320,  3328,
    3330,  3337,  3339,  3347,  3349,  3355,  3356,  3359,  3363,  3366,
    3370,  3374,  3377,  3381,  3384,  3387,  3390,  3394,  3398,  3402,
    3404,  3408,  3412,  3415,  3419,  3423,  3426,  3429,  3432,  3435,
    3436,  3441,  3444,  3448,  3452,  3458,  3460,  3463,  3465,  3467,
    3470,  3473,  3474,  3478,  3479,  3483,  3486,  3490,  3491,  3495,
    3501,  3502,  3507,  3512,  3516,  3519,  3523,  3527,  3531,  3535,
    3540,  3545,  3550,  3554,  3558,  3563,  3568,  3571,  3572,  3576,
    3577,  3581,  3585,  3589,  3591,  3593,  3595,  3596,  3597,  3601,
    3602,  3606,  3611,  3613,  3616,  3619,  3622,  3627,  3632,  3633,
    3634,  3638,  3639,  3643,  3647,  3649,  3650,  3651,  3654,  3657,
    3658,  3659,  3663,  3665,  3671,  3673,  3674,  3675,  3678,  3681,
    3682,  3683,  3687,  3689,  3695,  3697,  3700,  3701,  3704,  3706,
    3708,  3710,  3712,  3715,  3718,  3720,  3722,  3725,  3730,  3733,
    3736,  3737,  3741,  3747,  3748,  3749,  3752,  3755,  3758,  3761,
    3764,  3767,  3770,  3774,  3778,  3782,  3786,  3790,  3794,  3798,
    3802,  3806,  3810,  3813,  3817,  3821,  3826,  3830,  3833,  3836,
    3838,  3840,  3842,  3844,  3846,  3847,  3851,  3852,  3856,  3861,
    3863,  3865,  3867,  3874,  3876,  3883,  3886,  3889,  3893,  3897,
    3901,  3907,  3913,  3918,  3922,  3925,  3929,  3933,  3937,  3941,
    3943,  3946,  3949,  3952,  3956,  3962,  3964,  3967,  3970,  3973,
    3976,  3979,  3981,  3982,  3985,  3986,  3990,  3992,  3997,  4001,
    4005,  4008,  4010,  4012,  4014,  4016,  4018,  4020,  4022,  4024,
    4026,  4028,  4030,  4032,  4034,  4036,  4038,  4040,  4042,  4044,
    4046,  4048,  4050,  4052,  4054,  4056,  4058,  4060,  4062,  4064,
    4066,  4067,  4073,  4076,  4077,  4078,  4081,  4084,  4087,  4089,
    4091,  4095,  4097,  4101,  4103,  4105,  4107,  4109,  4111,  4113,
    4115,  4117,  4119,  4121,  4126,  4130,  4132,  4136,  4141,  4145,
    4149,  4151,  4156,  4158,  4164,  4166,  4170,  4172,  4176,  4178,
    4183,  4185,  4188,  4189,  4191,  4192,  4194,  4197,  4200,  4203,
    4207,  4211,  4212,  4215,  4217,  4219,  4222,  4226,  4229,  4233,
    4238,  4241,  4244,  4248,  4252,  4254,  4257,  4261,  4262,  4265,
    4266,  4270,  4271,  4275,  4279,  4281
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     524,     0,    -1,   525,     3,    -1,     4,   680,    -1,    -1,
     525,   526,    -1,   513,    -1,   527,    -1,    35,    20,    23,
     623,   513,    -1,    15,    -1,   514,   623,   515,    -1,    20,
      -1,   528,    40,    -1,   528,    41,    -1,   528,    42,    -1,
     528,    -1,    36,    -1,    38,    -1,    37,    -1,    39,    -1,
      -1,    17,    -1,    18,    -1,    20,    -1,    -1,    32,    20,
      -1,    31,    15,    -1,    17,   533,    -1,    18,    31,    15,
      -1,    18,    31,    15,    46,    18,    31,    15,    -1,    19,
     534,    -1,    19,   535,    -1,   534,   217,    15,   219,    15,
      -1,   535,   217,    15,   219,    15,    -1,    45,    15,    -1,
     534,    -1,   535,    -1,   537,    -1,   538,    -1,   539,    -1,
     540,    -1,   542,    -1,   543,    -1,   544,    -1,   579,    -1,
     536,    -1,   541,    -1,   535,    -1,    20,    -1,   542,    -1,
      20,    -1,   545,    -1,    20,    -1,   534,    -1,   535,    -1,
      17,    -1,    18,    -1,    20,    -1,    15,    -1,   550,    -1,
     551,    31,    15,    -1,    21,    -1,    21,    -1,    20,    -1,
      21,    -1,    -1,    99,    -1,    23,    -1,    10,    -1,    24,
      -1,     9,    -1,    25,    -1,     8,    -1,   100,    -1,    12,
      -1,    11,    -1,    51,    -1,    52,    53,    -1,    43,    -1,
      54,    -1,    55,    -1,    56,    57,    -1,    56,    58,    -1,
      61,    -1,    62,    -1,   557,    -1,    59,    60,    -1,    67,
      -1,    68,    -1,    49,    -1,    50,    -1,   555,   528,    -1,
     563,   556,   555,   528,    -1,   565,    -1,   563,    12,   565,
      -1,   528,    -1,   528,     7,   528,    -1,   564,    -1,   565,
     516,   564,    -1,   567,   528,    31,   528,    -1,   566,   556,
     567,   528,    31,   528,    -1,   566,   516,   567,   528,    31,
     528,    -1,    -1,    33,    -1,    63,    -1,    64,    -1,    65,
      -1,    66,    -1,   567,   568,    -1,   569,   556,   567,   568,
      -1,   569,   516,   567,   568,    -1,   562,   547,    -1,   558,
     563,    -1,   559,   566,    -1,   560,   569,    -1,   562,   546,
      -1,   562,   546,    69,    15,    -1,   558,   563,    -1,   559,
     566,    -1,   560,   569,    -1,   561,   566,    -1,    -1,   572,
     570,   513,    -1,    -1,   573,   571,   513,    -1,    -1,    -1,
      -1,    47,   517,   574,   575,   572,   518,    -1,    48,   517,
     574,   576,   573,   518,    -1,   577,    -1,   578,    -1,   580,
      -1,    -1,   131,    20,   581,   589,    -1,   582,    -1,   133,
     623,    -1,   583,    -1,   134,   585,    20,   513,    -1,   584,
      -1,   136,   514,    20,   516,   553,   515,    -1,    79,    -1,
      80,    -1,    81,    -1,    83,    -1,    82,    -1,    84,    -1,
      85,    -1,    86,    -1,    87,    -1,    89,    -1,    90,    -1,
      91,    -1,    92,    -1,    93,    -1,    94,    -1,   585,    88,
      -1,   585,    20,    -1,    -1,   586,   513,   587,    -1,   586,
      -1,   586,   513,   588,    -1,   593,    -1,    20,    -1,   589,
      -1,   132,   623,    -1,   514,   588,   515,    -1,   514,   515,
      -1,   587,   517,   596,   518,    -1,   594,    -1,    -1,    70,
      20,   595,   592,   593,    -1,    -1,   597,    -1,   629,    -1,
     597,   629,    -1,   629,    -1,   517,   596,   518,    -1,    17,
      -1,    18,    -1,    15,    -1,   599,    -1,    19,    -1,    16,
      -1,   514,   623,   515,    -1,    20,    -1,    15,    -1,   514,
     623,   515,    -1,   599,    -1,    16,    -1,   623,    -1,   514,
     602,   516,   602,   515,    -1,   514,   602,   516,   602,     7,
     602,   515,    -1,   514,   602,   516,    30,   515,    -1,   514,
     602,     7,   602,   516,   602,   515,    -1,   514,   602,     7,
     602,   516,   602,     7,   602,   515,    -1,   514,   602,     7,
     602,   516,    30,   515,    -1,   514,    30,   516,   602,   515,
      -1,   514,    30,   516,   602,     7,   602,   515,    -1,   514,
      30,   516,    30,   515,    -1,   514,   602,   516,   602,   515,
       7,   514,   602,   516,   602,   515,    -1,   101,    -1,   102,
      -1,   103,    15,    -1,   104,    -1,   514,   604,   516,   602,
     516,   602,   515,    -1,   514,   604,   516,   602,   516,   602,
       7,   602,   515,    -1,   514,   604,   516,   602,   516,    30,
     515,    -1,   514,   602,   516,   602,   516,   602,   515,    -1,
     514,   602,   516,   602,   516,   602,     7,   602,   515,    -1,
     514,   602,   516,   602,   516,    30,   515,    -1,   514,   602,
     516,   602,     7,   602,   516,    30,   515,    -1,   514,   602,
     516,    30,   516,    30,   515,    -1,   514,   602,     7,   602,
     516,    30,   516,    30,   515,    -1,   514,    30,   516,    30,
     516,    30,   515,    -1,   514,   602,   516,   602,   516,   602,
     515,     7,   514,   602,   516,   602,   516,   602,   515,    -1,
     603,    -1,   605,    -1,   606,    -1,   600,    -1,   600,     7,
     600,    -1,   603,    -1,   605,    -1,   606,    -1,   601,    -1,
     601,     7,   601,    -1,   607,    -1,   609,   516,   607,    -1,
     608,    -1,   610,   516,   608,    -1,   542,    -1,   542,    28,
      -1,   542,    29,    -1,   542,   517,    15,   516,    15,   518,
      -1,   611,    -1,   612,   516,   611,    -1,    -1,   613,   610,
     519,   596,    -1,   613,     6,   596,    -1,   621,    -1,   514,
     623,   515,    -1,    13,   616,    14,    -1,    15,   616,    -1,
      15,     7,    15,   616,    -1,    30,   616,    -1,   520,   616,
      -1,   614,   616,    -1,    -1,    15,    -1,    99,    -1,   100,
      -1,    21,    -1,   599,    -1,    19,    -1,   545,    -1,   521,
     609,   522,    -1,   521,   612,   522,    -1,    16,    -1,   514,
     623,   516,   623,   515,    -1,   514,   604,   516,   623,   516,
     623,   515,    -1,   514,   623,   516,   623,   516,   623,   515,
      -1,   615,    -1,    -1,    20,   514,   628,   515,    -1,    20,
      -1,    46,    -1,   105,    -1,   106,    -1,    51,    -1,   108,
      -1,   109,    -1,   110,    -1,   111,    -1,   112,    -1,   514,
     623,   515,    -1,   623,    28,   623,    -1,   623,    29,   623,
      -1,   623,    30,   623,    -1,   623,    31,   623,    -1,   623,
      11,   623,    -1,   623,    12,   623,    -1,   623,    23,   623,
      -1,   623,    10,   623,    -1,   623,    24,   623,    -1,   623,
       9,   623,    -1,   623,    25,   623,    -1,   623,     8,   623,
      -1,   623,    26,   623,    -1,   623,    27,   623,    -1,    33,
     623,    -1,   120,   514,   623,   515,    -1,   621,    -1,   617,
      -1,   618,    -1,   113,    -1,   619,   622,    -1,   619,   719,
      -1,   623,    34,   116,    -1,   623,    34,    57,    -1,   623,
      34,    81,    -1,   623,    34,    83,    -1,   623,    34,   118,
      -1,   623,    34,   119,    -1,   623,    34,   115,    -1,   623,
      34,    50,    -1,   623,    34,   107,   514,   623,   515,    -1,
     623,    34,   126,    -1,   623,    34,   127,    -1,   623,    34,
     128,    -1,    28,   130,    28,    -1,    29,   130,    29,    -1,
      29,    29,   130,    29,    29,    -1,    29,    29,    29,   130,
      29,    29,    29,    -1,   125,   514,   623,   516,   623,   515,
      -1,   121,   514,   623,   516,   623,   515,    -1,   122,   514,
     623,   516,   623,   515,    -1,   131,   514,   623,   516,   623,
     515,    -1,   114,   514,   646,   515,    -1,   114,   514,   646,
     516,   623,   516,   623,   515,    -1,   137,   514,   623,   515,
      -1,    20,   514,   628,   515,    -1,    78,    -1,    75,    -1,
      76,    -1,    77,    -1,    71,    -1,    72,    -1,   623,    -1,
      -1,   625,    -1,   625,   516,   626,    -1,   623,    -1,   623,
     516,   627,    -1,    -1,   627,    -1,    95,   623,    96,   598,
      -1,    95,   623,    96,   598,    97,   598,    -1,    20,    23,
     623,   513,    -1,    74,   623,   513,    -1,   619,   719,    23,
     623,   513,    -1,   619,   622,    23,   623,   513,    -1,   113,
      23,   623,   513,    -1,    73,   514,   619,   719,   515,   513,
      -1,   624,   626,   513,    -1,   620,   513,    -1,    98,   623,
     517,   613,   518,    -1,   619,   719,    34,   130,   513,    -1,
     619,   719,    34,   125,   514,   623,   515,   513,    -1,   619,
     719,    34,   121,   514,   623,   515,   513,    -1,   619,   719,
      34,   122,   514,   623,   515,   513,    -1,   619,   719,    34,
     131,   514,   623,   515,   513,    -1,   135,   514,   630,   623,
     630,   515,   513,    -1,    -1,   631,    -1,   138,   139,   632,
     513,    -1,   138,   139,    46,   661,   513,    -1,    15,    -1,
     514,   623,   515,    -1,    17,    -1,    20,    -1,   633,    -1,
     215,   167,   216,   528,   513,    -1,   155,    -1,   156,    -1,
     156,   161,    -1,   157,    -1,   158,    -1,   159,    -1,   160,
      -1,    47,    -1,    48,    -1,    45,    -1,   636,    -1,    -1,
     198,    -1,   634,   151,    20,   635,    -1,   663,    -1,   140,
      -1,   141,    -1,    -1,    20,    -1,    46,    20,    -1,    20,
      46,    20,    -1,    -1,   142,   530,    -1,   143,   668,    -1,
     202,   671,    -1,   138,   139,   632,    -1,   197,   553,    -1,
     150,   553,    -1,   634,    -1,   151,   646,    -1,   147,   647,
      -1,   148,   647,    -1,   162,   163,   649,    -1,   147,   163,
     649,    -1,   148,   163,   649,    -1,   113,   528,    -1,   147,
     169,   170,   530,    -1,    -1,   642,   641,   513,    -1,    -1,
     517,   642,   518,    -1,    -1,   640,   643,   644,    -1,    20,
      -1,   131,   590,    -1,   591,    -1,   144,    -1,   149,    -1,
      -1,   164,   165,    -1,   164,   166,    -1,   164,   167,    -1,
     164,   168,    -1,   528,   648,    -1,    37,    -1,   650,    -1,
     143,   176,   668,    -1,   143,   191,   528,    -1,   653,    -1,
     212,    -1,   140,    -1,   213,    -1,   214,    -1,   651,    21,
      -1,   651,    21,   528,    21,    -1,   651,   209,   210,    -1,
     651,   209,   210,    41,    -1,   651,   209,   210,    42,    -1,
     651,   209,   211,    -1,   651,   209,   211,    41,    -1,   651,
     209,   211,    42,    -1,   208,   652,   513,    -1,    -1,    21,
      -1,   554,   549,    -1,    -1,    29,    -1,   654,   656,   655,
      -1,   657,    -1,   658,   516,   657,    -1,   658,    -1,    -1,
     660,   658,    -1,   207,   528,    -1,    62,   528,    -1,   665,
     518,    -1,   637,   145,    -1,   664,   638,   517,    -1,   665,
     639,   513,    -1,   665,   645,   513,    -1,   665,   667,   513,
      -1,   665,   266,   267,   530,   513,    -1,    -1,   146,   666,
     658,    -1,   144,    -1,    37,    -1,   517,   669,   518,    -1,
     670,    -1,   669,   516,   670,    -1,   152,    -1,   153,    -1,
     154,    -1,   177,    -1,   174,    -1,   175,    -1,   144,    -1,
      37,    -1,   517,   672,   518,    -1,   673,    -1,   672,   516,
     673,    -1,   152,    -1,   203,    -1,   196,   517,   675,   518,
      -1,   676,    -1,    -1,   676,   513,   675,    -1,   677,   517,
     678,   518,    -1,   677,    -1,   171,   553,    -1,    -1,   194,
      46,   552,   513,   678,    -1,   194,   173,   552,   513,   678,
      -1,    75,    46,   552,   513,   678,    -1,    75,   173,   552,
     513,   678,    -1,    46,   552,   513,   678,    -1,   173,   552,
     513,   678,    -1,   139,   528,   513,   678,    -1,   178,   679,
     513,   678,    -1,   179,   181,    -1,   179,   182,    -1,   179,
     183,    -1,   179,   184,    -1,   179,   185,    -1,   180,   181,
      -1,   180,   182,    -1,   180,   183,    -1,   180,   184,    -1,
     180,   185,    -1,   681,    -1,   231,   232,     3,    -1,   682,
      -1,   231,   205,     3,    -1,   683,    -1,   231,   176,   718,
       3,    -1,   684,    -1,   231,   176,   144,   718,     3,    -1,
      20,    -1,    -1,   686,    -1,   231,   177,     3,    -1,   687,
      -1,   231,   177,   233,     3,    -1,   688,    -1,   231,   212,
     689,     3,    -1,    -1,   689,   548,    -1,   689,   190,   690,
      -1,   689,   151,    20,    -1,   689,   151,   144,    -1,   689,
     147,   151,    20,    34,   693,    -1,   689,   131,   590,    -1,
     689,   591,    -1,   689,   144,    -1,   689,   186,    -1,   689,
     170,    -1,   689,   692,    20,    -1,   689,   692,    20,    34,
     693,    -1,   689,   140,    20,    -1,   689,   187,    -1,   689,
     188,    -1,   691,    -1,   537,    -1,   538,    -1,   536,    -1,
      19,    17,    -1,    19,    18,    -1,    18,    46,    18,    -1,
      20,    -1,   534,    -1,   535,    -1,    17,    -1,    18,    -1,
     192,    -1,   148,    -1,   193,    -1,   155,    -1,   220,    -1,
     221,    -1,   156,    -1,   222,    -1,   223,    -1,   224,    -1,
     157,    -1,   225,    -1,   226,    -1,   158,    -1,   227,    -1,
     228,    -1,   159,    -1,   160,    -1,    47,    -1,    48,    -1,
      45,    -1,   229,    -1,   230,    -1,   694,    -1,   231,   234,
     695,     3,    -1,    -1,   695,   151,    -1,   695,    70,    -1,
     695,   131,    -1,   695,   140,    -1,   695,   141,    -1,   695,
      20,    -1,   696,    -1,   235,   236,     3,    -1,   697,    -1,
     235,   237,     3,    -1,   698,    -1,   235,   174,     3,    -1,
     699,    -1,   235,   177,     3,    -1,   700,    -1,   235,   238,
       3,    -1,   701,    -1,   235,   239,     3,    -1,   702,    -1,
     235,   153,     3,    -1,   703,    -1,   235,   176,     3,    -1,
     704,    -1,   133,   623,     3,    -1,   705,    -1,   240,   706,
     707,     3,    -1,   144,    -1,    37,    -1,   517,   890,   518,
      -1,    -1,    15,    -1,   708,    -1,   168,   717,   554,     3,
      -1,   709,    -1,   241,   717,   554,     3,    -1,   710,    -1,
     167,   717,   554,     3,    -1,   711,    -1,   199,   717,     3,
      -1,   712,    -1,   199,   200,   717,     3,    -1,   713,    -1,
     199,   201,   717,     3,    -1,   714,    -1,   143,   717,   668,
       3,    -1,   715,    -1,   202,   717,   671,     3,    -1,   716,
      -1,   204,     3,    -1,    20,    -1,   144,    -1,    21,    -1,
      20,    -1,    -1,    21,    -1,   206,    -1,   723,    -1,   637,
     242,    -1,   639,    -1,   146,   730,    -1,   249,   731,    -1,
     250,   735,    -1,    -1,   722,   721,   513,    -1,   720,   638,
     517,   722,   518,    -1,    -1,    -1,   247,   529,    -1,   243,
     245,   247,   529,    -1,   243,   246,   247,   529,    -1,   244,
     246,   247,   529,    -1,   248,   528,    -1,   172,   530,    -1,
     253,   727,    -1,   674,    -1,   149,    -1,   254,    -1,   179,
     181,    -1,   179,   182,    -1,   255,   179,   181,    -1,   255,
     179,   182,    -1,    -1,   728,   726,   513,    -1,    -1,   517,
     728,   518,    -1,   724,   659,   729,   725,    -1,   724,   729,
     725,    -1,    -1,    32,    20,    -1,   251,   553,    -1,    -1,
     252,   531,    -1,    -1,   249,   530,    -1,   531,   732,   733,
     734,    -1,   736,    -1,   231,   242,   256,   685,     3,    -1,
     740,    -1,   637,   257,    -1,   639,    -1,   645,    -1,   146,
     746,    -1,   271,   138,   139,   530,    -1,    -1,   739,   738,
     513,    -1,   737,   638,   517,   739,   518,    -1,    -1,    -1,
      -1,    43,   528,    -1,   259,   528,    -1,   163,   528,    -1,
      57,   262,    -1,    57,   263,    -1,   260,   247,   529,    -1,
     261,   247,   529,    -1,   245,   264,   528,    -1,   246,    61,
     528,    -1,   246,   662,    -1,   246,   265,   528,    -1,   266,
     267,   530,    -1,    52,   268,   155,   531,    -1,    52,   268,
     156,   531,    -1,    -1,   744,   743,   513,    -1,    -1,   517,
     744,   518,    -1,   741,   659,   745,   742,    -1,   269,    -1,
     747,    -1,   231,   257,   177,   685,   554,     3,    -1,   748,
      -1,   231,   257,   238,   685,   554,     3,    -1,   749,    -1,
     231,   257,   270,   685,   554,     3,    -1,   750,    -1,   231,
     257,   153,   685,   554,     3,    -1,   757,   518,    -1,   637,
     195,    -1,    -1,   752,    43,   528,    -1,   752,   219,   528,
      -1,    -1,   753,    43,   528,    -1,   753,   219,   528,    -1,
     530,    -1,   517,   755,   518,    -1,   756,    -1,   755,   516,
     756,    -1,   337,    -1,    82,   163,   338,    -1,   339,   340,
      -1,   341,   344,    -1,   339,   124,    -1,   345,   346,    -1,
     342,   343,    -1,   345,   347,    -1,   201,   348,   236,    -1,
     751,   638,   517,    -1,   757,   639,   513,    -1,   757,   765,
     513,    -1,   757,   252,   752,   513,    -1,   757,   252,   531,
     532,   752,   513,    -1,   757,   250,   753,   513,    -1,   757,
     250,   531,   532,   753,   513,    -1,   757,   146,    21,   513,
      -1,   757,   297,   300,   139,   632,   513,    -1,   757,   297,
     299,   530,   513,    -1,   757,   298,   299,   530,   513,    -1,
     757,   330,   528,   513,    -1,   757,   330,   331,   530,   513,
      -1,   757,   272,   273,   528,   513,    -1,   757,   277,   272,
     273,   528,   513,    -1,   757,   145,   513,    -1,   757,   249,
     513,    -1,   757,   249,   528,   513,    -1,   757,   328,   329,
     530,   513,    -1,   757,   281,   258,   530,   513,    -1,   757,
     318,   258,   530,   513,    -1,   757,   315,   258,   530,   513,
      -1,   757,   304,   305,   530,   513,    -1,   757,   321,   318,
     530,   513,    -1,   757,   280,   288,   528,   513,    -1,   757,
     280,   287,   528,   513,    -1,   757,   108,   296,   531,   513,
      -1,   757,   282,   283,   273,   528,   513,    -1,   757,   274,
     283,   273,   528,   513,    -1,   757,   274,   275,   273,   528,
     513,    -1,   757,   276,   273,   528,   513,    -1,   757,    77,
     284,   273,   528,   513,    -1,   757,    77,   216,   273,   528,
     516,   528,   513,    -1,   757,   168,   285,    77,   530,   513,
      -1,   757,   168,   285,   337,   754,   513,    -1,   757,   241,
     212,   310,   530,   513,    -1,   757,   241,   301,   530,   513,
      -1,   757,   241,   326,   203,   530,   513,    -1,   757,   303,
     530,   513,    -1,   757,   171,   553,   513,    -1,   757,   327,
     530,   513,    -1,   757,   172,   530,   513,    -1,   757,   311,
     312,   530,   513,    -1,   757,   323,   252,   219,   513,    -1,
     757,   323,   252,   219,   528,   513,    -1,   757,   323,   287,
     530,   513,    -1,   757,   215,   167,   530,   513,    -1,   757,
     215,   167,   325,   513,    -1,   757,   215,   167,   273,   528,
     513,    -1,   757,   211,   333,   215,   167,   530,   513,    -1,
     757,   211,   333,   215,   167,   325,   513,    -1,   757,   211,
     333,   334,   273,   528,   513,    -1,   757,   319,   320,   530,
     513,    -1,   757,   266,   267,   530,   513,    -1,   757,   242,
     530,   513,    -1,   757,   242,   215,   513,    -1,   155,    -1,
     156,    -1,   155,   332,    -1,   156,   332,    -1,   155,    45,
      -1,   156,    45,    -1,   157,    45,    -1,   158,    45,    -1,
     157,   332,    -1,   158,   332,    -1,    47,    -1,    48,    -1,
     758,    -1,   530,    -1,   335,    -1,   336,    -1,   641,    -1,
      52,   268,   296,   531,    -1,    52,   268,   279,   760,    -1,
      52,   268,   169,   760,    -1,   306,   307,   279,    -1,   306,
     307,   308,    -1,   306,   307,   309,    -1,   316,   145,    -1,
     316,   317,    -1,   322,   530,    -1,   215,   167,   530,    -1,
     211,   333,   215,   167,   530,    -1,   211,   333,   334,   273,
     528,    -1,   326,    52,   268,   530,    -1,   121,   324,   245,
      -1,   121,   324,   246,    -1,   121,   324,   530,    -1,   147,
     151,   530,    -1,   315,   151,   646,    -1,    -1,   762,   761,
     513,    -1,    -1,   517,   762,   518,    -1,    -1,   759,   763,
     764,    -1,   289,    -1,   286,    -1,   290,    -1,   288,    -1,
     287,    -1,   291,    -1,   292,    -1,   293,    -1,   313,    -1,
     314,    -1,   294,    -1,   295,    -1,   769,    -1,   637,   349,
      -1,   639,    -1,   151,   646,    -1,   151,    21,    -1,   131,
     590,    -1,   591,    -1,   350,   553,    -1,   351,   528,    -1,
     352,   121,   281,   530,    -1,    -1,   768,   767,   513,    -1,
     766,   638,   517,   768,   518,    -1,   770,    -1,   349,   235,
     771,     3,    -1,    -1,   771,   151,   646,    -1,   771,   151,
      21,    -1,   771,   131,   590,    -1,   771,   591,    -1,   771,
     173,   553,    -1,   774,   518,    -1,   353,    -1,   353,   354,
      -1,   353,   355,    -1,   637,   772,    -1,   773,   638,   517,
      -1,   774,   778,   513,    -1,    -1,   332,    -1,   634,   775,
      -1,   776,   643,   644,    -1,   639,    -1,   777,    -1,   361,
     530,    -1,   403,   530,    -1,    44,   404,   530,    -1,   362,
     138,   530,    -1,   390,   530,    -1,   390,   530,   163,   528,
      -1,   400,   388,   530,    -1,   363,   528,    -1,   397,   139,
     528,    -1,   780,    -1,   360,   632,    -1,   779,   517,   781,
     518,    -1,    -1,   781,   782,   513,    -1,   362,   530,    -1,
     392,    -1,   233,   530,    -1,   280,   392,   530,    -1,   280,
     364,   528,    -1,   280,   365,   528,    -1,   362,   364,   528,
      -1,   393,   530,    -1,   393,   394,   528,    -1,    -1,   380,
     783,   517,   794,   518,    -1,    -1,   388,   784,   517,   794,
     518,    -1,   386,   785,    -1,   146,   807,    -1,   789,    -1,
     786,   517,   787,   518,    -1,   786,    -1,   547,    -1,    -1,
     787,   788,   513,    -1,   381,   530,    -1,   233,   530,    -1,
     364,   528,    -1,   792,   802,   517,   790,   518,    -1,   792,
     802,    -1,    -1,   790,   791,   513,    -1,    -1,   260,   528,
      -1,   366,   528,    -1,   367,   283,   528,    -1,   216,   528,
      -1,   368,   528,    -1,   368,   188,   528,    -1,   253,   149,
      -1,   253,   254,    -1,   253,   377,    -1,   674,    -1,   382,
     267,   632,    -1,   364,   528,    -1,   260,   528,    -1,   379,
     528,    -1,   366,   528,    -1,   216,   528,    -1,   368,   528,
      -1,   368,   188,   528,    -1,    57,   369,    -1,    57,   370,
      -1,    57,   371,    -1,    57,   372,    -1,    57,   373,    -1,
      57,   374,    -1,    57,   375,    -1,    57,   376,    -1,   398,
     369,   530,    -1,   374,   399,   530,    -1,   367,   283,   528,
      -1,   265,   528,    -1,   328,   371,   530,    -1,   362,   530,
      -1,   266,   267,   530,    -1,   390,   391,   528,    -1,   267,
     401,   402,   530,    -1,   238,   517,   798,   518,    -1,   253,
     149,    -1,   253,   254,    -1,   253,   377,    -1,   245,   264,
     385,    -1,   245,   264,   384,    -1,   245,   264,   528,    -1,
     246,   662,    -1,   246,   265,   528,    -1,   246,    61,   528,
      -1,   319,   320,   530,    -1,   319,   320,   246,   383,    -1,
     242,   530,    -1,   674,    -1,    -1,   794,   795,    -1,   796,
     797,   513,    -1,   547,    -1,    -1,   381,    -1,   387,   528,
      -1,    -1,   798,   800,    -1,    -1,   378,    -1,   531,   799,
     513,    -1,    -1,    -1,   397,   528,    -1,    -1,   658,   804,
     802,    -1,    -1,   805,   793,   513,    -1,    -1,   517,   805,
     518,    -1,   801,   803,   806,    -1,   356,    -1,   357,    -1,
     358,    -1,   359,    -1,   808,    -1,   231,   353,   685,     3,
      -1,   809,    -1,   231,   353,   238,   685,   554,     3,    -1,
     810,    -1,   231,   353,   146,   685,   554,     3,    -1,   811,
      -1,   231,   353,   405,   685,   554,     3,    -1,   812,    -1,
     231,   353,   405,   144,   685,   554,     3,    -1,   813,    -1,
     231,   353,   406,   685,   554,     3,    -1,   814,    -1,   231,
     353,   406,   144,   685,   554,     3,    -1,   815,    -1,   231,
     353,   389,   816,     3,    -1,    -1,   816,   395,    -1,   816,
     360,   632,    -1,   816,   267,    -1,   816,    57,    15,    -1,
     816,   396,   632,    -1,   816,   279,    -1,   816,   138,   632,
      -1,   816,    20,    -1,   818,   518,    -1,   637,   407,    -1,
     817,   638,   517,    -1,   818,   819,   513,    -1,   818,   639,
     513,    -1,   645,    -1,   408,    46,    15,    -1,   408,   173,
      15,    -1,   409,    15,    -1,   410,   243,   529,    -1,   410,
     217,   529,    -1,   169,   530,    -1,   411,   147,    -1,   411,
     148,    -1,   822,   518,    -1,    -1,   637,   412,   821,   638,
      -1,   820,   517,    -1,   822,   639,   513,    -1,   822,   641,
     513,    -1,   822,   341,   151,   646,   513,    -1,   828,    -1,
     637,   413,    -1,   639,    -1,   645,    -1,   146,   837,    -1,
      82,   843,    -1,    -1,   431,   825,   849,    -1,    -1,   432,
     826,   855,    -1,   435,   546,    -1,   440,   153,   530,    -1,
      -1,   827,   824,   513,    -1,   823,   638,   517,   827,   518,
      -1,    -1,   243,   414,   247,   528,    -1,   217,   414,   247,
     528,    -1,   243,   283,   528,    -1,   415,   530,    -1,   416,
     417,   530,    -1,   267,   419,   528,    -1,   420,   273,   528,
      -1,   421,   422,   528,    -1,   423,   268,   163,   528,    -1,
     280,   427,   528,   857,    -1,   212,   427,   528,   857,    -1,
     280,   113,   833,    -1,   212,   113,   833,    -1,    82,   418,
     273,   528,    -1,   212,   418,   273,   528,    -1,    82,   843,
      -1,    -1,   431,   831,   849,    -1,    -1,   432,   832,   855,
      -1,   431,   252,   530,    -1,   432,   252,   530,    -1,   437,
      -1,   438,    -1,   439,    -1,    -1,    -1,   835,   830,   513,
      -1,    -1,   517,   835,   518,    -1,   829,   659,   836,   834,
      -1,   546,    -1,   428,   530,    -1,   429,   530,    -1,   430,
     530,    -1,   424,   427,   528,   857,    -1,   425,   427,   528,
     857,    -1,    -1,    -1,   841,   839,   513,    -1,    -1,   517,
     841,   518,    -1,   838,   842,   840,    -1,   531,    -1,    -1,
      -1,   433,   844,    -1,   427,   856,    -1,    -1,    -1,   848,
     846,   513,    -1,   844,    -1,   517,   845,   848,   518,   847,
      -1,    21,    -1,    -1,    -1,   434,   850,    -1,   427,   856,
      -1,    -1,    -1,   854,   852,   513,    -1,   850,    -1,   517,
     851,   854,   518,   853,    -1,   528,    -1,   426,   528,    -1,
      -1,   436,   530,    -1,   441,    -1,   442,    -1,   862,    -1,
     443,    -1,   443,   444,    -1,   637,   858,    -1,   639,    -1,
     645,    -1,   390,   530,    -1,   390,   530,   163,   528,    -1,
     445,   528,    -1,   146,   869,    -1,    -1,   861,   860,   513,
      -1,   859,   638,   517,   861,   518,    -1,    -1,    -1,   258,
     528,    -1,   411,   332,    -1,   411,   369,    -1,   172,   530,
      -1,   296,   531,    -1,    43,   528,    -1,   448,   528,    -1,
     448,   383,   530,    -1,   449,   450,   530,    -1,   451,   452,
     530,    -1,   266,   453,   530,    -1,   261,   273,   528,    -1,
     446,   273,   528,    -1,   447,   273,   528,    -1,   390,   391,
     528,    -1,   245,   264,   528,    -1,   246,    61,   528,    -1,
     246,   662,    -1,   246,   265,   528,    -1,   319,   320,   530,
      -1,   319,   320,   246,   383,    -1,   266,   267,   530,    -1,
     242,   530,    -1,   253,   866,    -1,   674,    -1,   149,    -1,
     454,    -1,   377,    -1,   181,    -1,    -1,   867,   865,   513,
      -1,    -1,   517,   867,   518,    -1,   863,   659,   868,   864,
      -1,   455,    -1,   456,    -1,   870,    -1,   231,   443,   177,
     685,   554,     3,    -1,   871,    -1,   231,   443,   238,   685,
     554,     3,    -1,   873,   518,    -1,   637,   457,    -1,   872,
     638,   517,    -1,   873,   639,   513,    -1,   873,   645,   513,
      -1,   873,   266,   267,   530,   513,    -1,   873,   315,   151,
     646,   513,    -1,   873,   877,   880,   513,    -1,   278,   531,
     532,    -1,   278,    21,    -1,   874,    45,   551,    -1,   874,
     429,   530,    -1,   874,   391,   528,    -1,   874,   242,   530,
      -1,   874,    -1,   875,   874,    -1,   212,   548,    -1,   876,
     875,    -1,   876,   317,   531,    -1,   876,   317,   531,    45,
     551,    -1,   876,    -1,   876,   308,    -1,   876,    76,    -1,
     876,   459,    -1,   876,   460,    -1,   876,   458,    -1,   629,
      -1,    -1,   879,   878,    -1,    -1,   517,   879,   518,    -1,
     881,    -1,   231,   457,   685,     3,    -1,   882,   883,   513,
      -1,   461,   151,   528,    -1,   258,   528,    -1,   462,    -1,
     463,    -1,   464,    -1,   465,    -1,   466,    -1,   467,    -1,
     468,    -1,   469,    -1,   470,    -1,   471,    -1,   472,    -1,
     473,    -1,   474,    -1,   475,    -1,   476,    -1,   477,    -1,
     478,    -1,   479,    -1,   480,    -1,   481,    -1,   482,    -1,
     483,    -1,   484,    -1,   485,    -1,   486,    -1,   487,    -1,
     488,    -1,   489,    -1,   885,    -1,    -1,   214,   884,   888,
     889,   513,    -1,   500,   553,    -1,    -1,    -1,   528,   553,
      -1,   553,   887,    -1,   490,   886,    -1,   498,    -1,   144,
      -1,   517,   890,   518,    -1,   891,    -1,   890,   516,   891,
      -1,   143,    -1,   491,    -1,   492,    -1,   493,    -1,   494,
      -1,    77,    -1,   495,    -1,   496,    -1,   497,    -1,   892,
      -1,   202,   176,   671,   513,    -1,   202,   553,   513,    -1,
     893,    -1,   143,   503,   530,    -1,   143,   503,   163,   529,
      -1,   504,   494,   529,    -1,   504,   446,   529,    -1,   894,
      -1,   505,   900,   901,     3,    -1,   895,    -1,   505,   499,
     900,   901,     3,    -1,   896,    -1,   505,   501,     3,    -1,
     897,    -1,   505,   502,     3,    -1,   898,    -1,   505,   266,
     900,     3,    -1,   899,    -1,   506,     3,    -1,    -1,    21,
      -1,    -1,   446,    -1,   446,   528,    -1,   882,   518,    -1,
     637,   461,    -1,   902,   638,   517,    -1,   882,   904,   513,
      -1,    -1,   163,   528,    -1,   639,    -1,   645,    -1,   507,
     530,    -1,   508,   273,   528,    -1,   509,   530,    -1,   215,
     167,   530,    -1,   400,   324,   530,   903,    -1,   906,   518,
      -1,   637,   510,    -1,   905,   638,   517,    -1,   906,   907,
     513,    -1,   639,    -1,   146,   912,    -1,   508,   273,   528,
      -1,    -1,   425,   531,    -1,    -1,   910,   909,   513,    -1,
      -1,   517,   910,   518,    -1,   908,   659,   911,    -1,   511,
      -1,   512,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1085,  1085,  1086,  1089,  1091,  1094,  1099,  1102,  1111,
    1112,  1113,  1120,  1121,  1122,  1128,  1129,  1130,  1131,  1132,
    1133,  1140,  1141,  1142,  1149,  1150,  1157,  1163,  1173,  1186,
    1205,  1211,  1217,  1225,  1233,  1239,  1239,  1240,  1240,  1241,
    1241,  1244,  1245,  1246,  1247,  1248,  1249,  1256,  1257,  1265,
    1266,  1274,  1275,  1283,  1284,  1285,  1286,  1287,  1297,  1305,
    1306,  1315,  1323,  1324,  1331,  1332,  1341,  1342,  1343,  1344,
    1345,  1346,  1347,  1348,  1352,  1353,  1357,  1358,  1359,  1360,
    1361,  1362,  1363,  1364,  1365,  1368,  1369,  1370,  1371,  1374,
    1375,  1379,  1383,  1387,  1388,  1392,  1396,  1405,  1406,  1410,
    1414,  1418,  1425,  1426,  1430,  1431,  1432,  1433,  1437,  1440,
    1443,  1449,  1453,  1454,  1455,  1459,  1463,  1469,  1470,  1471,
    1472,  1475,  1477,  1480,  1482,  1486,  1493,  1494,  1496,  1502,
    1508,  1508,  1513,  1515,  1515,  1524,  1526,  1529,  1530,  1534,
    1536,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,
    1559,  1560,  1561,  1562,  1563,  1564,  1565,  1588,  1599,  1600,
    1607,  1608,  1615,  1624,  1628,  1632,  1653,  1654,  1658,  1669,
    1671,  1671,  1687,  1688,  1691,  1692,  1696,  1699,  1708,  1709,
    1722,  1723,  1724,  1725,  1726,  1730,  1738,  1739,  1740,  1741,
    1745,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,
    1757,  1762,  1763,  1764,  1765,  1769,  1770,  1771,  1775,  1776,
    1777,  1778,  1779,  1780,  1781,  1782,  1787,  1788,  1789,  1790,
    1791,  1795,  1796,  1797,  1798,  1799,  1803,  1804,  1808,  1809,
    1813,  1814,  1815,  1816,  1824,  1825,  1828,  1829,  1836,  1848,
    1849,  1853,  1857,  1858,  1859,  1860,  1861,  1862,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1879,  1880,
    1881,  1882,  1886,  1890,  1912,  1932,  1933,  1934,  1935,  1936,
    1937,  1938,  1939,  1940,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1962,  1963,  1964,  1966,  1968,  1970,  1972,  1973,  1974,
    1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2002,  2003,  2005,
    2010,  2032,  2033,  2034,  2035,  2036,  2037,  2041,  2044,  2045,
    2046,  2054,  2060,  2068,  2069,  2073,  2078,  2086,  2098,  2103,
    2107,  2113,  2117,  2122,  2123,  2124,  2130,  2131,  2132,  2133,
    2134,  2135,  2139,  2148,  2151,  2152,  2156,  2157,  2158,  2159,
    2169,  2171,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2185,  2186,  2194,  2197,  2198,  2201,  2211,  2214,  2215,  2219,
    2225,  2229,  2238,  2247,  2249,  2250,  2251,  2252,  2253,  2254,
    2258,  2264,  2269,  2270,  2271,  2272,  2273,  2274,  2275,  2278,
    2280,  2283,  2285,  2289,  2296,  2300,  2307,  2308,  2309,  2310,
    2314,  2315,  2316,  2317,  2318,  2322,  2323,  2327,  2330,  2331,
    2336,  2339,  2340,  2341,  2342,  2346,  2347,  2348,  2349,  2350,
    2351,  2352,  2353,  2357,  2364,  2372,  2373,  2377,  2378,  2382,
    2387,  2388,  2392,  2394,  2402,  2406,  2407,  2412,  2414,  2421,
    2422,  2423,  2424,  2425,  2429,  2437,  2443,  2444,  2445,  2449,
    2450,  2454,  2455,  2456,  2457,  2458,  2459,  2465,  2466,  2467,
    2471,  2472,  2476,  2477,  2483,  2484,  2487,  2489,  2493,  2494,
    2498,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2545,  2546,  2549,  2550,  2553,  2554,  2557,  2558,  2562,  2563,
    2566,  2567,  2570,  2571,  2575,  2576,  2580,  2586,  2591,  2597,
    2603,  2610,  2620,  2625,  2630,  2634,  2638,  2642,  2651,  2661,
    2669,  2673,  2680,  2684,  2685,  2686,  2687,  2691,  2695,  2699,
    2713,  2714,  2715,  2716,  2719,  2720,  2721,  2726,  2727,  2728,
    2729,  2730,  2731,  2732,  2733,  2734,  2735,  2736,  2737,  2738,
    2739,  2740,  2741,  2742,  2743,  2744,  2745,  2749,  2750,  2754,
    2757,  2758,  2759,  2760,  2761,  2762,  2767,  2768,  2770,  2771,
    2773,  2774,  2776,  2777,  2779,  2780,  2782,  2783,  2785,  2786,
    2788,  2789,  2792,  2793,  2797,  2798,  2804,  2805,  2806,  2810,
    2811,  2817,  2818,  2820,  2821,  2823,  2824,  2826,  2827,  2829,
    2830,  2832,  2833,  2837,  2838,  2842,  2843,  2846,  2847,  2851,
    2852,  2853,  2857,  2858,  2859,  2862,  2867,  2869,  2881,  2882,
    2883,  2884,  2887,  2889,  2893,  2897,  2911,  2931,  2932,  2933,
    2934,  2935,  2936,  2937,  2938,  2942,  2943,  2944,  2945,  2946,
    2947,  2950,  2952,  2955,  2957,  2961,  2964,  2969,  2970,  2971,
    2975,  2976,  2980,  2981,  2984,  3003,  3004,  3009,  3011,  3019,
    3020,  3021,  3022,  3025,  3027,  3031,  3035,  3049,  3074,  3075,
    3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,  3085,
    3086,  3087,  3088,  3091,  3093,  3096,  3098,  3103,  3105,  3109,
    3110,  3113,  3114,  3117,  3118,  3121,  3122,  3127,  3129,  3157,
    3159,  3160,  3163,  3165,  3166,  3171,  3172,  3176,  3177,  3181,
    3182,  3183,  3184,  3185,  3186,  3187,  3188,  3189,  3193,  3194,
    3195,  3196,  3197,  3201,  3202,  3208,  3209,  3210,  3211,  3212,
    3213,  3214,  3215,  3216,  3217,  3218,  3219,  3220,  3221,  3222,
    3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,
    3243,  3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,
    3253,  3254,  3255,  3256,  3260,  3261,  3262,  3263,  3264,  3265,
    3266,  3267,  3268,  3269,  3270,  3271,  3274,  3299,  3300,  3301,
    3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,  3312,  3313,
    3314,  3315,  3316,  3317,  3318,  3319,  3320,  3321,  3322,  3335,
    3337,  3340,  3342,  3346,  3353,  3356,  3358,  3360,  3362,  3364,
    3366,  3368,  3370,  3372,  3374,  3376,  3378,  3387,  3389,  3395,
    3396,  3397,  3398,  3399,  3400,  3401,  3402,  3405,  3407,  3411,
    3414,  3415,  3419,  3420,  3421,  3422,  3423,  3424,  3430,  3433,
    3434,  3435,  3438,  3452,  3453,  3457,  3458,  3462,  3472,  3475,
    3476,  3477,  3478,  3479,  3480,  3481,  3482,  3483,  3484,  3485,
    3486,  3489,  3504,  3507,  3509,  3513,  3514,  3515,  3516,  3517,
    3518,  3519,  3520,  3521,  3522,  3522,  3523,  3523,  3524,  3525,
    3526,  3530,  3531,  3535,  3543,  3545,  3549,  3550,  3551,  3555,
    3556,  3559,  3561,  3564,  3565,  3566,  3567,  3568,  3569,  3570,
    3571,  3572,  3573,  3574,  3577,  3596,  3597,  3598,  3599,  3600,
    3601,  3602,  3603,  3604,  3605,  3606,  3607,  3608,  3609,  3610,
    3611,  3612,  3613,  3614,  3615,  3616,  3617,  3618,  3619,  3620,
    3621,  3622,  3623,  3624,  3625,  3626,  3627,  3628,  3629,  3630,
    3631,  3632,  3633,  3636,  3638,  3641,  3643,  3651,  3653,  3654,
    3657,  3659,  3663,  3664,  3667,  3677,  3698,  3700,  3704,  3704,
    3707,  3709,  3712,  3714,  3718,  3721,  3722,  3723,  3724,  3727,
    3728,  3731,  3732,  3735,  3736,  3741,  3742,  3745,  3746,  3751,
    3752,  3755,  3756,  3760,  3761,  3765,  3768,  3769,  3770,  3771,
    3772,  3773,  3774,  3775,  3780,  3782,  3795,  3796,  3797,  3801,
    3802,  3803,  3804,  3805,  3806,  3807,  3808,  3809,  3815,  3818,
    3817,  3832,  3833,  3834,  3835,  3840,  3842,  3853,  3854,  3855,
    3856,  3857,  3857,  3858,  3858,  3859,  3860,  3863,  3865,  3869,
    3873,  3896,  3897,  3898,  3899,  3900,  3901,  3902,  3903,  3904,
    3905,  3910,  3914,  3915,  3916,  3917,  3918,  3919,  3919,  3920,
    3920,  3921,  3922,  3926,  3927,  3928,  3931,  3969,  3971,  3974,
    3976,  3980,  3983,  3995,  3996,  3997,  3998,  4002,  4009,  4017,
    4019,  4022,  4024,  4028,  4032,  4042,  4047,  4048,  4049,  4053,
    4065,  4067,  4071,  4072,  4076,  4089,  4094,  4095,  4096,  4100,
    4112,  4114,  4118,  4119,  4124,  4125,  4129,  4130,  4133,  4134,
    4138,  4141,  4142,  4145,  4159,  4160,  4161,  4162,  4163,  4164,
    4167,  4169,  4173,  4177,  4201,  4231,  4232,  4233,  4234,  4235,
    4236,  4237,  4241,  4242,  4243,  4244,  4245,  4246,  4247,  4248,
    4249,  4250,  4251,  4252,  4253,  4254,  4255,  4256,  4257,  4258,
    4262,  4263,  4264,  4265,  4268,  4270,  4273,  4275,  4279,  4282,
    4283,  4287,  4288,  4291,  4292,  4298,  4300,  4307,  4308,  4309,
    4310,  4311,  4319,  4323,  4328,  4333,  4336,  4339,  4343,  4349,
    4350,  4353,  4364,  4365,  4369,  4374,  4375,  4376,  4377,  4378,
    4379,  4383,  4386,  4388,  4391,  4393,  4397,  4398,  4403,  4406,
    4407,  4410,  4411,  4412,  4414,  4415,  4416,  4417,  4418,  4419,
    4420,  4421,  4422,  4423,  4424,  4425,  4426,  4428,  4429,  4430,
    4431,  4432,  4433,  4434,  4435,  4436,  4437,  4439,  4440,  4445,
    4447,  4449,  4456,  4457,  4460,  4462,  4466,  4473,  4474,  4478,
    4479,  4483,  4484,  4488,  4489,  4490,  4491,  4492,  4493,  4494,
    4495,  4496,  4500,  4503,  4504,  4512,  4515,  4516,  4517,  4518,
    4526,  4527,  4530,  4531,  4538,  4539,  4542,  4543,  4546,  4547,
    4550,  4551,  4555,  4556,  4560,  4561,  4562,  4569,  4571,  4576,
    4577,  4580,  4581,  4585,  4586,  4587,  4588,  4592,  4599,  4600,
    4611,  4613,  4616,  4617,  4620,  4621,  4622,  4629,  4636,  4639,
    4641,  4644,  4646,  4650,  4653,  4654
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "IP4", "IP6", "VPN_RD", "SYM", "TEXT", "PREFIX_DUMMY", "'='",
  "'<'", "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'",
  "'.'", "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT",
  "VPN", "MPLS", "FROM", "FLOW4", "FLOW6", "DST", "SRC", "PROTO", "NEXT",
  "HEADER", "DPORT", "SPORT", "ICMP", "TYPE", "CODE", "TCP", "FLAGS",
  "LENGTH", "DSCP", "DONT_FRAGMENT", "IS_FRAGMENT", "FIRST_FRAGMENT",
  "LAST_FRAGMENT", "FRAGMENT", "LABEL", "OFFSET", "FUNCTION", "PRINT",
  "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT", "ERROR", "QUITBIRD",
  "INT", "BOOL", "IP", "PREFIX", "RD", "PAIR", "QUAD", "EC", "LC", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "LCLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN",
  "GENERIC", "GW", "NET", "MASK", "SOURCE", "SCOPE", "DEST", "IFNAME",
  "IFINDEX", "PREFERENCE", "ROA_CHECK", "ASN", "IS_V4", "IS_V6", "LEN",
  "MAXLEN", "DEFINED", "ADD", "DELETE", "CONTAINS", "RESET", "PREPEND",
  "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH", "EMPTY", "FILTER",
  "WHERE", "EVAL", "ATTRIBUTE", "BT_ASSERT", "BT_TEST_SUITE", "FORMAT",
  "ROUTER", "ID", "PROTOCOL", "TEMPLATE", "DISABLED", "DEBUG", "ALL",
  "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "NONE", "VRF", "TABLE",
  "STATES", "ROUTES", "FILTERS", "IPV4", "IPV6", "VPN4", "VPN6", "ROA4",
  "ROA6", "SADR", "RECEIVE", "LIMIT", "ACTION", "WARN", "BLOCK", "RESTART",
  "DISABLE", "KEEP", "FILTERED", "PASSWORD", "PASSIVE", "TO", "EVENTS",
  "PACKETS", "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC",
  "MD5", "SHA1", "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT",
  "BY", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "BGP",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "TIMEFORMAT",
  "ISO", "SHORT", "LONG", "ROUTE", "BASE", "LOG", "GRACEFUL", "WAIT",
  "MAX", "FLUSH", "AS", "IPV4_MC", "IPV4_MPLS", "IPV6_MC", "IPV6_MPLS",
  "IPV6_SADR", "VPN4_MC", "VPN4_MPLS", "VPN6_MC", "VPN6_MPLS", "PRI",
  "SEC", "SHOW", "STATUS", "SUMMARY", "SYMBOLS", "DUMP", "RESOURCES",
  "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "ECHO", "ENABLE", "BFD", "MIN",
  "IDLE", "RX", "TX", "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR",
  "DEV", "LOCAL", "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS",
  "BABEL", "METRIC", "RXCOST", "HELLO", "UPDATE", "WIRED", "WIRELESS",
  "BUFFER", "PRIORITY", "CHECK", "LINK", "HOP", "BABEL_METRIC", "ENTRIES",
  "RANDOMIZE", "HOLD", "TIME", "CONNECT", "RETRY", "KEEPALIVE", "STARTUP",
  "VIA", "SELF", "DEFAULT", "PATH", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "BGP_LARGE_COMMUNITY", "ADDRESS", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "CAPABILITIES", "PREFER",
  "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH", "INTERPRET",
  "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY",
  "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC", "SECONDARY",
  "ALLOW", "PATHS", "AWARE", "EXTENDED", "SETKEY", "STRICT", "BIND",
  "CONFEDERATION", "MEMBER", "MULTICAST", "LIVED", "STALE", "IBGP", "EBGP",
  "CEASE", "HIT", "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION",
  "CHANGE", "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF",
  "MRT", "FILENAME", "PERIOD", "ALWAYS", "OSPF", "V2", "V3",
  "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "AREA",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT",
  "TRANSMIT", "DEAD", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "CRYPTOGRAPHIC",
  "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "MERGE", "LSA", "SUPPRESSION", "RFC5838", "PE", "TOPOLOGY",
  "STATE", "PERF", "EXP", "REPEAT", "THRESHOLD", "MODE", "PIPE", "RADV",
  "RA", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "NG", "INFINITY", "TIMEOUT",
  "GARBAGE", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO",
  "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "BLACKHOLE",
  "UNREACHABLE", "KERNEL", "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE",
  "KRT_MTU", "KRT_WINDOW", "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH",
  "KRT_CWND", "KRT_ADVMSS", "KRT_REORDERING", "KRT_HOPLIMIT",
  "KRT_INITCWND", "KRT_RTO_MIN", "KRT_INITRWND", "KRT_QUICKACK",
  "KRT_LOCK_MTU", "KRT_LOCK_WINDOW", "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR",
  "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND", "KRT_LOCK_ADVMSS",
  "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT", "KRT_LOCK_RTO_MIN",
  "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "SYSLOG", "TRACE", "INFO",
  "REMOTE", "WARNING", "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "NAME",
  "CONFIRM", "UNDO", "LATENCY", "WATCHDOG", "CONFIGURE", "DOWN", "PERSIST",
  "SCAN", "LEARN", "DEVICE", "KRT_SOURCE", "KRT_METRIC", "';'", "'('",
  "')'", "','", "'{'", "'}'", "':'", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "conf", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "pxlen4", "net_ip4_", "net_ip6_",
  "net_ip6_sadr_", "net_vpn4_", "net_vpn6_", "net_roa4_", "net_roa6_",
  "net_mpls_", "net_ip_", "net_vpn_", "net_roa_", "net_", "net_ip6",
  "net_ip", "net_any", "net_or_ipa", "label_stack_start", "label_stack",
  "time", "text", "opttext", "flow_num_op", "flow_logic_op",
  "flow_num_type_", "flow_num_type", "flow_flag_type", "flow_frag_type",
  "flow_label_type", "flow_srcdst", "flow_num_opts",
  "flow_num_opt_ext_expr", "flow_num_opt_ext", "flow_bmk_opts", "flow_neg",
  "flow_frag_val", "flow_frag_opts", "flow4_item", "flow6_item",
  "flow4_opts", "flow6_opts", "flow_builder_init", "flow_builder_set_ipv4",
  "flow_builder_set_ipv6", "net_flow4_", "net_flow6_", "net_flow_",
  "filter_def", "$@1", "filter_eval", "custom_attr", "bt_test_suite",
  "type", "one_decl", "decls", "declsn", "filter_body", "filter",
  "where_filter", "function_params", "function_body", "function_def",
  "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom", "switch_atom",
  "cnum", "pair_item", "ec_kind", "ec_item", "lc_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix", "fprefix_set",
  "switch_body", "bgp_path_expr", "bgp_path", "bgp_path_tail", "constant",
  "constructor", "rtadot", "function_call", "symbol", "static_attr",
  "term", "break_command", "print_one", "print_list", "var_listn",
  "var_list", "cmd", "get_cf_position", "rtrid", "idval", "gr_opts",
  "net_type", "table_sorted", "table", "proto_start", "proto_name",
  "proto_item", "channel_start", "channel_item", "channel_opts",
  "channel_opt_list", "channel_end", "proto_channel", "rtable", "imexport",
  "limit_action", "limit_spec", "debug_default", "timeformat_which",
  "timeformat_spec", "timeformat_base", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_list_nopx", "iface_patt_init",
  "iface_patt", "tos", "proto", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cli_cmd", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "r_args_for",
  "r_args_for_val", "export_mode", "r_args_channel", "cmd_SHOW_SYMBOLS",
  "sym_args", "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2",
  "dynamic_attr", "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts",
  "bfd_proto", "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item",
  "bfd_auth_type", "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface",
  "bfd_multihop", "bfd_neigh_iface", "bfd_neigh_local",
  "bfd_neigh_multihop", "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS",
  "babel_proto_start", "babel_proto_item", "babel_proto_opts",
  "babel_proto", "babel_iface_start", "babel_iface_finish",
  "babel_iface_item", "babel_iface_opts", "babel_iface_opt_list",
  "babel_iface", "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "cmd_SHOW_BABEL_ROUTES", "bgp_proto_start",
  "bgp_loc_opts", "bgp_nbr_opts", "bgp_cease_mask", "bgp_cease_list",
  "bgp_cease_flag", "bgp_proto", "bgp_afi", "bgp_channel_start", "bgp_nh",
  "bgp_channel_item", "bgp_channel_opts", "bgp_channel_opt_list",
  "bgp_channel_end", "bgp_proto_channel", "mrt_proto_start",
  "mrt_proto_item", "mrt_proto_opts", "mrt_proto", "cmd_MRT_DUMP",
  "mrt_dump_args", "ospf_variant", "ospf_proto_start", "ospf_proto",
  "ospf_af_mc", "ospf_channel_start", "ospf_channel", "ospf_proto_item",
  "ospf_area_start", "ospf_area", "ospf_area_opts", "ospf_area_item",
  "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "perf_proto_start", "perf_proto", "perf_proto_item",
  "pipe_proto_start", "$@6", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@7", "$@8", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@9", "$@10", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_variant", "rip_proto_start", "rip_proto_item", "rip_proto_opts",
  "rip_proto", "rip_iface_start", "rip_iface_finish", "rip_iface_item",
  "rip_auth", "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_nexthop", "stat_nexthops",
  "stat_route0", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "kern_proto", "kern_sys_item",
  "log_begin", "log_config", "syslog_name", "log_limit", "log_file",
  "log_mask", "log_mask_list", "log_cat", "mrtdump_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_mp_limit", "kern_item",
  "kif_proto_start", "kif_proto", "kif_item", "kif_iface_start",
  "kif_iface_item", "kif_iface_opts", "kif_iface_opt_list", "kif_iface", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    61,    60,    62,   126,   278,    43,    45,
      42,    47,    37,    33,    46,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,   756,    59,    40,    41,    44,   123,   125,    58,
      63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   523,   524,   524,   525,   525,   526,   526,   527,   528,
     528,   528,   529,   529,   529,   530,   530,   530,   530,   530,
     530,   531,   531,   531,   532,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   542,   543,   543,   544,
     544,   545,   545,   545,   545,   545,   545,   546,   546,   547,
     547,   548,   548,   549,   549,   549,   549,   549,   550,   551,
     551,   552,   553,   553,   554,   554,   555,   555,   555,   555,
     555,   555,   555,   555,   556,   556,   557,   557,   557,   557,
     557,   557,   557,   557,   557,   558,   559,   560,   561,   562,
     562,   563,   563,   563,   563,   564,   564,   565,   565,   566,
     566,   566,   567,   567,   568,   568,   568,   568,   569,   569,
     569,   570,   570,   570,   570,   571,   571,   571,   571,   571,
     571,   572,   572,   573,   573,   574,   575,   576,   577,   578,
     579,   579,   526,   581,   580,   526,   582,   526,   583,   526,
     584,   585,   585,   585,   585,   585,   585,   585,   585,   585,
     585,   585,   585,   585,   585,   585,   585,   586,   587,   587,
     588,   588,   589,   590,   590,   591,   592,   592,   593,   526,
     595,   594,   596,   596,   597,   597,   598,   598,   599,   599,
     600,   600,   600,   600,   600,   600,   601,   601,   601,   601,
     602,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   604,   604,   604,   604,   605,   605,   605,   606,   606,
     606,   606,   606,   606,   606,   606,   607,   607,   607,   607,
     607,   608,   608,   608,   608,   608,   609,   609,   610,   610,
     611,   611,   611,   611,   612,   612,   613,   613,   613,   614,
     614,   615,   616,   616,   616,   616,   616,   616,   617,   617,
     617,   617,   617,   617,   617,   617,   617,   617,   618,   618,
     618,   618,   619,   620,   621,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   623,
     623,   624,   624,   624,   624,   624,   624,   625,   626,   626,
     626,   627,   627,   628,   628,   629,   629,   629,   629,   629,
     629,   629,   629,   629,   629,   629,   629,   629,   629,   629,
     629,   629,   630,   526,   631,   631,   632,   632,   632,   632,
     526,   633,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   526,   635,   635,   636,   526,   637,   637,   638,
     638,   638,   638,   639,   639,   639,   639,   639,   639,   639,
     640,   641,   641,   641,   641,   641,   641,   641,   641,   642,
     642,   643,   643,   644,   645,   646,   647,   647,   647,   647,
     648,   648,   648,   648,   648,   649,   649,   526,   650,   650,
     526,   651,   651,   651,   651,   652,   652,   652,   652,   652,
     652,   652,   652,   653,   654,   655,   655,   656,   656,   657,
     658,   658,   659,   660,   661,   662,   662,   663,   664,   665,
     665,   665,   665,   665,   666,   667,   668,   668,   668,   669,
     669,   670,   670,   670,   670,   670,   670,   671,   671,   671,
     672,   672,   673,   673,   674,   674,   675,   675,   676,   676,
     677,   678,   678,   678,   678,   678,   678,   678,   678,   678,
     679,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     680,   681,   680,   682,   680,   683,   680,   684,   685,   685,
     680,   686,   680,   687,   680,   688,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   689,   689,
     689,   689,   690,   690,   690,   690,   690,   690,   690,   690,
     691,   691,   691,   691,   692,   692,   692,   693,   693,   693,
     693,   693,   693,   693,   693,   693,   693,   693,   693,   693,
     693,   693,   693,   693,   693,   693,   693,   680,   694,   695,
     695,   695,   695,   695,   695,   695,   680,   696,   680,   697,
     680,   698,   680,   699,   680,   700,   680,   701,   680,   702,
     680,   703,   680,   704,   680,   705,   706,   706,   706,   707,
     707,   680,   708,   680,   709,   680,   710,   680,   711,   680,
     712,   680,   713,   680,   714,   680,   715,   680,   716,   717,
     717,   717,   718,   718,   718,   719,   663,   720,   721,   721,
     721,   721,   722,   722,   723,   724,   725,   726,   726,   726,
     726,   726,   726,   726,   726,   727,   727,   727,   727,   727,
     727,   728,   728,   729,   729,   730,   731,   732,   732,   732,
     733,   733,   734,   734,   735,   680,   736,   663,   737,   738,
     738,   738,   738,   739,   739,   740,   741,   742,   743,   743,
     743,   743,   743,   743,   743,   743,   743,   743,   743,   743,
     743,   743,   743,   744,   744,   745,   745,   746,   719,   680,
     747,   680,   748,   680,   749,   680,   750,   663,   751,   752,
     752,   752,   753,   753,   753,   754,   754,   755,   755,   756,
     756,   756,   756,   756,   756,   756,   756,   756,   757,   757,
     757,   757,   757,   757,   757,   757,   757,   757,   757,   757,
     757,   757,   757,   757,   757,   757,   757,   757,   757,   757,
     757,   757,   757,   757,   757,   757,   757,   757,   757,   757,
     757,   757,   757,   757,   757,   757,   757,   757,   757,   757,
     757,   757,   757,   757,   757,   757,   757,   757,   757,   757,
     757,   757,   757,   757,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   759,   760,   760,   760,
     761,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   761,   761,   761,   761,   761,   761,   762,
     762,   763,   763,   764,   765,   719,   719,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,   663,   766,   767,
     767,   767,   767,   767,   767,   767,   767,   768,   768,   769,
     680,   770,   771,   771,   771,   771,   771,   771,   663,   772,
     772,   772,   773,   774,   774,   775,   775,   776,   777,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   779,   780,   781,   781,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   783,   782,   784,   782,   782,   782,
     782,   785,   785,   786,   787,   787,   788,   788,   788,   789,
     789,   790,   790,   791,   791,   791,   791,   791,   791,   791,
     791,   791,   791,   791,   792,   793,   793,   793,   793,   793,
     793,   793,   793,   793,   793,   793,   793,   793,   793,   793,
     793,   793,   793,   793,   793,   793,   793,   793,   793,   793,
     793,   793,   793,   793,   793,   793,   793,   793,   793,   793,
     793,   793,   793,   794,   794,   795,   796,   797,   797,   797,
     798,   798,   799,   799,   800,   801,   802,   802,   804,   803,
     805,   805,   806,   806,   807,   719,   719,   719,   719,   680,
     808,   680,   809,   680,   810,   680,   811,   680,   812,   680,
     813,   680,   814,   680,   815,   816,   816,   816,   816,   816,
     816,   816,   816,   816,   663,   817,   818,   818,   818,   819,
     819,   819,   819,   819,   819,   819,   819,   819,   663,   821,
     820,   822,   822,   822,   822,   663,   823,   824,   824,   824,
     824,   825,   824,   826,   824,   824,   824,   827,   827,   828,
     829,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   831,   830,   832,
     830,   830,   830,   833,   833,   833,   834,   835,   835,   836,
     836,   837,   838,   839,   839,   839,   839,   839,   840,   841,
     841,   842,   842,   843,   844,   845,   846,   846,   846,   847,
     848,   848,   849,   849,   850,   851,   852,   852,   852,   853,
     854,   854,   855,   855,   856,   856,   857,   857,   719,   719,
     663,   858,   858,   859,   860,   860,   860,   860,   860,   860,
     861,   861,   862,   863,   864,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     866,   866,   866,   866,   867,   867,   868,   868,   869,   719,
     719,   680,   870,   680,   871,   663,   872,   873,   873,   873,
     873,   873,   873,   874,   874,   874,   874,   874,   874,   875,
     875,   876,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   878,   879,   879,   880,   880,   680,   881,   882,   883,
     883,   719,   719,   719,   719,   719,   719,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,   719,   719,   526,
     884,   885,   886,   886,   887,   887,   888,   888,   888,   889,
     889,   890,   890,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   526,   892,   892,   526,   893,   893,   893,   893,
     680,   894,   680,   895,   680,   896,   680,   897,   680,   898,
     680,   899,   900,   900,   901,   901,   901,   663,   902,   882,
     882,   903,   903,   904,   904,   904,   904,   904,   904,   904,
     663,   905,   906,   906,   907,   907,   907,   908,   909,   910,
     910,   911,   911,   912,   719,   719
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     1,     5,     1,
       3,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     0,     2,     2,     2,     3,     7,
       2,     2,     5,     5,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     2,     2,     1,     1,     1,     2,     1,     1,     1,
       1,     2,     4,     1,     3,     1,     3,     1,     3,     4,
       6,     6,     0,     1,     1,     1,     1,     1,     2,     4,
       4,     2,     2,     2,     2,     2,     4,     2,     2,     2,
       2,     0,     3,     0,     3,     0,     0,     0,     6,     6,
       1,     1,     1,     0,     4,     1,     2,     1,     4,     1,
       6,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     0,     3,
       1,     3,     1,     1,     1,     2,     3,     2,     4,     1,
       0,     5,     0,     1,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     3,     1,     1,
       1,     5,     7,     5,     7,     9,     7,     5,     7,     5,
      11,     1,     1,     2,     1,     7,     9,     7,     7,     9,
       7,     9,     7,     9,     7,    15,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     3,     1,     3,     1,     3,
       1,     2,     2,     6,     1,     3,     0,     4,     3,     1,
       3,     3,     2,     4,     2,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     1,     5,     7,
       7,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       4,     1,     1,     1,     1,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     6,     3,     3,     3,     3,
       3,     5,     7,     6,     6,     6,     6,     4,     8,     4,
       4,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     1,     3,     0,     1,     4,     6,     4,     3,     5,
       5,     4,     6,     3,     2,     5,     5,     8,     8,     8,
       8,     7,     0,     1,     4,     5,     1,     3,     1,     1,
       1,     5,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     4,     1,     1,     1,     0,
       1,     2,     3,     0,     2,     2,     2,     3,     2,     2,
       1,     2,     2,     2,     3,     3,     3,     2,     4,     0,
       3,     0,     3,     0,     3,     1,     2,     1,     1,     1,
       0,     2,     2,     2,     2,     2,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     2,     4,     3,     4,     4,
       3,     4,     4,     3,     0,     1,     2,     0,     1,     3,
       1,     3,     1,     0,     2,     2,     2,     2,     2,     3,
       3,     3,     3,     5,     0,     3,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     1,     1,     4,     1,     0,     3,     4,     1,
       2,     0,     5,     5,     5,     5,     4,     4,     4,     4,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       1,     3,     1,     3,     1,     4,     1,     5,     1,     0,
       1,     3,     1,     4,     1,     4,     0,     2,     3,     3,
       3,     6,     3,     2,     2,     2,     2,     3,     5,     3,
       2,     2,     1,     1,     1,     1,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     0,
       2,     2,     2,     2,     2,     2,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     4,     1,     1,     3,     0,
       1,     1,     4,     1,     4,     1,     4,     1,     3,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     2,     1,
       1,     1,     1,     0,     1,     1,     1,     2,     1,     2,
       2,     2,     0,     3,     5,     0,     0,     2,     4,     4,
       4,     2,     2,     2,     1,     1,     1,     2,     2,     3,
       3,     0,     3,     0,     3,     4,     3,     0,     2,     2,
       0,     2,     0,     2,     4,     1,     5,     1,     2,     1,
       1,     2,     4,     0,     3,     5,     0,     0,     0,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     2,     3,
       3,     4,     4,     0,     3,     0,     3,     4,     1,     1,
       6,     1,     6,     1,     6,     1,     6,     2,     2,     0,
       3,     3,     0,     3,     3,     1,     3,     1,     3,     1,
       3,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     4,     6,     4,     6,     4,     6,     5,     5,     4,
       5,     5,     6,     3,     3,     4,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     6,     6,     6,     5,     6,
       8,     6,     6,     6,     5,     6,     4,     4,     4,     4,
       5,     5,     6,     5,     5,     5,     6,     7,     7,     7,
       5,     5,     4,     4,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     3,     3,     3,     2,     2,     2,
       3,     5,     5,     4,     3,     3,     3,     3,     3,     0,
       3,     0,     3,     0,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     2,     2,     1,     2,     2,     4,     0,     3,     5,
       1,     4,     0,     3,     3,     3,     2,     3,     2,     1,
       2,     2,     2,     3,     3,     0,     1,     2,     3,     1,
       1,     2,     2,     3,     3,     2,     4,     3,     2,     3,
       1,     2,     4,     0,     3,     2,     1,     2,     3,     3,
       3,     3,     2,     3,     0,     5,     0,     5,     2,     2,
       1,     4,     1,     1,     0,     3,     2,     2,     2,     5,
       2,     0,     3,     0,     2,     2,     3,     2,     2,     3,
       2,     2,     2,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     2,     3,     2,     3,     3,     4,     4,
       2,     2,     2,     3,     3,     3,     2,     3,     3,     3,
       4,     2,     1,     0,     2,     3,     1,     0,     1,     2,
       0,     2,     0,     1,     3,     0,     0,     2,     0,     3,
       0,     3,     0,     3,     3,     1,     1,     1,     1,     1,
       4,     1,     6,     1,     6,     1,     6,     1,     7,     1,
       6,     1,     7,     1,     5,     0,     2,     3,     2,     3,
       3,     2,     3,     2,     2,     2,     3,     3,     3,     1,
       3,     3,     2,     3,     3,     2,     2,     2,     2,     0,
       4,     2,     3,     3,     5,     1,     2,     1,     1,     2,
       2,     0,     3,     0,     3,     2,     3,     0,     3,     5,
       0,     4,     4,     3,     2,     3,     3,     3,     3,     4,
       4,     4,     3,     3,     4,     4,     2,     0,     3,     0,
       3,     3,     3,     1,     1,     1,     0,     0,     3,     0,
       3,     4,     1,     2,     2,     2,     4,     4,     0,     0,
       3,     0,     3,     3,     1,     0,     0,     2,     2,     0,
       0,     3,     1,     5,     1,     0,     0,     2,     2,     0,
       0,     3,     1,     5,     1,     2,     0,     2,     1,     1,
       1,     1,     2,     2,     1,     1,     2,     4,     2,     2,
       0,     3,     5,     0,     0,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     4,     3,     2,     2,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     4,     1,
       1,     1,     6,     1,     6,     2,     2,     3,     3,     3,
       5,     5,     4,     3,     2,     3,     3,     3,     3,     1,
       2,     2,     2,     3,     5,     1,     2,     2,     2,     2,
       2,     1,     0,     2,     0,     3,     1,     4,     3,     3,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     5,     2,     0,     0,     2,     2,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     3,     1,     3,     4,     3,     3,
       1,     4,     1,     5,     1,     3,     1,     3,     1,     4,
       1,     2,     0,     1,     0,     1,     2,     2,     2,     3,
       3,     0,     2,     1,     1,     2,     3,     2,     3,     4,
       2,     2,     3,     3,     1,     2,     3,     0,     2,     0,
       3,     0,     3,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,   262,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1282,     0,     3,   500,
     502,   504,   506,   510,   512,   514,   567,   576,   578,   580,
     582,   584,   586,   588,   590,   592,   594,   601,   603,   605,
     607,   609,   611,   613,   615,   617,   665,   699,   701,   703,
     705,   850,   989,   991,   993,   995,   997,   999,  1001,  1003,
    1171,  1173,  1206,  1270,  1272,  1274,  1276,  1278,  1280,     1,
       2,     0,   371,   369,   370,     0,     0,   262,     0,     0,
       0,   377,   378,     0,   362,   363,   365,   366,   367,   368,
       0,     0,  1240,     0,     0,     6,     5,     7,   132,   135,
     137,   139,   169,   353,   360,     0,   372,     0,   417,   420,
     376,   379,   383,   379,   626,   379,   667,   379,   383,   379,
     837,   379,   383,   379,   383,     0,   383,   379,  1035,   379,
    1120,   379,   383,   383,  1239,  1262,  1265,   379,   379,   383,
     247,   248,   257,   178,   179,   253,   264,   251,     0,     0,
     262,     0,     0,     0,   249,   250,   294,     0,     0,     0,
       0,     0,     0,     0,   262,     0,    35,    36,    45,    37,
      38,    39,    40,    46,    41,    42,    43,   254,   130,   131,
      44,   252,   261,   292,   293,     0,   291,     0,   619,   621,
     620,     0,    65,    65,     0,     0,     0,     0,   618,   623,
       0,     0,   516,     0,   569,     0,     0,   509,     0,   509,
       0,     0,     0,     0,     0,     0,     0,     0,   597,   596,
       0,   599,    65,   852,  1283,  1282,  1282,     0,     0,  1284,
    1281,     0,   170,   133,   136,   141,   142,   143,   145,   144,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
       0,     0,     0,     0,     0,    20,   364,    63,    62,     0,
       0,   422,   421,   423,   424,     0,     0,     0,     0,     0,
       0,     0,   448,   708,   627,   668,   838,   859,  1015,  1029,
    1036,  1121,  1176,  1288,  1301,   862,  1123,   380,     0,     0,
       0,    20,     0,   454,     0,     0,     0,     0,   447,   390,
       0,   401,     0,     0,     0,     0,     0,   794,   795,     0,
       0,     0,     0,   784,   785,     0,     0,     0,     0,    20,
       0,     0,     0,    20,     0,   712,   709,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,   707,     0,
     796,   821,     0,     0,     0,     0,     0,    20,     0,     0,
      20,     0,     0,    20,   858,   865,   869,   401,   870,     0,
       0,   880,     0,    20,     0,     0,     0,     0,  1014,     0,
    1019,     0,  1031,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,  1175,     0,
       0,  1195,  1204,     0,     0,     0,     0,    20,     0,    20,
    1287,  1293,  1294,     0,     0,     0,     0,  1307,     0,  1300,
    1304,     0,   247,   264,   247,   262,   247,   247,     0,   239,
       0,    27,     0,     0,     0,    30,    31,   262,     0,     0,
       0,   289,    34,   125,   125,     0,   262,   262,   262,   262,
     262,   262,   201,   202,     0,   204,     0,     0,   180,   183,
     179,   182,   185,   262,    35,    36,   230,   181,   219,   216,
     217,   218,   226,     0,   234,     0,     0,     0,   265,   268,
     266,   267,   269,   270,   271,   272,   273,   625,   698,   826,
     829,   828,   825,   827,   830,   831,   832,   835,   836,   833,
     834,   985,   986,   987,   988,  1118,  1119,  1169,  1170,  1211,
    1212,  1213,  1214,  1215,  1216,  1217,  1218,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1314,  1315,   295,
     296,   593,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,     0,   457,   456,     0,
       0,    64,     0,     0,     0,     0,   608,   468,   467,     0,
       0,   622,   624,   623,     0,   511,     0,   503,     0,   501,
       0,   509,   509,   509,   509,   509,   508,   509,   509,  1005,
     509,   509,     0,   509,   509,     0,   589,   581,   591,   583,
     577,   579,   585,   587,  1258,  1253,  1254,  1255,  1256,  1257,
    1259,  1260,  1261,     0,  1251,   600,     0,     0,     0,     0,
    1284,  1275,  1277,  1285,     0,   262,     0,   158,     0,   156,
       0,   356,   358,   359,   443,   262,     0,   418,     9,    11,
     262,   419,    16,    18,    17,    19,     0,    15,  1266,     0,
    1264,   425,     0,   433,  1243,  1248,  1244,     0,     0,     0,
    1269,  1268,   373,   860,   861,   379,  1122,     0,   381,   449,
       0,   384,   385,   434,   389,   388,   386,    20,   450,   399,
     403,   451,   452,   632,   673,   728,     0,     0,     0,   743,
       0,   788,   786,   789,   787,   790,   792,   791,   793,     0,
       0,     0,     0,    20,     0,    20,     0,     0,     0,   744,
       0,    21,    22,    23,    24,     0,    24,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    20,     0,    20,     0,
      20,     0,    20,    20,    20,    20,    20,    20,     0,    20,
       0,    20,    20,     0,   729,   819,   823,   730,   847,   863,
      20,   881,   871,    20,   878,   875,     0,    20,   872,   866,
     867,   403,   864,   883,  1016,  1025,     0,     0,  1022,     0,
       0,  1026,  1027,  1018,  1017,   397,   158,   262,   408,   409,
       0,     0,   407,   392,     0,   393,   405,   391,     0,     0,
    1032,  1033,  1047,  1130,  1177,     0,     0,    52,    51,  1191,
      20,     0,  1178,  1179,  1197,     0,  1196,     0,  1200,  1198,
    1199,  1189,  1192,  1202,     0,    20,  1210,    20,     0,  1295,
       0,  1297,  1208,  1290,  1289,  1302,   434,  1305,     0,  1303,
       0,   242,   244,     0,   245,   246,   241,    26,    28,     0,
     331,   334,     0,   309,     0,     0,   310,   126,   127,     0,
       0,     0,     0,     0,     0,     0,   203,   262,   274,   262,
       0,     0,     0,   190,   231,   232,     0,     0,     0,   255,
       0,   256,     0,     0,   286,   284,   282,   279,   280,   281,
     283,   285,   287,   288,   275,   276,   277,   278,   304,   298,
     299,   300,     0,   303,   297,   301,   302,   306,   307,   308,
     461,   462,   463,   465,   466,   464,     0,   459,   614,   606,
     602,   610,   612,   472,   473,     0,   470,   616,     0,   505,
     513,   515,   158,     0,   524,     0,   545,     0,   526,   525,
     530,   531,     0,   544,   546,   517,   523,     0,   568,   575,
     571,   572,   573,   574,   570,     0,    65,    65,    65,    65,
      65,    65,     0,   509,    65,   509,    65,   990,    65,    65,
    1207,     0,   598,   595,   604,   851,   158,     0,     0,   856,
    1279,     0,  1286,  1271,     0,     0,   158,     0,     0,     0,
     134,   162,   138,     0,   434,     0,     0,   354,     0,  1267,
    1263,     0,   427,   430,     0,  1247,     0,  1246,  1249,     0,
       0,     0,    12,    13,    14,   374,   375,  1030,   382,   387,
     437,   440,   455,     0,     0,   404,   383,   383,     0,     0,
       0,   735,    20,    20,   767,   769,     0,     0,     0,     0,
       0,    20,     0,    20,   783,   782,   745,     0,   712,     0,
       0,   733,   709,     0,     0,   731,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   766,
       0,     0,     0,     0,     0,     0,     0,     0,   768,     0,
       0,   739,     0,   824,   383,   873,   874,     0,   879,   877,
     868,     0,  1020,  1021,  1024,  1023,   163,   164,   406,   165,
     416,   410,   395,    20,   396,   394,     0,   383,   383,     0,
       0,  1184,    24,  1193,     0,    20,     0,    20,  1190,   262,
    1182,  1298,  1291,  1209,  1296,   442,  1311,  1306,   247,   240,
       0,    28,   262,   320,     0,     0,   121,   123,   317,   262,
     290,   262,   262,   262,   262,   319,     0,     0,   262,   262,
     262,   262,   184,     0,   178,   179,   262,   220,   227,   235,
       0,     0,   262,     0,   458,     0,   469,   507,   522,   529,
       0,   519,   520,   542,   543,     0,   539,   540,   541,   535,
     533,   534,   518,   532,   527,   666,     0,     0,     0,     0,
       0,     0,  1004,  1013,     0,     0,  1008,  1011,     0,  1006,
       0,    65,     0,    65,     0,     0,     0,  1252,   855,   854,
     853,   857,  1273,     8,   167,   160,     0,   171,   157,   158,
     262,     0,   444,   355,   357,    10,   426,   428,   429,   431,
     432,  1242,  1245,     0,  1241,   361,   438,    65,   434,   453,
     402,     0,   635,   635,     0,   634,   628,     0,   676,     0,
     675,   669,   670,     0,     0,     0,   754,     0,     0,   715,
       0,    20,     0,     0,   775,   774,     0,   764,     0,    25,
       0,   713,   714,     0,   710,   711,   781,   741,     0,     0,
     758,     0,   753,   752,   747,     0,   737,     0,   738,   750,
     770,   749,   748,   780,   751,   771,     0,   773,   746,   740,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
     822,   800,     0,   158,     0,     0,     0,     0,   849,   843,
     839,     0,   876,   975,    20,     0,    20,   894,     0,     0,
     896,   886,    20,   882,     0,   900,   976,     0,   415,   398,
    1034,     0,  1050,  1041,  1043,     0,     0,  1049,  1037,  1038,
       0,  1133,    20,     0,  1132,  1124,  1125,     0,  1180,  1181,
    1183,     0,    58,    59,  1185,  1188,  1187,  1186,     0,   325,
     326,     0,   262,   322,   323,   324,   321,   262,   262,     0,
       0,  1205,     0,     0,   262,  1201,  1203,     0,  1299,  1309,
    1313,   243,     0,   332,     0,   311,     0,     0,     0,     0,
       0,     0,     0,   262,   258,   262,     0,     0,   190,     0,
       0,     0,     0,     0,     0,    32,    33,     0,   460,   471,
       0,     0,   536,   537,     0,   706,   700,   702,   704,   994,
     992,  1009,  1012,  1007,  1010,     0,   996,     0,  1000,  1172,
    1174,     0,   166,   159,     0,   262,   174,   140,  1250,   435,
       0,   439,   441,   400,   434,   629,   653,   630,   657,   631,
     633,   434,   671,     0,   674,     0,   759,   761,     0,     0,
     719,     0,     0,     0,     0,     0,   717,   762,     0,     0,
       0,   776,   763,   765,   734,   732,   757,   756,   742,   755,
     736,   772,     0,    20,    20,     0,    20,     0,     0,   807,
     808,   809,     0,   820,   842,   841,   840,   844,   845,     0,
     848,   434,   899,   887,     0,     0,    20,     0,   885,     0,
       0,    50,    49,   903,   898,   902,     0,     0,   892,   884,
       0,   910,   411,   412,   413,   414,    48,    47,  1082,  1091,
    1040,   434,  1039,     0,     0,  1045,    20,  1048,   434,  1129,
    1126,  1128,  1131,  1194,     0,   262,   262,   262,     0,     0,
       0,   262,   352,     0,     0,   344,   327,   329,     0,  1292,
       0,     0,     0,    78,    89,    90,    76,     0,    79,    80,
       0,     0,    83,    84,    87,   128,    85,     0,   102,   102,
       0,     0,    88,   129,     0,   102,   102,   102,     0,     0,
     262,   314,   315,   313,   316,     0,     0,   199,     0,   262,
     197,   262,   193,     0,   262,   191,   262,   262,     0,   305,
       0,   538,   564,   562,   563,   547,   550,   554,   557,   560,
     561,   548,   549,   551,   552,   553,   555,   556,   558,   559,
     565,   566,   528,   998,  1002,   161,   168,   175,    55,    56,
      57,    53,    54,   436,   653,   651,   636,     0,     0,   660,
     695,    20,     0,     0,     0,   723,   721,   722,   725,   724,
     726,     0,   716,   778,   777,   779,    20,    20,     0,   814,
     815,   816,   817,     0,     0,   810,   804,   805,   806,   818,
      20,    20,   978,   982,   889,   890,   888,   891,   963,   924,
     904,   963,   893,   977,   911,  1089,  1088,  1079,  1095,  1094,
    1102,  1042,  1104,  1105,  1112,  1044,  1046,  1166,     0,    60,
       0,     0,     0,   338,   262,   236,     0,   262,   262,   262,
       0,   262,   343,     0,  1312,     0,    29,   312,    77,    81,
      82,    86,    72,    70,    68,    67,    69,    71,    66,    73,
      95,     0,   112,    97,    93,   103,   113,     0,     0,   114,
     111,   122,   117,   118,   119,   120,   115,   124,     0,   259,
     260,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   233,   521,   636,     0,   656,   658,   659,     0,
     662,   693,   677,   672,   760,   720,   727,   718,   798,   799,
     797,   803,   802,   801,    20,     0,   813,   846,   976,   980,
     984,     0,     0,     0,   913,     0,  1093,  1077,  1076,  1100,
    1110,  1164,  1134,  1127,   337,   263,     0,   262,   335,   176,
       0,   341,   352,     0,     0,     0,     0,     0,     0,     0,
     330,  1308,  1310,     0,    91,    75,    74,     0,     0,    74,
     102,   102,     0,   104,   105,   106,   107,   108,   102,   102,
       0,   318,   214,   198,   196,     0,   262,   194,   212,   192,
       0,   262,   210,   262,   208,   207,   262,   205,   655,     0,
      20,     0,     0,     0,     0,     0,     0,   654,   644,   475,
     479,     0,   661,    20,   664,   678,   697,   811,   812,   979,
       0,   895,   966,   964,   967,    20,     0,    20,   901,     0,
     897,     0,     0,     0,     0,     0,     0,   909,   923,     0,
       0,     0,    20,    20,    20,  1092,     0,     0,  1081,  1096,
    1106,     0,  1168,     0,     0,   262,   262,   186,   189,   262,
     345,   188,   224,   221,   222,   223,   228,     0,     0,   340,
     339,   262,   262,   262,   346,   262,    96,    94,     0,    98,
       0,     0,     0,     0,     0,   116,     0,     0,     0,     0,
       0,     0,     0,   480,   642,   476,     0,     0,     0,   637,
     641,   645,     0,   646,     0,   643,   481,   652,   663,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   696,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
       0,     0,     0,   983,   962,     0,   968,     0,     0,   907,
     908,   906,   905,   917,   920,   921,   922,   914,   915,     0,
       0,   918,   912,     0,     0,  1083,  1084,  1085,  1090,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
    1067,  1069,  1080,     0,     0,     0,  1099,     0,     0,     0,
    1109,     0,     0,    20,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1167,  1159,     0,   342,   177,   336,   238,   190,     0,     0,
     262,     0,     0,     0,     0,     0,    92,     0,     0,    99,
     110,   109,   213,   195,   211,   262,   209,   262,   206,     0,
       0,     0,     0,     0,   647,   648,     0,     0,     0,     0,
       0,     0,     0,     0,   679,     0,   682,   683,   681,     0,
       0,     0,     0,     0,   688,   680,     0,     0,    20,   694,
     932,   933,   934,   935,   936,   937,   938,   939,   929,   970,
     961,     0,     0,     0,   956,   950,   951,   952,   926,   943,
      20,     0,    20,    20,   945,   925,   928,     0,     0,   930,
      20,   927,     0,    20,   981,   969,   965,   916,   919,  1116,
    1116,     0,  1066,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1054,    20,     0,     0,     0,    20,     0,    20,
       0,  1078,     0,  1114,  1098,  1097,  1103,  1101,  1108,  1107,
    1113,  1111,  1140,  1138,  1157,     0,     0,     0,  1152,  1160,
    1163,  1162,  1161,  1158,  1135,     0,    20,    20,  1139,    20,
       0,  1136,  1137,     0,     0,    20,  1141,    20,    20,  1165,
     187,   262,   225,   229,   237,   351,     0,     0,     0,     0,
       0,     0,     0,     0,   474,   476,   638,   639,   640,   649,
     650,    61,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   478,     0,     0,   686,   687,   446,   445,   689,
     684,   685,   690,     0,   954,   953,   955,   958,   957,   946,
      20,     0,   959,   944,   942,   931,   941,   947,   940,    20,
    1086,  1087,     0,  1073,  1074,  1075,  1063,     0,  1116,     0,
    1053,     0,  1056,  1062,  1116,  1055,  1057,  1058,     0,  1071,
    1068,  1072,  1070,  1115,  1150,  1151,  1153,  1146,  1156,  1145,
       0,  1154,  1149,  1147,  1148,  1142,  1143,  1144,     0,   348,
     349,   347,   350,   101,   100,   200,   262,   477,   481,     0,
       0,   481,   481,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   481,     0,     0,   691,   692,   949,   972,
     971,   948,   960,  1117,  1064,  1065,  1061,  1052,  1051,  1060,
    1059,  1155,     0,   486,   481,   481,   488,   487,   489,   481,
     481,   973,     0,   262,   484,   485,   482,   483,   974,     0,
     215
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    96,    97,   647,   660,  1790,  1699,  1038,
     431,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,  1528,  1892,   799,  1643,  1353,  1354,  2262,
     260,   562,  1741,  1841,  1576,  1577,  1578,  1579,  1587,  1580,
    1742,  1743,  1744,  1746,  1747,  1847,  1749,  1581,  1589,  1386,
    1387,   847,  1126,  1127,   178,   179,   180,    98,   627,    99,
     100,   101,   977,   978,   979,  1206,  1087,  1088,   782,   976,
     981,   102,   626,  1434,  1435,  1818,   181,   468,  1932,   861,
     469,   862,   470,   471,   472,  1936,   473,  1937,   474,   475,
    1820,   427,   182,   428,   183,   184,   185,  1373,   186,   539,
    1398,  1374,  1557,  1558,   841,   842,  1436,  1717,   103,   636,
     104,   299,  1006,   106,   107,   289,   300,   301,   391,  1014,
     680,  1015,   302,   787,   783,  1328,  1092,   108,   265,   266,
     109,  1010,  1441,  1227,  1011,  1115,  1116,   984,   985,  2134,
     110,   111,   112,   673,   303,   560,   906,   907,   570,   915,
     916,  1878,  2109,  1879,  1880,  2123,  2269,    18,    19,    20,
      21,    22,   592,    23,    24,    25,   578,  1172,  1173,   937,
    1632,    26,   580,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,   221,   616,    37,    38,    39,    40,    41,
      42,    43,    44,    45,   191,   574,   540,   113,  1237,  1016,
     114,  1444,  1776,  1881,  1975,  1775,  1646,  1445,  1447,  1649,
    1780,  1884,  1449,    46,   115,  1243,  1017,   116,  1451,  1886,
    1990,  1885,  1782,  1452,    47,    48,    49,    50,   117,   717,
     715,  1250,  1465,  1466,   118,   350,   351,  1791,  1302,  1072,
     746,  1073,   352,   119,  1311,  1074,   120,    51,   618,   285,
     121,   122,   760,   367,   368,   369,   370,   371,  1081,  1324,
    1509,  1516,  1514,  1515,  1802,  1899,  1325,  1804,  1909,  1326,
    2015,  1801,  1893,  1894,  2018,  2283,  2392,  2370,  1501,  1521,
    1683,  1798,  1890,  1800,  1502,    52,    53,    54,    55,    56,
      57,    58,    59,   952,   123,   124,   381,   125,   665,   126,
     127,  1340,  1533,  1534,  1097,   128,  1531,  2053,  2198,  2200,
    2306,  1918,  1917,  1808,  1532,  1529,  1916,  1806,  1805,  1696,
    1530,  1700,  1809,  2057,  2206,  1919,  1701,  1704,  1810,  2061,
    2210,  1920,  1705,  2204,  2300,   286,   129,  1347,  1098,   130,
    1538,  1922,  2082,  2223,  1921,  1812,  1539,    60,    61,   131,
     132,   811,   812,   401,   402,  1376,  1109,   814,    62,   133,
     413,   267,   134,   995,   997,   657,  1000,   613,   614,   135,
     136,    63,    64,    65,    66,    67,    68,   229,   624,   137,
    1378,   414,   138,   139,   421,   826,  1725,  1560,  1380,   827
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1887
static const yytype_int16 yypact[] =
{
     112,  2011,    56,   166,  2406,   645,   645,   645,   852,   645,
     278,  3465,  1346,    -1,   645,   109,    19,   394, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887,   398, -1887, -1887, -1887,   442,   476,  2406,  4126,    39,
     458, -1887, -1887,    -2, -1887,   431, -1887, -1887, -1887, -1887,
     478,   796, -1887,   459,   150, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,   487, -1887,  3277, -1887, -1887,
   -1887,   327,  3426,   327, -1887,   327, -1887,   327,  3530,   327,
   -1887,   327,  3057,   327,  3187,   171,  1180,   327, -1887,   327,
   -1887,   327,  3240,  3034, -1887, -1887, -1887,   327,   327,  1687,
     127, -1887, -1887,   624,   627,   813,   196, -1887,   602,   480,
    2406,   707,   224,   259, -1887, -1887, -1887,   272,   298,   342,
     346,   361,   364,   377,  1212,   223,   600,   703, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,  3603, -1887,  4170, -1887, -1887,
   -1887,     0,   878,   878,   645,   645,   838,   108, -1887,   683,
      78,   937, -1887,   957, -1887,   697,   601,   667,    60,   958,
     978,  1008,  1020,  1024,  1048,  1051,  1063,  1068, -1887, -1887,
     568,  1075,   878, -1887, -1887,  1062,  1062,  1096,  1101,   666,
   -1887,  1120, -1887, -1887,  4238, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
     470,  1099,   187,     0,   445,   276, -1887, -1887, -1887,   108,
     640, -1887, -1887, -1887, -1887,   213,   651,   429,   960,   445,
     445,  1166, -1887, -1887, -1887, -1887, -1887,   497, -1887, -1887,
   -1887,   746, -1887, -1887, -1887, -1887, -1887,  1147,  1189,   700,
    1100,   946,     0, -1887,   866,   866,   108,   947, -1887, -1887,
     734,   747,   763,   777,   775,   786,   790, -1887, -1887,   384,
     984,   785,  1289,    24,    76,    91,   135,  1032,   866,   946,
     991,  1162,   595,   448,    89,   950,   950,  1071,  1084,   482,
    1086,  1093,   719,  1089,  1098,   731,  1073,   946,  1079,  1064,
    1135,  1140,  1103,  1107,   426,   946,  1110,   120, -1887,   929,
   -1887,   932,   949,   959,   965,  1070,   178,   946,  1326,   445,
     946,  1354,  1108,   946, -1887,  1170, -1887,   747, -1887,   992,
     989, -1887,   993,   946,   281,  1504,   309,   894, -1887,  1013,
   -1887,  1014, -1887,   445,  1312,  1248,  1517,  1375,  1389, -1887,
    1030,  1031,  1029,  1039,  1043,  1748,  1295,  1407, -1887,  1076,
    1078,   803,  1077,  1410,   445,  1264,  1442,   946,  1322,   946,
   -1887, -1887, -1887,  1085,  1087,  1088,  1091, -1887,  1328, -1887,
   -1887,  1097,    52, -1887,   127,  2406,   127,   127,  1588, -1887,
    1589, -1887,  1591,   624,  1581, -1887, -1887,   241,  1586,   665,
    1587,  1584, -1887, -1887, -1887,  1517,  2406,  2406,  2406,  2406,
    2406,  2406, -1887, -1887,  1600, -1887,  1105,   308, -1887, -1887,
    1581, -1887, -1887,   781, -1887, -1887,   155, -1887,  1630, -1887,
   -1887, -1887, -1887,   506, -1887,   528,  1604,  1623, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887,  2406,  2406,  2406,  2406,  2406,  2406,  2406,  2406,
    2406,  2406,  2406,  2406,  2406,  2406,  3898, -1887, -1887,  1399,
    1636, -1887,  1638,  1639,  1640,  1643, -1887, -1887, -1887,   381,
    1645, -1887, -1887,  1055,  1646, -1887,  1648, -1887,  4090, -1887,
    1168,   958,   958,   958,   958,   958, -1887,   958,   958, -1887,
     457,   484,  1650,   958,   958,  1653, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887,    95, -1887, -1887,  1654,  1655,   966,  1657,
     666, -1887, -1887,   445,  1662,  2406,  1153,  4126,  1167, -1887,
    1163, -1887, -1887, -1887, -1887,  2406,  1175, -1887, -1887, -1887,
    2406, -1887, -1887, -1887, -1887, -1887,   445, -1887, -1887,  1186,
   -1887,   445,   885, -1887,  1181, -1887,   445,   -69,   445,  1074,
   -1887, -1887,  1485, -1887, -1887,   327, -1887,  1666, -1887, -1887,
     178, -1887, -1887, -1887, -1887, -1887, -1887,   946, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887,  1428,  1431,   950, -1887,
    1198, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,   154,
    1199,  1203,   312,   185,  1395,   946,  1515,  1206,  1209, -1887,
    1217, -1887, -1887, -1887,  1693,    74,  1693,   139,   946,   445,
    1458,  1461,   445,  1462,   445,   445,   946,  1463,   946,  1598,
     946,  1226,   946,   946,   946,   946,   946,   946,  1521,   946,
    1229,   946,   946,  1230, -1887, -1887, -1887, -1887, -1887, -1887,
     946, -1887, -1887,   946, -1887,  1578,   445,   946, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887,  1731,  1733, -1887,   445,
     445, -1887, -1887, -1887, -1887, -1887,  3844,  2406, -1887, -1887,
     235,  1579, -1887, -1887,   235, -1887, -1887, -1887,   235,  1517,
   -1887, -1887, -1887, -1887, -1887,   627,   813, -1887, -1887, -1887,
     946,  1517, -1887, -1887, -1887,  1116, -1887,   950, -1887, -1887,
   -1887,   141,  1473, -1887,  1256,   946, -1887,   946,   445, -1887,
     445, -1887, -1887, -1887, -1887, -1887, -1887, -1887,   445, -1887,
    1739, -1887, -1887,  1505, -1887, -1887, -1887, -1887,  1710,  1756,
     552, -1887,  1257, -1887,  1644,  1744, -1887, -1887, -1887,   727,
    1964,   920,  1009,  1173,  1243,  2106, -1887,  2406, -1887,  2406,
    1268,    15,  1269,  2378, -1887, -1887,  1777,   260,   333, -1887,
     813, -1887,  1575,  1592,  3459,  3459,  3459,  4282,  4282,  3459,
    3459,  3459,  3459,  3459,   877,   877,  1584,  1584, -1887, -1887,
   -1887, -1887,  1284, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887,   182, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,   592, -1887, -1887,  1811, -1887,
   -1887, -1887,  3844,  1795, -1887,  1667, -1887,   486, -1887, -1887,
   -1887, -1887,  1104, -1887, -1887, -1887, -1887,  1799, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,  1818,   878,   878,   878,   878,
     878,   878,  1491,   958,   878,   958,   878, -1887,   878,   878,
   -1887,   568, -1887, -1887, -1887, -1887,  3844,  1258,   866, -1887,
   -1887,  1819, -1887, -1887,   964,  3029,  4126,   586,  1310,  1309,
   -1887, -1887, -1887,   866, -1887,  1314,  2432, -1887,  2473, -1887,
   -1887,  1821,  1241,  1245,   866, -1887,   866, -1887, -1887,   568,
    1319,  1330, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
    1810, -1887,  1333,  1337,   290, -1887,  1674,  3462,   445,   445,
    1340, -1887,   946,   179, -1887, -1887,  1685,  1583,   445,  1347,
    1348,   946,  1349,   946, -1887, -1887, -1887,  1843, -1887,   445,
     445, -1887, -1887,   445,   445, -1887,  1351,  1352,   445,   445,
    1355,   445,  1359,  1360,  1361,   445,  1362,   178,  1364, -1887,
    1367,  1368,  1372,  1377,  1391,  1392,   177,  1393, -1887,  1396,
    1397, -1887,  1239, -1887,  3151, -1887, -1887,   445, -1887, -1887,
   -1887,  3381, -1887, -1887, -1887, -1887, -1887, -1887, -1887,  4238,
   -1887,  1703, -1887,   946, -1887, -1887,  1400,  3114,  3320,  1403,
    1406, -1887,  1693,  1855,  1887,   946,   445,   946,   141,  1820,
   -1887, -1887,  1749, -1887, -1887,  1333,  1405, -1887,   127, -1887,
    1896, -1887,  2406, -1887,  1891,  1892, -1887, -1887, -1887,  2406,
   -1887,  2406,  2406,  2406,  2406, -1887,  1752,   401,  1387,  2406,
    1450,  2406, -1887,  1413, -1887, -1887,  2406, -1887, -1887, -1887,
    1915,  1916,  2406,  1399, -1887,   381, -1887, -1887, -1887, -1887,
    1912, -1887, -1887,   624,   462,  1279, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887,  1900, -1887,  1932,  1937,  1939,  1940,
    1941,  1942, -1887, -1887,  1921,   178, -1887, -1887,   178, -1887,
     178,   878,  1943,   878,  1944,  1945,  1948, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,  1439,  1441, -1887, -1887,  4126,
    2242,  1443,  1333, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887,   706, -1887, -1887, -1887,  1936, -1887, -1887,
   -1887,  1452, -1887, -1887,   950, -1887, -1887,  1453, -1887,  1816,
   -1887, -1887, -1887,  1454,  1447,  1456, -1887,  1457,   660, -1887,
    1464,   612,   445,  1470, -1887, -1887,  1471, -1887,  1483, -1887,
     148, -1887, -1887,   303, -1887, -1887, -1887, -1887,  1484,  1486,
   -1887,  1499, -1887, -1887, -1887,  1500, -1887,  1501, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887,  1502, -1887, -1887, -1887,
    1750,  1695,  1448,  1689,  1856,  1717,  1874,   163,   946,  1974,
   -1887, -1887,  1514,  3844,  1285,   866,   445,  1908, -1887, -1887,
   -1887,  1522, -1887, -1887,   946,   473,   578, -1887,  1763,  1148,
   -1887, -1887,   709, -1887,  1524, -1887,  1642,  1401, -1887, -1887,
   -1887,  1216, -1887, -1887, -1887,  1216,  1888, -1887, -1887, -1887,
    1529, -1887,   946,   445, -1887, -1887, -1887,  1532, -1887, -1887,
   -1887,  1887, -1887, -1887,  2016, -1887, -1887, -1887,    10, -1887,
   -1887,  1534,  2406, -1887, -1887, -1887, -1887,  2406,  2406,  2026,
    1536, -1887,  3603,  1547,  1607, -1887, -1887,   445, -1887, -1887,
   -1887, -1887,  2030, -1887,  2033, -1887,  1095,  1641,  1779,  2530,
    2584,  2629,  2656,  2406, -1887,  2406,   805,    20,  4238,  1551,
     820,    14,  1553,  2048,  2378, -1887, -1887,  2683, -1887, -1887,
    2036,  2053,   624,  1581,  4129, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,  2069, -1887,  2070, -1887, -1887,
   -1887,  4126, -1887, -1887,  1557,    77, -1887, -1887, -1887,  1155,
    1188, -1887, -1887, -1887, -1887, -1887,  1559, -1887,    33, -1887,
   -1887, -1887, -1887,  1938, -1887,   445, -1887, -1887,  1917,  1730,
   -1887,    35,  1737,  1741,   994,   732, -1887, -1887,  1572,  1573,
    1574, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887,   215,   229,   946,   339,   946,   512,  1517, -1887,
   -1887, -1887,  1823, -1887, -1887, -1887, -1887, -1887, -1887,  1807,
   -1887, -1887, -1887, -1887,   445,   445,   946,   445, -1887,  1585,
     178, -1887, -1887, -1887, -1887,  1594,  1595,   445, -1887, -1887,
     445,  1596, -1887, -1887, -1887, -1887, -1887, -1887, -1887,  1602,
   -1887, -1887, -1887,   159,     8, -1887,   946, -1887, -1887, -1887,
    1926, -1887, -1887,  2016,  2086,  2406,   241, -1887,  2952,  3401,
     103,  2406, -1887,  2080,   682, -1887,  4238,  1593,  1610, -1887,
    -215,  2089,  2079, -1887, -1887, -1887, -1887,  2073, -1887, -1887,
    1288,  2067, -1887, -1887, -1887, -1887, -1887,   834,  2105,  2105,
    1148,  1626, -1887, -1887,   834,  2105,  2105,  2105,  1216,  1628,
    2406, -1887, -1887, -1887, -1887,  2710,  2753, -1887,  2112,  2406,
   -1887,  2077, -1887,  2113,  2406,  2138,  2210,  2254,  1629, -1887,
    4129, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,   624,  1581,
   -1887, -1887, -1887, -1887,  1559, -1887, -1887,  2128,   866,  1897,
    1633,   946,  1649,  1814,  1919, -1887, -1887, -1887, -1887, -1887,
   -1887,   660, -1887, -1887, -1887, -1887,   350,   350,   950, -1887,
   -1887, -1887, -1887,  1986,  1884, -1887, -1887, -1887, -1887, -1887,
     946,   946,  1333,  1647, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887,  1651, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887,  1652,   445, -1887,
    2981,  1656,  3678, -1887,  1933, -1887,  3008,  2406,  2406,  2406,
    1010,  1607, -1887,   950, -1887,  1659, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
    2154,   445,  1339, -1887,  1658, -1887,    41,   445,  1612,    43,
   -1887, -1887,  1339,    41,    43,    41,  2094, -1887,  2780, -1887,
   -1887,  1660,  1665,   846,    40,  1668,   880,  1670,  1671,    50,
    1672,    54, -1887, -1887, -1887,  1041, -1887, -1887, -1887,   950,
    1924, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887,   946,   445, -1887, -1887,  1642, -1887,
   -1887,    81,    72,   105,   853,  1060, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887,  1673,  2242,  2068, -1887,
      71, -1887,  4238,  3038,  3066,  1675,  1679,  1680,  1669,  1682,
   -1887, -1887, -1887,   445, -1887, -1887,   445,  1404,   445, -1887,
    2105,  2105,  2135, -1887, -1887, -1887, -1887, -1887,  2105,  2105,
    2155, -1887, -1887, -1887, -1887,  2151,  2406, -1887, -1887, -1887,
    2170,  2406, -1887,  2406,  2178, -1887,  2406, -1887, -1887,   866,
     946,  1684,  1122,  1957,   445,   445,   792, -1887, -1887, -1887,
    1690,  1691, -1887,   946, -1887,  1192, -1887, -1887, -1887, -1887,
    3621, -1887, -1887, -1887,   571,   946,   445,   946, -1887,  1696,
   -1887,   445,    29,   445,   445,  1923,   267, -1887, -1887,  1698,
    1785,  1789,   946,   946,   946, -1887,  1704,  2943, -1887,   407,
     391,  2887, -1887,  1705,  1701,  1933,    90, -1887, -1887,   781,
   -1887, -1887,  2213, -1887, -1887, -1887, -1887,   244,  1706, -1887,
   -1887,  2406,  2406,  2406, -1887,  2406, -1887,  1658,   445, -1887,
     445,   445,   445,  1612,  1612, -1887,  1709,  1718,  1719,  1716,
    1721,  1727,  1729, -1887, -1887,  2074,  2001,  2003,  2006, -1887,
   -1887, -1887,  1228, -1887,  2075, -1887,  1200, -1887, -1887,   445,
    1988,  1156,   445,  1995,   329,   445,  2013,  2014,  1996, -1887,
    1764,  1683,   445,  1759,   946,  2015,   453,   258,   445,   445,
    2018,  1877,  1960,  1910,   946,   445,   445,  2005,   400,  1890,
     445,  1895,  1922, -1887, -1887,  1780, -1887,   445,  1781, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,   445,
     445, -1887, -1887,   445,   445, -1887, -1887, -1887, -1887,   138,
     -42,  1876,  -113,  1873,   -11,   946,  1879,  2024,  1878,  2035,
    2046,  2052, -1887,  1792,   362,   950, -1887,  1793,   362,  2286,
   -1887,  1798,   445,   946,   946,  2044,   659,   285,   445,  2039,
     -96,   950,  2002,  1930,  -106,  2054,  2055,   449,  1875,  1881,
   -1887, -1887,  1813, -1887, -1887, -1887, -1887,  2807,   212,   230,
      90,  1826,  2834,  2861,  2888,  2925, -1887,  2298,  2303, -1887,
   -1887, -1887, -1887, -1887, -1887,  2406, -1887,  2406, -1887,  1824,
    1830,   445,   445,   445, -1887, -1887,  1240,  2315,   436,   445,
    2315,  1251,   467,  1827, -1887,  1291, -1887, -1887, -1887,   445,
     445,   445,   445,   445, -1887, -1887,   445,   445,   946, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887,   399,   445,   445, -1887, -1887, -1887, -1887, -1887, -1887,
     946,  1946,   644,   946, -1887, -1887, -1887,   445,   445, -1887,
     946, -1887,   445,   946, -1887, -1887, -1887, -1887, -1887,  1913,
    1913,  2071, -1887,   722,  2078,   445,  2103,   445,  2110,   445,
     722,   445, -1887,   946,   445,   445,  2189,   946,   159,   946,
       8, -1887,   445, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,   445,   445,   445, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887,   445,   946,   946, -1887,   767,
     445, -1887, -1887,   445,   445,   946, -1887,   946,   946, -1887,
   -1887,  2406, -1887, -1887, -1887, -1887,  1845,  1846,  1848,  1849,
     445,   445,  1850,  1847, -1887,  2074, -1887, -1887, -1887, -1887,
   -1887, -1887,  1851,  2315,  2315,  1853,  1857,  1449,  1488,  1858,
    2315,  2315, -1887,   950,   950, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887,   121, -1887, -1887, -1887, -1887, -1887, -1887,
     946,  1989, -1887, -1887, -1887, -1887, -1887, -1887, -1887,   946,
   -1887, -1887,   445, -1887, -1887, -1887, -1887,   445,  1913,   445,
   -1887,   445, -1887, -1887,  1913, -1887, -1887, -1887,   445, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
    1990, -1887, -1887, -1887, -1887, -1887, -1887, -1887,  2807, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887,  2406, -1887,  1200,  1865,
    1867,  1200,  1200, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887,  1200,  1868,  1869, -1887, -1887, -1887,  1991,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887,  1880, -1887,  1200,  1200, -1887, -1887, -1887,  1200,
    1200, -1887,  1870,  2406, -1887, -1887, -1887, -1887, -1887,  1883,
   -1887
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1887, -1887, -1887, -1887, -1887,  -151,  -267,   352,  -324,  -685,
   -1887,  -139,  -140,  1460,  1467,  1468, -1887, -1887, -1887,  -156,
   -1887, -1887,  -305, -1100, -1110,  1806, -1887, -1887,  1042, -1401,
    -260,  -179,   557,  -675, -1887,  1023,  1026,  1027, -1887,  1033,
     811,   573,   581,  -329,  -884,  -481,   832, -1887, -1887, -1887,
   -1887,  1984, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887,  2351,  -934,  1221,  1000,  1805,  -842,  -555, -1887,
    1469, -1887, -1887, -1598, -1887,   508,  -161,  1569,   349, -1128,
   -1729,  2274, -1633, -1600,  1580,   357, -1887, -1887,  1577, -1887,
   -1887, -1887, -1887,  -378, -1887, -1887, -1090, -1887,  -132,  1080,
      -4, -1887, -1887,   728,  1342,   919, -1092,   646, -1887,  -340,
   -1887,   520, -1887, -1887, -1887,   -53,   -94, -1887,  -808, -1887,
    2100,  1708,   -82,  -430,  2085, -1887,    31, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887,  1244,  -655,  -344, -1887, -1887, -1815,
   -1887, -1887, -1887, -1887, -1887,    18, -1887,  1318,   526, -1887,
    1320, -1237,   218, -1886, -1887, -1174, -1887, -1887, -1887, -1887,
   -1887, -1887,  -189, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
     864, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887,   744,  1903, -1272, -1887, -1887, -1887,
   -1887,  1247,   704, -1887, -1887, -1887,   833, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,  1444,
    1451, -1887, -1887,   826, -1887, -1887, -1887,   821, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887,   800, -1887, -1887, -1887, -1887, -1887, -1887, -1887,   694,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
     304, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
     454,   440, -1887, -1887, -1887, -1887,   310,   450, -1887, -1887,
   -1887, -1887,   311,   452, -1780, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887,  1711, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887,  1519,  1552, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887,  1266,  1901, -1887,
   -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887, -1887
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -334
static const yytype_int16 yytable[] =
{
     187,   714,   716,   661,   467,   436,   435,   656,   429,   466,
    1397,  1399,  1401,  1402,   563,   849,   751,  1375,  1012,  1372,
     595,  1604,  1139,   936,   349,   465,   464,  1599,   366,  1702,
     379,  1042,   390,  1545,   674,   675,   218,   557,   399,   411,
     224,  1205,   380,   617,   831,   420,   832,  1856,   834,   835,
     400,   412,  1835,  1839,  1835,  1839,    69,  1863,   700,   830,
     304,  1866,   305,   969,   306,  1647,   353,   422,   354,   691,
     372,  2183,   423,   234,   392,   998,   393,  1926,   394,  2110,
    1158,   575,   424,  -173,   415,   416,  1927,  1928,  1144,  1145,
     798,  1933,  -173,  -173,  -173,  -173,  -172,  1358,   433,   434,
    1554,  1511,  2190,   641,   638,  -172,  -172,  -172,  -172,   639,
    1358,   542,   543,   544,   545,   546,     1,  1039,   659,   659,
    1372,   693,   433,   434,  1198,  1511,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   638,   695,   556,   711,   712,
     639,   713,   422,   219,   558,   567,   441,   423,  1359,  1360,
    1361,  1362,  1363,  1364,  1365,  1366,   434,   424,  1526,  1655,
     457,  1359,  1360,  1361,  1362,  1363,  1364,  1365,  1366,    70,
    2187,  2226,  1367,   710,   253,  1368,   711,   712,  2024,   713,
     697,  2154,  1043,   864,   865,  1367,  1104,  1934,  1368,   254,
    1369,  1039,   638,   631,   638,   632,   743,   639,   633,   639,
     638,    71,   631,  1369,   632,   639,  1231,   633,   754,  1513,
    1723,    72,  1370,    73,    74,   642,   643,   644,   645,  1924,
    1935,   642,   643,   644,   645,  1370,  2231,  1927,  1928,  1144,
    1145,  1022,   775,   634,   651,  1535,    75,   593,   458,   459,
     143,   460,   461,   462,   638,  1927,  1928,  1144,  1145,   639,
     638,  2218,   568,   816,   140,   639,   141,   142,   143,   144,
     145,   146,   147,  2232,  1301,   642,   643,   644,   645,   148,
     149,   637,  1090,   798,   150,   458,   459,  1144,  1145,   461,
     462,   198,   638,  2025,  1648,   225,   151,   639,   152,   153,
     429,   638,   429,  1040,   429,   429,   639,    76,   594,    77,
      78,  2188,    79,  1724,    80,  1895,    81,    82,  1489,    83,
     672,   576,   642,   643,   644,   645,   542,   543,   544,   545,
     546,    84,    85,    86,    87,    88,    89,   766,  2086,  1212,
    1009,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     154,   155,   556,  1637,   223,  1372,  1043,   287,   458,   459,
    1144,  1145,   461,   462,   156,   157,   692,  2227,  1044,  1096,
    1933,   158,   159,   160,  1020,   638,   161,  1040,    90,  2110,
     639,  1100,   162,   288,    91,  1656,  2184,   638,   163,   989,
      92,    93,   639,  1105,  1666,  2185,   642,   643,   644,   645,
    2130,  2131,   945,   946,   947,   948,   949,   230,   950,   951,
    2301,   954,   956,   383,   958,   959,  2026,  2155,   694,   542,
     543,   544,   545,   546,   638,   638,  2191,  1350,   231,   639,
     639,   833,   652,   696,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   840,  2219,   556,  1896,   384,   385,   646,
    1816,   386,   850,   851,   852,   853,   854,   855,   999,   257,
     258,   742,   387,  1897,   767,  2030,  1934,  1712,  1028,   863,
     638,  1494,   232,   638,   638,   639,  2220,   698,   639,   639,
    1750,  1762,   972,  1764,  1669,  1670,  1766,   586,  1769,  1771,
    1490,  1102,  2263,  1103,   642,   643,   644,   645,  1756,  1935,
     628,  1023,  2244,   432,  1667,   659,   233,  1205,   257,   258,
     991,   255,  1084,  1085,   586,   996,  1161,  1001,  1411,   439,
    1029,  1668,  2156,  2270,  2152,  2131,   220,   559,   226,  1309,
     227,   228,  1044,   105,  1546,  1703,   769,  1026,  2376,  1605,
    1606,  1140,  1106,   913,  2379,  1600,  2132,  1200,   874,   875,
     876,   877,   878,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   770,   251,  1673,  1857,  2181,  1840,   629,  1848,
     542,   543,   544,   545,   546,  1864,   425,  1908,  1047,  1867,
    1107,  1050,   426,  1052,  1053,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   914,  1929,   556,  1041,  2168,  1930,
    1898,  -173,   256,   638,  2133,  -173,   269,   252,   639,  1891,
     686,   953,   709,   640,  -172,  1078,  1208,   648,  -172,  2264,
     440,   961,  1007,   962,   642,   643,   644,   645,   659,   659,
    1715,   974,  1819,  1900,  1372,   569,   268,   638,   955,  1091,
    1162,   986,   639,  1091,   640,  2157,   988,  1091,   271,  2368,
    2271,   425,   365,   671,   270,   604,  1027,   426,   642,   643,
     644,   645,  1045,  2014,   259,   430,   436,   435,   432,   638,
    2132,  1474,  2221,   707,   639,   188,   189,  1113,   687,  1114,
      94,   701,   866,  1674,   629,   708,  1698,  1117,   738,    95,
     642,   643,   644,   645,  2081,  1788,  1789,   586,   382,   731,
    1285,   640,   635,   640,   844,  1748,  1248,   740,  1153,   640,
    1154,   635,  1748,   571,   572,  1719,   467,   467,  1201,   752,
     437,   605,   755,   739,   466,   758,  1720,  1277,  2153,  2266,
    2216,  2131,   442,  1211,   638,   765,  2241,  1372,  1957,   639,
     465,   464,   438,  1959,  1221,  1960,  1222,   463,  1962,  2222,
    1381,   443,  1458,   640,  1929,   642,   643,   644,   645,   640,
     192,   193,   196,   197,   582,   164,  -333,   720,   222,   819,
    2089,   821,   165,  2090,  1191,   721,  1193,  1176,  1177,  1178,
    1179,  1180,  1181,  1089,  1146,  1192,   444,  1194,   583,  1195,
    1196,   640,   638,  2284,  2285,   649,   445,   639,  2202,   190,
     640,  1676,  1168,  1167,   140,   845,   141,   142,   143,   144,
     145,   146,   147,   642,   643,   644,   645,   704,  1230,   148,
     149,   860,   446,   587,   150,  1094,  1475,   476,  2058,  1095,
    1677,  1678,   676,   858,   859,  2059,   151,   573,   152,   153,
     433,   434,  2235,  1819,  2054,  1372,  1372,  1504,  1505,   584,
    2055,   566,  1732,  1733,  1734,  1422,  1682,   463,  1423,   638,
    1424,   663,   664,  1136,   639,  1137,   447,  1735,  1736,  1737,
     448,  1459,  2349,  2350,   640,  1506,  2132,  1244,  1245,  2364,
    2365,   585,   188,   189,  1496,   449,   640,  1253,   450,   804,
     154,   155,   452,   453,   454,   455,   257,   258,  1261,  1262,
    2291,   451,  1264,  1265,   156,   157,   705,  1268,  1269,   561,
    1271,   158,   159,   160,  1275,   588,   161,   554,   555,  2060,
    1448,   556,   162,   640,   640,  1286,  1394,  1395,   163,   654,
     477,   706,  1236,  1241,  2217,  2056,  1312,   655,   542,   543,
     544,   545,   546,  1738,  1739,  1242,   261,  1468,   564,   565,
     577,  1971,  1507,   547,   548,   549,   550,   551,   552,   553,
     554,   555,  2016,   581,   556,  1356,  1950,  1951,  2017,   640,
     579,   638,   640,   640,  1953,  1954,   639,   711,   712,   965,
     713,  1972,   542,   543,   544,   545,   546,  2252,   586,  2253,
    1310,   596,   642,   643,   644,   645,   429,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   190,  1460,   556,  1461,
    1372,  1462,  1463,  1338,  1345,  1464,   724,   725,   262,   263,
     264,   597,  1425,  2330,  1427,  1339,  1346,   542,   543,   544,
     545,   546,   868,   598,  1869,   436,   435,   599,   869,  1013,
     728,   729,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   771,   772,   556,   870,  1497,  1973,  1974,  1440,  1871,
     871,   600,   194,   195,   601,  1030,   589,  1032,  1679,   606,
     607,   608,   609,   610,   611,   612,   602,  1837,  1122,  1901,
    1046,   603,   590,   591,  1849,   571,   572,  1837,  1054,  1849,
    1056,   805,  1058,   224,  1060,  1061,  1062,  1063,  1064,  1065,
     615,  1067,   640,  1069,  1070,   992,   993,   966,   777,   621,
    1644,  1470,  1075,  1517,   622,  1076,  1902,  1650,  1155,  1079,
    1156,   806,   623,  1903,  1002,  1003,  1004,   967,   840,   630,
     807,  1163,  1164,  1165,  1166,  1388,   640,  1389,  1390,  1391,
    1392,  1825,  1826,   711,   712,  1827,   713,  1101,  1563,   968,
    1828,  1829,  1404,   625,  1564,  1565,  1566,  1567,  1407,  1568,
    1569,  1570,  1099,   650,  1571,  1498,  1572,  1573,   640,  2303,
    2304,  2305,  1574,  1512,   653,   433,   434,  1111,  1511,  1112,
    1689,   938,   -64,   -64,  2383,   -64,   658,  2386,  2387,   465,
     464,   542,   543,   544,   545,   546,   662,  1697,   939,  2388,
     666,  1527,  1541,   667,  1707,  1527,   547,   548,   549,   550,
     551,   552,   553,   554,   555,  1638,  1639,   556,  1640,   668,
    2394,  2395,  1869,  1870,   677,  2396,  2397,   669,  2382,  1904,
    1905,  1906,   961,   640,  1438,   140,  1559,   141,   142,   143,
     144,   145,   146,   147,   434,  1979,  1526,  1871,   940,   670,
     148,   149,  1128,  1129,  1980,   150,  2117,   678,  1661,  1981,
    1662,   542,   543,   544,   545,   546,  1753,   151,  1755,   152,
     153,   808,   809,   810,   679,  2399,   547,   548,   549,   550,
     551,   552,   553,   554,   555,  2118,   681,   556,   786,  1199,
     688,   640,  1217,  1218,  1872,  1873,  1219,  1220,  1874,  1875,
     682,  1290,   683,   383,  1876,   164,  1412,  1413,   689,   941,
    1642,  1641,   165,   684,  1652,   786,  1495,   685,   942,   943,
     690,   154,   155,   452,   453,   454,   455,   699,   290,   944,
    1597,  1598,   291,   292,   702,   156,   157,   384,   385,   703,
     294,   386,   158,   159,   160,  1602,  1603,   161,   718,  2119,
    1659,  1660,   387,   162,  1793,  1729,  1730,   726,   640,   163,
    1835,  1836,   383,  1684,  1685,  1982,  1687,   719,  1548,   722,
    1291,  1854,  1855,  1549,  1550,   723,  1692,  1966,  1967,  1693,
    1556,  1907,   730,  2120,  1247,  1249,   733,   295,  2121,   776,
     777,   727,   296,  1256,   732,  1258,  1292,   385,  1778,  1595,
     386,  1596,   778,   734,  2122,  1859,  1860,   779,   735,  1831,
     140,   387,   141,   142,   143,   144,   145,   146,   147,  2114,
    2115,   784,  1732,  1733,  1734,   148,   149,  1396,  2126,  2127,
     150,  2259,  2260,   736,  1512,   737,  1740,  1735,  1736,  1737,
    2267,  2268,   151,  1740,   152,   153,  1131,  1983,  1984,   741,
     465,   464,   744,   776,   777,  1329,  2273,  2274,  1527,   745,
    1293,  1985,  1986,  1987,  1294,  1882,   778,  1355,  1988,  1357,
     640,   779,   747,   140,   753,   141,   142,   143,   144,   145,
     146,   147,  2100,  2101,   750,   780,   748,  1203,   148,   149,
    1400,   781,   749,   150,  1910,  1911,   154,   155,  1912,  1913,
    1914,   619,   620,   756,  1182,   151,   757,   152,   153,   210,
     156,   157,   759,  1738,  1739,   762,   763,   158,   159,   160,
     764,  1183,   161,   542,   543,   544,   545,   546,   162,   768,
     211,   388,   212,   213,   163,  1132,   773,   774,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   786,   788,   556,
     789,  1710,   840,   790,   791,  1295,   792,  1716,  1184,   154,
     155,   900,   901,   902,  1296,  1297,   793,  1813,   801,  1877,
     794,  1298,   800,   156,   157,  1299,  1522,  1523,  1524,  1525,
     158,   159,   160,   903,   904,   161,   905,   815,  1915,   776,
     777,   162,   214,   215,   216,   217,  1758,   163,   817,   802,
    1834,   803,   778,   818,   813,   820,  1842,   779,   822,  1484,
     823,   828,   836,  1469,   837,   824,   838,  1969,   825,  1963,
     829,   780,   839,  1575,   843,   856,   846,   781,   556,   872,
     140,   857,   141,   142,   143,   144,   145,   146,   147,  1185,
    2353,  2354,  2355,  2356,  2357,   148,   149,   867,   873,   908,
     150,   909,   910,   911,  1888,  1512,   912,  1512,   917,   919,
    1491,   920,   151,   957,   152,   153,   960,   963,   964,  1931,
     970,   465,   464,   465,   464,   973,  1503,   975,  1508,  2358,
    2359,  2360,  2361,  2362,  1518,  1843,  1844,  1845,  1846,   983,
     982,   994,  1946,  1005,  1563,  1740,  1008,  1740,   987,  1133,
    1564,  1565,  1566,  1567,  1540,  1568,  1569,  1570,   389,   990,
    1571,  1018,  1572,  1573,  1019,  1031,   154,   155,  1574,  1582,
    1989,  1021,  1024,  1822,  1823,  1824,  1025,  1556,  1033,  1034,
     156,   157,  1035,   659,  1970,  1037,   164,   158,   159,   160,
    1036,  1048,   161,   165,  1049,  1051,  1055,  1057,   162,  1059,
    1066,  1077,  1068,  1071,   163,  2020,  1082,  2228,  1083,  1093,
    2023,   805,  2027,  2028,  1118,  2031,  1120,  1300,  1186,  1134,
     542,   543,   544,   545,   546,   433,   795,   796,   797,  1110,
    1187,  1121,  1123,  1125,  1124,   547,   548,   549,   550,   551,
     552,   553,   554,   555,  1138,  1141,   556,   542,   543,   544,
     545,   546,  1143,   151,  1150,   152,   153,  2096,  1152,  2097,
    2098,  2099,   547,   548,   549,   550,   551,   552,   553,   554,
     555,  1151,   290,   556,  1157,  1159,   291,   292,  1160,  1174,
    1232,  1175,  1202,  1209,   294,   290,  1210,  1213,  2124,   291,
     292,  2128,  1224,   417,  2135,  1671,  1672,   294,  1675,  1226,
    1358,  2148,  1216,  1225,  2256,  2257,  2258,  2158,  2159,  1228,
    1229,  1188,  1251,  1246,  2165,  2166,  1252,  2169,  1686,  2171,
    1254,  1255,  1257,  1259,  1266,  1267,  2175,  1327,  1270,  2280,
    2281,   295,  1272,  1273,  1274,  1276,   296,  1278,  2177,  2178,
    1279,  1280,  2179,  2180,   295,  1281,  1189,  1190,  1706,   296,
    1282,  1359,  1360,  1361,  1362,  1363,  1364,  1365,  1366,  1527,
    1351,   164,  1352,  2203,  1283,  1284,  1287,  2203,   165,  1288,
    1289,  2212,  1377,  1330,  1382,  1367,  1348,  2224,  1368,  1349,
    1384,  1385,  1379,  1233,  1234,  2087,  2236,  1931,  1931,  1403,
    1405,  1406,  1410,  1369,  1414,  1415,  1421,  2092,  2093,  2094,
    1416,  2095,  1417,  1418,  1419,  1420,  1426,  1428,  1429,  2366,
    2367,  1430,  1431,  1358,  1453,  1370,  1432,  1439,  1437,  2369,
     659,   659,   659,  1455,   164,  1443,  1450,  1454,  2265,  1456,
    1457,   165,   542,   543,   544,   545,   546,  1467,  2275,  2276,
    2277,  2278,  2279,  1471,  1472,   659,   659,   547,   548,   549,
     550,   551,   552,   553,   554,   555,  1473,  1476,   556,  1477,
    2286,  2287,  2288,  1783,  1359,  1360,  1361,  1362,  1363,  1364,
    1365,  1366,  1478,  1479,  1480,  1481,  2294,  2295,  1482,  1483,
    1119,  2297,  1485,  1486,  1487,  1488,  1492,  1493,  1367,  1499,
    1510,  1368,  1796,  1797,  2308,  1500,  2310,  1519,  2312,  1520,
    2314,  1536,  1537,  2316,  2317,  1542,  1369,  1544,  1547,  1551,
    1552,  2323,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    1555,  1561,  1562,  1608,  2324,  2325,  2326,  1601,  1370,  1607,
    1610,  1611,  1633,  1634,  2327,  1636,  1645,  1651,  1654,  2332,
    1653,  1657,  2333,  2334,  1658,  1663,  1664,  1665,  1681,  1708,
     140,  1680,   141,   142,   143,   144,   145,   146,   147,  2343,
    2344,  1709,  1688,  1718,  1726,   148,   149,  1763,  1727,  1721,
     150,  1690,  1691,  1694,   542,   543,   544,   545,   546,  1695,
    -328,   164,   151,  1722,   152,   153,  1728,  1731,   165,   547,
     548,   549,   550,   551,   552,   553,   554,   555,  1745,  1751,
     556,  1757,  1761,  1765,     4,  1767,  1887,  1772,  1777,  1779,
    1781,  2374,  1785,  1794,     5,  1786,  2375,  1795,  2377,  1583,
    2378,  1833,  1784,  1850,  1799,  1925,  1952,  2380,  1807,  1811,
    1955,  1815,  1832,  1883,  1838,  1852,   154,   155,     6,     7,
    1853,  1956,  1944,  1858,  1861,  1961,  1862,  1865,  1923,  1941,
     156,   157,  1235,  1942,  1943,   418,  1945,   158,   159,   160,
    1958,  1965,   161,  1968,  1977,   419,  2029,  1976,   162,  2022,
       8,  2032,  2033,     9,   163,    10,  2034,  2038,  2083,  2084,
    2088,  2091,  1964,   140,  2102,   141,   142,   143,   144,   145,
     146,   147,  2105,  2103,  2104,  1978,  2106,  2338,   148,   149,
    1768,  2107,    11,   150,  2108,  1869,    12,  2019,  2111,  2021,
    2112,    13,    14,  2113,  2116,   151,  2125,   152,   153,  2129,
    2136,  2137,  1358,  2138,  2035,  2036,  2037,   140,  1393,   141,
     142,   143,   144,   145,   146,   147,  2149,  2139,  2161,  2151,
    2162,  2163,   148,   149,  1770,  2160,  2172,   150,  2167,  2170,
    2186,  2173,  2189,  2174,  2176,  1590,  2193,  2194,  2197,   151,
    2195,   152,   153,  2196,  2199,  2201,  2207,  1702,  2215,   154,
     155,  2211,  2225,  1359,  1360,  1361,  1362,  1363,  1364,  1365,
    1366,  2230,  2229,   156,   157,  2237,  2239,  2233,  2234,  2250,
     158,   159,   160,  2238,  2251,   161,  2261,  1367,  1371,  2245,
    1368,   162,  2254,  2255,  2302,  2272,  2150,   163,  2290,  2299,
    2309,  2307,  2318,   154,   155,  1369,  2164,  2311,  2339,  2340,
      15,  2341,  2342,  2346,  2348,  2345,  2351,   156,   157,  2391,
    2352,  2363,  2372,  2381,   158,   159,   160,  1370,  2384,   161,
    2385,  2389,  2390,  2398,   935,   162,   542,   543,   544,   545,
     546,   163,  1169,  1543,  1948,  1752,  2393,  2192,  2400,  1170,
    1171,   547,   548,   549,   550,   551,   552,   553,   554,   555,
    1584,  1949,   556,  1585,  1586,  2213,  2214,  1947,  1754,   140,
    1588,   141,   142,   143,   144,   145,   146,   147,   848,   250,
    1433,  1635,   980,  2085,   148,   149,  1147,  2242,   456,   150,
     542,   543,   544,   545,   546,  1207,  2243,  1149,  1148,  1830,
    1817,   151,  1553,   152,   153,   547,   548,   549,   550,   551,
     552,   553,   554,   555,  1383,  1711,   556,   761,  1938,  1080,
     785,  1408,  1442,  2347,  1773,  1409,   918,  1774,  1868,  1130,
    1446,   542,   543,   544,   545,   546,  1263,  1787,  1792,  1260,
    2282,  1803,  1889,  2182,  2313,  2205,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   154,   155,   556,  2320,  2209,
    2208,  2322,  2289,  1197,  2292,  2293,    16,    17,  1223,   156,
     157,   971,  2296,  1108,     0,  2298,   158,   159,   160,     0,
       0,   161,     0,     0,     0,     0,     0,   162,   542,   543,
     544,   545,   546,   163,     0,  2315,     0,     0,     0,  2319,
       0,  2321,     0,   547,   548,   549,   550,   551,   552,   553,
     554,   555,     0,     0,   556,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2328,  2329,
       0,  2331,     0,     0,     0,     0,     0,  2335,     0,  2336,
    2337,   164,   542,   543,   544,   545,   546,     0,   165,     0,
       0,     0,     0,     0,     0,     0,     0,   547,   548,   549,
     550,   551,   552,   553,   554,   555,     0,     0,   556,     0,
       0,  1135,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   542,   543,   544,
     545,   546,  2371,     0,     0,     0,     0,     0,     0,     0,
       0,  2373,   547,   548,   549,   550,   551,   552,   553,   554,
     555,     0,     0,   556,   542,   543,   544,   545,   546,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   547,
     548,   549,   550,   551,   552,   553,   554,   555,     0,     0,
     556,   542,   543,   544,   545,   546,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   547,   548,   549,   550,
     551,   552,   553,   554,   555,     0,     0,   556,   542,   543,
     544,   545,   546,     0,   164,     0,     0,     0,     0,     0,
       0,   165,     0,   547,   548,   549,   550,   551,   552,   553,
     554,   555,     0,     0,   556,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -172,   542,   543,   544,   545,   546,     0,     0,   164,     0,
       0,     0,     0,     0,     0,   165,   547,   548,   549,   550,
     551,   552,   553,   554,   555,     0,     0,   556,   542,   543,
     544,   545,   546,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   547,   548,   549,   550,   551,   552,   553,
     554,   555,     0,     0,   556,   542,   543,   544,   545,   546,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     547,   548,   549,   550,   551,   552,   553,   554,   555,     0,
       0,   556,   542,   543,   544,   545,   546,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   547,   548,   549,
     550,   551,   552,   553,   554,   555,     0,     0,   556,   542,
     543,   544,   545,   546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   547,   548,   549,   550,   551,   552,
     553,   554,   555,  1142,     0,   556,   542,   543,   544,   545,
     546,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     164,     0,   556,     0,     0,     0,     0,   165,     0,     0,
    2062,     0,     0,   542,   543,   544,   545,   546,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1214,   547,   548,
     549,   550,   551,   552,   553,   554,   555,     0,     0,   556,
     542,   543,   544,   545,   546,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   547,   548,   549,   550,   551,
     552,   553,   554,   555,     0,     0,   556,     0,  1215,   542,
     543,   544,   545,   546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   547,   548,   549,   550,   551,   552,
     553,   554,   555,     0,     0,   556,   542,   543,   544,   545,
     546,     0,     0,     0,     0,  2039,     0,     0,     0,     0,
       0,   547,   548,   549,   550,   551,   552,   553,   554,   555,
       0,     0,   556,     0,     0,  1591,   542,   543,   544,   545,
     546,     0,     0,     0,     0,     0,     0,     0,  1869,  2063,
       0,   547,   548,   549,   550,   551,   552,   553,   554,   555,
       0,     0,   556,     0,   542,   543,   544,   545,   546,    72,
       0,    73,    74,  1871,     0,     0,     0,     0,     0,   547,
     548,   549,   550,   551,   552,   553,   554,   555,     0,  1592,
     556,   355,    72,     0,    73,    74,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,     0,     0,     0,  2064,
       0,     0,  2065,  2066,     0,     0,     0,     0,     0,     0,
    2067,     0,     0,     0,  1593,  2068,     0,     0,  2069,     0,
       0,     0,     0,  2070,     0,  2040,     0,     0,     0,    72,
    2041,    73,    74,     0,     0,     0,     0,     0,     0,     0,
       0,  1594,   290,     0,     0,     0,   291,   292,     0,     0,
       0,     0,     0,  2071,   294,     0,  2042,     0,     0,    84,
      85,    86,    87,    88,    89,   290,  1331,     0,  1609,   291,
     292,     0,     0,     0,     0,     0,  2072,   294,     0,     0,
    2043,     0,    84,    85,    86,    87,    88,    89,     0,     0,
       0,     0,     0,  2044,     0,  1759,     0,     0,     0,     0,
       0,   295,    72,     0,    73,    74,   296,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   403,
       0,     0,   290,     0,   295,     0,   291,   292,     0,   296,
    1332,     0,     0,     0,   294,     0,     0,     0,  1760,    84,
      85,    86,    87,    88,    89,     0,     0,  2073,     0,     0,
       0,     0,  1303,   777,     0,    72,     0,    73,    74,   290,
       0,     0,   404,   291,   292,  1851,     0,     0,  2074,     0,
       0,   294,  1304,     0,     0,     0,     0,     0,     0,     0,
       0,   295,     0,     0,     0,     0,   296,     0,     0,     0,
       0,     0,  2240,     0,     0,   290,     0,     0,     0,   291,
     292,     0,     0,  2075,  2076,  2077,  2078,   294,  2079,     0,
       0,     0,    84,    85,    86,    87,    88,    89,   295,  2246,
       0,     0,     0,   296,     0,     0,   373,     0,  2045,  2046,
       0,     0,     0,  2047,  2048,    72,  2049,    73,    74,     0,
       0,     0,     0,     0,  2050,  2051,  2247,     0,   290,     0,
       0,     0,   291,   292,   295,     0,     0,     0,     0,   296,
     294,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,     0,     0,  2248,     0,  2080,     0,     0,     0,   542,
     543,   544,   545,   546,     0,     0,     0,   356,   357,   358,
     359,     0,   272,     0,   547,   548,   549,   550,   551,   552,
     553,   554,   555,     0,   405,   556,     0,   295,     0,     0,
    2249,     0,   296,     0,     0,     0,     0,   360,     0,     0,
       0,     0,   395,     0,   361,     0,     0,   362,   290,     0,
     363,  2052,   291,   292,     0,  1713,  1341,  -334,  -334,  -334,
     294,    72,   273,    73,    74,    84,    85,    86,    87,    88,
      89,     0,  -334,  -334,  -334,  -334,  -334,   552,   553,   554,
     555,     0,     0,   556,  1814,   406,     0,  1714,     0,     0,
       0,  1305,  1306,  1307,     0,     0,   396,    72,     0,    73,
      74,     0,     0,     0,     0,     0,     0,   295,     0,   274,
       0,  1821,   296,     0,     0,     0,     0,  1313,     0,     0,
       0,     0,     0,     0,   275,     0,     0,     0,     0,     0,
       0,   407,   408,   409,  1204,  1333,  1334,     0,     0,  1335,
       0,  1939,   410,     0,  1336,   397,     0,     0,     0,     0,
       0,     0,     0,     0,   290,     0,     0,     0,   291,   292,
       0,     0,   293,     0,     0,   364,   294,   307,   308,  1940,
       0,    84,    85,    86,    87,    88,    89,     0,     0,     0,
       0,     0,     0,     0,     0,   374,   375,   376,   377,     0,
     290,     0,     0,     0,   291,   292,     0,   309,  1238,     0,
       0,     0,   294,     0,  1314,     0,     0,    84,    85,    86,
      87,    88,    89,   295,     0,     0,   276,     0,   296,     0,
     277,     0,  1337,     0,     0,     0,     0,     0,   310,     0,
       0,   199,   200,     0,     0,     0,     0,     0,     0,   478,
       0,     0,     0,     0,   479,     0,     0,     0,     0,   295,
       0,  1315,     0,     0,   296,     0,     0,     0,   290,  1308,
     201,     0,   291,   292,     0,   311,   312,   202,  1991,     0,
     294,     0,     0,     0,   278,   313,   314,   315,   316,   279,
     280,     0,   297,     0,     0,     0,     0,   203,   317,   204,
       0,   318,   319,     0,     0,   378,     0,   205,   480,   481,
    1342,   482,   483,   484,   485,   486,     0,     0,     0,     0,
     281,     0,   206,     0,     0,     0,     0,   295,     0,     0,
       0,     0,   296,  1239,   282,     0,     0,     0,   283,     0,
       0,   320,     0,  1316,     0,   321,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   398,     0,
       0,  1317,     0,  1318,     0,  1343,     0,  1319,     0,  1320,
       0,   322,   323,  1321,  1322,     0,     0,     0,     0,   324,
     325,     0,   326,     0,     0,     0,     0,   284,     0,     0,
       0,     0,  1869,     0,     0,     0,   327,     0,     0,     0,
       0,     0,   328,     0,   329,     0,   330,   331,     0,   487,
     332,   333,   334,     0,     0,     0,     0,  1871,   207,     0,
       0,     0,     0,     0,     0,     0,     0,   335,   336,     0,
       0,     0,     0,   337,   338,     0,     0,  1992,  1344,     0,
       0,   339,     0,     0,     0,   340,     0,     0,   341,   342,
       0,   343,     0,   344,     0,     0,     0,   345,   346,  1993,
     347,     0,     0,  1994,  1086,     0,  1995,  1996,     0,     0,
       0,     0,   488,     0,  1997,     0,     0,     0,     0,     0,
       0,  1998,     0,     0,   487,     0,  1999,  2000,  2001,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,  1323,
       0,     0,     0,     0,     0,     0,     0,     0,   208,     0,
       0,     0,     0,     0,     0,     0,   499,   500,     0,     0,
       0,     0,   209,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
    2002,     0,     0,     0,   298,     0,     0,   488,   888,  2003,
       0,     0,     0,     0,     0,   889,     0,     0,     0,   501,
     502,   503,   504,     0,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,     0,     0,     0,     0,     0,   890,
    1240,   891,     0,  2004,     0,  2005,     0,  2006,  2007,  2008,
       0,   499,   500,     0,     0,  2009,     0,     0,     0,     0,
    2010,     0,     0,     0,     0,   892,     0,     0,     0,     0,
       0,  2011,     0,   893,   894,     0,   895,   896,     0,  2012,
       0,     0,     0,     0,   897,   898,   899,     0,     0,     0,
       0,     0,     0,     0,   501,   502,   503,   504,     0,     0,
       0,     0,     0,     0,   505,   506,     0,     0,   348,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   507,   508,
       0,     0,     0,     0,     0,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   921,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   795,   796,
     797,     0,     0,     0,   537,   538,     0,     0,     0,   505,
     506,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   507,   508,   151,     0,   152,   153,  2013,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,     0,     0,
       0,     0,     0,   541,  1612,     0,  1613,  1614,   542,   543,
     544,   545,   546,     0,     0,     0,     0,     0,     0,   537,
     538,     0,     0,   547,   548,   549,   550,   551,   552,   553,
     554,   555,     0,     0,   556,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,   247,   248,
     249,   922,   777,     0,     0,     0,     0,     0,     0,     0,
     923,     0,     0,     0,   924,     0,     0,   925,   926,     0,
       0,   927,     0,     0,     0,     0,   542,   543,   544,   545,
     546,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     928,   547,   548,   549,   550,   551,   552,   553,   554,   555,
       0,     0,   556,     0,     0,     0,   929,   930,   931,     0,
     932,     0,   933,   934,  1615,  1616,  1617,  1618,  1619,  1620,
     542,   543,   544,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   547,   548,   549,   550,   551,
     552,   553,   554,   555,     0,     0,   556,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631
};

static const yytype_int16 yycheck[] =
{
       4,   325,   326,   270,   165,   145,   145,   267,   140,   165,
    1138,  1139,  1140,  1141,   193,   445,   356,  1109,   673,  1109,
     209,     7,     7,   578,   118,   165,   165,     7,   122,    21,
     124,   716,   126,    23,   294,   295,    37,    37,   132,   133,
      21,   975,   124,   222,   422,   139,   424,     7,   426,   427,
     132,   133,    11,    12,    11,    12,     0,     7,   318,     7,
     113,     7,   115,   618,   117,    32,   119,    15,   121,    45,
     123,   113,    20,    77,   127,   144,   129,     6,   131,  1965,
     922,     3,    30,     6,   137,   138,    15,    16,    17,    18,
     395,  1820,    15,    16,    17,    18,     6,    20,    17,    18,
    1372,    20,   113,   254,    15,    15,    16,    17,    18,    20,
      20,     8,     9,    10,    11,    12,     4,    43,   269,   270,
    1210,    45,    17,    18,   966,    20,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    15,    45,    34,    17,    18,
      20,    20,    15,   144,   144,    37,   150,    20,    71,    72,
      73,    74,    75,    76,    77,    78,    18,    30,    20,   124,
     164,    71,    72,    73,    74,    75,    76,    77,    78,     3,
     283,   267,    95,   324,   176,    98,    17,    18,   149,    20,
      45,  1996,    43,    28,    29,    95,    45,  1820,    98,   191,
     113,    43,    15,    15,    15,    17,   347,    20,    20,    20,
      15,    35,    15,   113,    17,    20,  1014,    20,   359,  1319,
     425,    45,   135,    47,    48,    36,    37,    38,    39,  1817,
    1820,    36,    37,    38,    39,   135,   332,    15,    16,    17,
      18,    77,   383,    46,    21,  1335,    70,   177,    15,    16,
      17,    18,    19,    20,    15,    15,    16,    17,    18,    20,
      15,  2066,   144,   404,    13,    20,    15,    16,    17,    18,
      19,    20,    21,   369,  1072,    36,    37,    38,    39,    28,
      29,   253,    37,   578,    33,    15,    16,    17,    18,    19,
      20,     3,    15,   254,   251,   266,    45,    20,    47,    48,
     422,    15,   424,   219,   426,   427,    20,   131,   238,   133,
     134,   414,   136,   518,   138,   233,   140,   141,   145,   143,
     292,   233,    36,    37,    38,    39,     8,     9,    10,    11,
      12,   155,   156,   157,   158,   159,   160,    46,  1926,   984,
     670,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      99,   100,    34,  1435,   235,  1435,    43,    20,    15,    16,
      17,    18,    19,    20,   113,   114,   332,   453,   219,   789,
    2089,   120,   121,   122,   688,    15,   125,   219,   202,  2255,
      20,   801,   131,    46,   208,   340,   418,    15,   137,   646,
     214,   215,    20,   242,   169,   427,    36,    37,    38,    39,
      61,    62,   581,   582,   583,   584,   585,     3,   587,   588,
    2180,   590,   591,   113,   593,   594,   377,   149,   332,     8,
       9,    10,    11,    12,    15,    15,   427,  1102,    20,    20,
      20,   425,   209,   332,    23,    24,    25,    26,    27,    28,
      29,    30,    31,   437,   149,    34,   364,   147,   148,   163,
    1712,   151,   446,   447,   448,   449,   450,   451,   517,    20,
      21,   331,   162,   381,   173,   188,  2089,  1547,   273,   463,
      15,  1303,    20,    15,    15,    20,   181,   332,    20,    20,
    1580,  1599,   623,  1601,   245,   246,  1604,    20,  1606,  1607,
     317,   805,    46,   807,    36,    37,    38,    39,  1588,  2089,
      20,   337,  2090,    31,   279,   646,    20,  1431,    20,    21,
     651,   503,   769,   770,    20,   656,    20,   658,    46,    29,
     325,   296,   254,    46,    61,    62,   517,   517,   499,  1074,
     501,   502,   219,     3,   514,   517,   217,   215,  2308,   515,
     516,   516,   391,   152,  2314,   515,   207,   967,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   243,   514,   215,   515,   418,   516,    88,   516,
       8,     9,    10,    11,    12,   515,   514,  1804,   719,   515,
     429,   722,   520,   724,   725,    23,    24,    25,    26,    27,
      28,    29,    30,    31,   203,   514,    34,   513,   188,   518,
     518,   514,   161,    15,   265,   518,   446,   139,    20,   518,
     216,   144,   513,   514,   514,   756,    20,   255,   518,   173,
     130,   516,   665,   518,    36,    37,    38,    39,   769,   770,
     517,   625,  1714,   518,  1714,   517,   167,    15,   144,   780,
     144,   635,    20,   784,   514,   377,   640,   788,   151,   518,
     173,   514,   122,   291,   494,    77,   334,   520,    36,    37,
      38,    39,   513,  1890,   176,    31,   796,   796,    31,    15,
     207,   513,   377,   215,    20,    20,    21,   818,   284,   820,
     504,   319,   517,   334,    88,   323,   517,   828,   252,   513,
      36,    37,    38,    39,  1921,   335,   336,    20,   517,   337,
     513,   514,   514,   514,    29,  1579,   517,   345,   516,   514,
     518,   514,  1586,    20,    21,    23,   867,   868,   968,   357,
     514,   143,   360,   287,   870,   363,    34,  1057,   265,  2120,
      61,    62,    15,   983,    15,   373,   514,  1817,  1856,    20,
     870,   870,   130,  1861,   994,  1863,   996,   514,  1866,   454,
    1118,   517,    82,   514,   514,    36,    37,    38,    39,   514,
       6,     7,     8,     9,   153,   514,   515,   275,    14,   407,
     516,   409,   521,   519,   953,   283,   955,   946,   947,   948,
     949,   950,   951,   777,   514,   954,   517,   956,   177,   958,
     959,   514,    15,   384,   385,   259,   514,    20,   426,   144,
     514,   279,   932,   932,    13,   130,    15,    16,    17,    18,
      19,    20,    21,    36,    37,    38,    39,   212,   518,    28,
      29,    30,   514,   146,    33,   784,   513,   217,   427,   788,
     308,   309,   296,   515,   516,   434,    45,   144,    47,    48,
      17,    18,   383,  1925,   427,  1925,  1926,   364,   365,   238,
     433,     3,     8,     9,    10,  1185,  1501,   514,  1188,    15,
    1190,   354,   355,   857,    20,   859,   514,    23,    24,    25,
     514,   201,  2263,  2264,   514,   392,   207,  1018,  1019,  2270,
    2271,   270,    20,    21,  1304,   514,   514,  1028,   514,    76,
      99,   100,   101,   102,   103,   104,    20,    21,  1039,  1040,
     246,   514,  1043,  1044,   113,   114,   301,  1048,  1049,    21,
    1051,   120,   121,   122,  1055,   238,   125,    30,    31,   518,
    1234,    34,   131,   514,   514,  1066,   515,   516,   137,   490,
     217,   326,  1016,  1017,   265,   518,  1077,   498,     8,     9,
      10,    11,    12,    99,   100,  1017,   140,   325,   194,   195,
       3,   149,   364,    23,    24,    25,    26,    27,    28,    29,
      30,    31,   381,   256,    34,  1106,  1840,  1841,   387,   514,
       3,    15,   514,   514,  1848,  1849,    20,    17,    18,     3,
      20,   179,     8,     9,    10,    11,    12,  2105,    20,  2107,
    1074,     3,    36,    37,    38,    39,  1118,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   144,   337,    34,   339,
    2090,   341,   342,  1097,  1098,   345,   287,   288,   212,   213,
     214,     3,  1191,   246,  1193,  1097,  1098,     8,     9,    10,
      11,    12,   516,     3,   171,  1165,  1165,     3,   522,   677,
     299,   300,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   147,   148,    34,   516,  1305,   254,   255,  1227,   196,
     522,     3,   200,   201,     3,   703,   389,   705,  1488,   491,
     492,   493,   494,   495,   496,   497,     3,  1742,   516,   216,
     718,     3,   405,   406,  1749,    20,    21,  1752,   726,  1754,
     728,   278,   730,    21,   732,   733,   734,   735,   736,   737,
      15,   739,   514,   741,   742,   210,   211,   131,   132,     3,
    1444,  1252,   750,   394,     3,   753,   253,  1451,   516,   757,
     518,   308,   446,   260,    40,    41,    42,   151,  1122,    20,
     317,    17,    18,    19,    20,  1129,   514,  1131,  1132,  1133,
    1134,   121,   122,    17,    18,   125,    20,    21,    43,   173,
     130,   131,  1146,    23,    49,    50,    51,    52,  1152,    54,
      55,    56,   800,   513,    59,  1306,    61,    62,   514,   437,
     438,   439,    67,  1319,   513,    17,    18,   815,    20,   817,
    1510,     3,    17,    18,  2348,    20,   216,  2351,  2352,  1319,
    1319,     8,     9,    10,    11,    12,    20,  1531,    20,  2363,
     444,  1331,  1343,    46,  1538,  1335,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    17,    18,    34,    20,    20,
    2384,  2385,   171,   172,   267,  2389,  2390,   517,  2346,   366,
     367,   368,   516,   514,   518,    13,  1377,    15,    16,    17,
      18,    19,    20,    21,    18,    43,    20,   196,    70,   139,
      28,    29,   515,   516,    52,    33,    46,   513,   516,    57,
     518,     8,     9,    10,    11,    12,  1585,    45,  1587,    47,
      48,   458,   459,   460,   517,  2393,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    75,   513,    34,    20,    21,
     296,   514,    41,    42,   243,   244,    41,    42,   247,   248,
     513,    52,   517,   113,   253,   514,    17,    18,   513,   131,
    1440,  1440,   521,   517,  1455,    20,    21,   517,   140,   141,
      21,    99,   100,   101,   102,   103,   104,   285,   138,   151,
     515,   516,   142,   143,   333,   113,   114,   147,   148,   167,
     150,   151,   120,   121,   122,   515,   516,   125,   267,   139,
     346,   347,   162,   131,  1668,    57,    58,   258,   514,   137,
      11,    12,   113,  1504,  1505,   163,  1507,   273,  1362,   273,
     121,   515,   516,  1367,  1368,   272,  1517,   245,   246,  1520,
    1374,   518,   299,   173,  1022,  1023,   312,   197,   178,   131,
     132,   283,   202,  1031,   305,  1033,   147,   148,  1648,  1393,
     151,  1395,   144,   258,   194,   515,   516,   149,   258,  1723,
      13,   162,    15,    16,    17,    18,    19,    20,    21,   181,
     182,   163,     8,     9,    10,    28,    29,    30,   262,   263,
      33,   181,   182,   320,  1580,   318,  1577,    23,    24,    25,
     179,   180,    45,  1584,    47,    48,   516,   245,   246,   329,
    1580,  1580,   513,   131,   132,  1093,   155,   156,  1588,   517,
     211,   259,   260,   261,   215,  1779,   144,  1105,   266,  1107,
     514,   149,   513,    13,   138,    15,    16,    17,    18,    19,
      20,    21,  1953,  1954,   404,   163,   517,   513,    28,    29,
      30,   169,   517,    33,   424,   425,    99,   100,   428,   429,
     430,   225,   226,   139,     3,    45,   388,    47,    48,   153,
     113,   114,   332,    99,   100,   513,   517,   120,   121,   122,
     517,    20,   125,     8,     9,    10,    11,    12,   131,    15,
     174,   341,   176,   177,   137,   516,   513,   513,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    20,   163,    34,
     151,  1545,  1546,   513,   513,   306,   517,  1551,    57,    99,
     100,   152,   153,   154,   315,   316,   517,  1708,   151,   518,
     517,   322,   267,   113,   114,   326,   165,   166,   167,   168,
     120,   121,   122,   174,   175,   125,   177,   167,   518,   131,
     132,   131,   236,   237,   238,   239,  1590,   137,   324,   513,
    1741,   513,   144,   151,   517,   273,  1747,   149,   513,   151,
     513,   273,    14,  1251,    15,   517,    15,  1874,   517,  1869,
     513,   163,    31,   518,    28,    15,    29,   169,    34,    15,
      13,   516,    15,    16,    17,    18,    19,    20,    21,   138,
     181,   182,   183,   184,   185,    28,    29,     7,    15,     3,
      33,     3,     3,     3,  1795,  1801,     3,  1803,     3,     3,
    1298,     3,    45,     3,    47,    48,     3,     3,     3,  1820,
       3,  1801,  1801,  1803,  1803,     3,  1314,   514,  1316,   181,
     182,   183,   184,   185,  1322,    63,    64,    65,    66,   516,
     513,   500,  1833,   198,    43,  1836,    20,  1838,   513,   516,
      49,    50,    51,    52,  1342,    54,    55,    56,   518,   513,
      59,   273,    61,    62,   273,   310,    99,   100,    67,    68,
     518,   513,   513,  1717,  1718,  1719,   513,  1721,   203,   513,
     113,   114,   513,  1874,  1875,    32,   514,   120,   121,   122,
     513,   273,   125,   521,   273,   273,   273,   139,   131,   513,
     219,   163,   513,   513,   137,  1896,    15,  2071,    15,   170,
    1901,   278,  1903,  1904,    15,  1906,    46,   518,   267,   516,
       8,     9,    10,    11,    12,    17,    18,    19,    20,   513,
     279,    15,   515,    29,   130,    23,    24,    25,    26,    27,
      28,    29,    30,    31,   516,   516,    34,     8,     9,    10,
      11,    12,    15,    45,   219,    47,    48,  1948,   514,  1950,
    1951,  1952,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   219,   138,    34,     3,    20,   142,   143,   151,    20,
     146,     3,     3,   513,   150,   138,   517,   513,  1979,   142,
     143,  1982,   513,   146,  1985,  1483,  1484,   150,  1486,    29,
      20,  1992,    21,   513,  2111,  2112,  2113,  1998,  1999,   516,
     513,   360,   167,   513,  2005,  2006,   273,  2008,  1506,  2010,
     513,   513,   513,    20,   513,   513,  2017,   164,   513,  2136,
    2137,   197,   513,   513,   513,   513,   202,   513,  2029,  2030,
     513,   513,  2033,  2034,   197,   513,   395,   396,  1536,   202,
     513,    71,    72,    73,    74,    75,    76,    77,    78,  2039,
      45,   514,    15,  2054,   513,   513,   513,  2058,   521,   513,
     513,  2062,   163,   513,    18,    95,   513,  2068,    98,   513,
      29,    29,   517,   249,   250,  1929,  2077,  2088,  2089,   516,
      15,    15,    20,   113,    34,     3,    15,  1941,  1942,  1943,
       3,  1945,     3,     3,     3,     3,     3,     3,     3,  2273,
    2274,     3,   513,    20,   138,   135,   515,    21,   515,  2283,
    2111,  2112,  2113,   516,   514,   513,   513,   513,  2119,   513,
     513,   521,     8,     9,    10,    11,    12,   513,  2129,  2130,
    2131,  2132,  2133,   513,   513,  2136,  2137,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   513,   513,    34,   513,
    2151,  2152,  2153,  1651,    71,    72,    73,    74,    75,    76,
      77,    78,   513,   513,   513,   513,  2167,  2168,   268,   324,
     515,  2172,   333,   167,   307,   151,    52,   513,    95,   121,
     267,    98,  1680,  1681,  2185,   513,  2187,   513,  2189,   397,
    2191,   153,   513,  2194,  2195,   513,   113,    31,   514,    23,
     514,  2202,   369,   370,   371,   372,   373,   374,   375,   376,
     513,    31,    29,    15,  2215,  2216,  2217,   516,   135,   516,
      34,    18,     3,     3,  2225,   518,   517,   139,   348,  2230,
     163,   344,  2233,  2234,   343,   513,   513,   513,   281,   163,
      13,   268,    15,    16,    17,    18,    19,    20,    21,  2250,
    2251,    15,   517,    23,    15,    28,    29,    30,    29,   516,
      33,   517,   517,   517,     8,     9,    10,    11,    12,   517,
     513,   514,    45,   513,    47,    48,    53,    60,   521,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    33,   513,
      34,   513,    30,    30,   133,     7,  1794,   518,    20,   252,
     517,  2302,   338,   167,   143,   236,  2307,   273,  2309,   518,
    2311,     7,   513,    69,   517,    97,    31,  2318,   517,   517,
      15,   515,   513,   249,   516,   515,    99,   100,   167,   168,
     515,    30,   513,   515,   514,     7,   515,   515,   515,   514,
     113,   114,   518,   514,   514,   508,   514,   120,   121,   122,
      30,   517,   125,   246,   513,   518,   283,   517,   131,   513,
     199,   513,   427,   202,   137,   204,   427,   513,   513,   518,
       7,   515,  1870,    13,   515,    15,    16,    17,    18,    19,
      20,    21,   516,   515,   515,  1883,   515,  2241,    28,    29,
      30,   514,   231,    33,   515,   171,   235,  1895,   247,  1897,
     247,   240,   241,   247,   179,    45,   268,    47,    48,   264,
     247,   247,    20,   267,  1912,  1913,  1914,    13,   516,    15,
      16,    17,    18,    19,    20,    21,   517,   513,   401,   264,
     320,   371,    28,    29,    30,   267,   391,    33,   283,   399,
     414,   369,   419,   513,   513,   516,   417,   273,   252,    45,
     422,    47,    48,   268,   252,   513,   513,    21,   264,    99,
     100,   513,   273,    71,    72,    73,    74,    75,    76,    77,
      78,   391,   320,   113,   114,   450,   513,   273,   273,    31,
     120,   121,   122,   452,    31,   125,    21,    95,   518,   513,
      98,   131,   518,   513,   273,   518,  1994,   137,   402,   436,
     247,   273,   163,    99,   100,   113,  2004,   247,   513,   513,
     349,   513,   513,   516,   513,   515,   513,   113,   114,   378,
     513,   513,   383,   383,   120,   121,   122,   135,   513,   125,
     513,   513,   513,   513,   578,   131,     8,     9,    10,    11,
      12,   137,   932,  1351,  1837,  1584,   516,  2045,   515,   932,
     932,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    1387,  1838,    34,  1387,  1387,  2063,  2064,  1836,  1586,    13,
    1387,    15,    16,    17,    18,    19,    20,    21,   444,    78,
    1209,  1431,   627,  1925,    28,    29,   867,  2088,   164,    33,
       8,     9,    10,    11,    12,   976,  2089,   870,   868,  1721,
     517,    45,  1372,    47,    48,    23,    24,    25,    26,    27,
      28,    29,    30,    31,  1122,  1546,    34,   367,  1822,   761,
     385,  1153,  1228,  2255,  1610,  1155,   573,  1644,  1774,   515,
    1233,     8,     9,    10,    11,    12,  1042,  1661,  1667,  1038,
    2138,  1691,  1798,  2039,  2190,  2055,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    99,   100,    34,  2198,  2059,
    2058,  2200,  2160,   961,  2162,  2163,   505,   506,   999,   113,
     114,   620,  2170,   812,    -1,  2173,   120,   121,   122,    -1,
      -1,   125,    -1,    -1,    -1,    -1,    -1,   131,     8,     9,
      10,    11,    12,   137,    -1,  2193,    -1,    -1,    -1,  2197,
      -1,  2199,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2226,  2227,
      -1,  2229,    -1,    -1,    -1,    -1,    -1,  2235,    -1,  2237,
    2238,   514,     8,     9,    10,    11,    12,    -1,   521,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    34,    -1,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,
      11,    12,  2290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2299,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    34,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      34,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    34,     8,     9,
      10,    11,    12,    -1,   514,    -1,    -1,    -1,    -1,    -1,
      -1,   521,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,     8,     9,    10,    11,    12,    -1,    -1,   514,    -1,
      -1,    -1,    -1,    -1,    -1,   521,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    34,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    34,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    34,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    31,   515,    -1,    34,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    31,
     514,    -1,    34,    -1,    -1,    -1,    -1,   521,    -1,    -1,
      43,    -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    34,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    34,    -1,   515,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    34,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    34,    -1,    -1,   515,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    34,    -1,     8,     9,    10,    11,    12,    45,
      -1,    47,    48,   196,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,   515,
      34,    44,    45,    -1,    47,    48,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,   245,   246,    -1,    -1,    -1,    -1,    -1,    -1,
     253,    -1,    -1,    -1,   515,   258,    -1,    -1,   261,    -1,
      -1,    -1,    -1,   266,    -1,   212,    -1,    -1,    -1,    45,
     217,    47,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   515,   138,    -1,    -1,    -1,   142,   143,    -1,    -1,
      -1,    -1,    -1,   296,   150,    -1,   243,    -1,    -1,   155,
     156,   157,   158,   159,   160,   138,    82,    -1,   515,   142,
     143,    -1,    -1,    -1,    -1,    -1,   319,   150,    -1,    -1,
     267,    -1,   155,   156,   157,   158,   159,   160,    -1,    -1,
      -1,    -1,    -1,   280,    -1,   515,    -1,    -1,    -1,    -1,
      -1,   197,    45,    -1,    47,    48,   202,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,
      -1,    -1,   138,    -1,   197,    -1,   142,   143,    -1,   202,
     146,    -1,    -1,    -1,   150,    -1,    -1,    -1,   515,   155,
     156,   157,   158,   159,   160,    -1,    -1,   390,    -1,    -1,
      -1,    -1,   131,   132,    -1,    45,    -1,    47,    48,   138,
      -1,    -1,   258,   142,   143,   515,    -1,    -1,   411,    -1,
      -1,   150,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   197,    -1,    -1,    -1,    -1,   202,    -1,    -1,    -1,
      -1,    -1,   515,    -1,    -1,   138,    -1,    -1,    -1,   142,
     143,    -1,    -1,   446,   447,   448,   449,   150,   451,    -1,
      -1,    -1,   155,   156,   157,   158,   159,   160,   197,   515,
      -1,    -1,    -1,   202,    -1,    -1,   169,    -1,   415,   416,
      -1,    -1,    -1,   420,   421,    45,   423,    47,    48,    -1,
      -1,    -1,    -1,    -1,   431,   432,   515,    -1,   138,    -1,
      -1,    -1,   142,   143,   197,    -1,    -1,    -1,    -1,   202,
     150,    -1,    -1,    -1,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   515,    -1,   518,    -1,    -1,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,   360,   361,   362,
     363,    -1,   145,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,   400,    34,    -1,   197,    -1,    -1,
     515,    -1,   202,    -1,    -1,    -1,    -1,   390,    -1,    -1,
      -1,    -1,   212,    -1,   397,    -1,    -1,   400,   138,    -1,
     403,   518,   142,   143,    -1,   513,   146,     8,     9,    10,
     150,    45,   195,    47,    48,   155,   156,   157,   158,   159,
     160,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    34,   513,   461,    -1,    96,    -1,    -1,
      -1,   350,   351,   352,    -1,    -1,   266,    45,    -1,    47,
      48,    -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,   242,
      -1,   513,   202,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   515,   431,   432,    -1,    -1,   435,
      -1,   513,   518,    -1,   440,   315,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,   142,   143,
      -1,    -1,   146,    -1,    -1,   518,   150,    47,    48,   513,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   408,   409,   410,   411,    -1,
     138,    -1,    -1,    -1,   142,   143,    -1,    77,   146,    -1,
      -1,    -1,   150,    -1,   233,    -1,    -1,   155,   156,   157,
     158,   159,   160,   197,    -1,    -1,   349,    -1,   202,    -1,
     353,    -1,   518,    -1,    -1,    -1,    -1,    -1,   108,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,   197,
      -1,   280,    -1,    -1,   202,    -1,    -1,    -1,   138,   518,
     205,    -1,   142,   143,    -1,   145,   146,   212,    57,    -1,
     150,    -1,    -1,    -1,   407,   155,   156,   157,   158,   412,
     413,    -1,   266,    -1,    -1,    -1,    -1,   232,   168,   234,
      -1,   171,   172,    -1,    -1,   518,    -1,   242,   105,   106,
     390,   108,   109,   110,   111,   112,    -1,    -1,    -1,    -1,
     443,    -1,   257,    -1,    -1,    -1,    -1,   197,    -1,    -1,
      -1,    -1,   202,   271,   457,    -1,    -1,    -1,   461,    -1,
      -1,   211,    -1,   362,    -1,   215,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,    -1,
      -1,   380,    -1,   382,    -1,   445,    -1,   386,    -1,   388,
      -1,   241,   242,   392,   393,    -1,    -1,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,    -1,    -1,   510,    -1,    -1,
      -1,    -1,   171,    -1,    -1,    -1,   266,    -1,    -1,    -1,
      -1,    -1,   272,    -1,   274,    -1,   276,   277,    -1,   206,
     280,   281,   282,    -1,    -1,    -1,    -1,   196,   353,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,   298,    -1,
      -1,    -1,    -1,   303,   304,    -1,    -1,   216,   518,    -1,
      -1,   311,    -1,    -1,    -1,   315,    -1,    -1,   318,   319,
      -1,   321,    -1,   323,    -1,    -1,    -1,   327,   328,   238,
     330,    -1,    -1,   242,    20,    -1,   245,   246,    -1,    -1,
      -1,    -1,   269,    -1,   253,    -1,    -1,    -1,    -1,    -1,
      -1,   260,    -1,    -1,   206,    -1,   265,   266,   267,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   518,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   443,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   313,   314,    -1,    -1,
      -1,    -1,   457,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    -1,
     319,    -1,    -1,    -1,   518,    -1,    -1,   269,    50,   328,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,   356,
     357,   358,   359,    -1,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,    81,
     518,    83,    -1,   362,    -1,   364,    -1,   366,   367,   368,
      -1,   313,   314,    -1,    -1,   374,    -1,    -1,    -1,    -1,
     379,    -1,    -1,    -1,    -1,   107,    -1,    -1,    -1,    -1,
      -1,   390,    -1,   115,   116,    -1,   118,   119,    -1,   398,
      -1,    -1,    -1,    -1,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
      -1,    -1,    -1,    -1,   441,   442,    -1,    -1,   518,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   455,   456,
      -1,    -1,    -1,    -1,    -1,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    -1,    -1,    -1,   511,   512,    -1,    -1,    -1,   441,
     442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   455,   456,    45,    -1,    47,    48,   518,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,    -1,    -1,
      -1,    -1,    -1,     3,    45,    -1,    47,    48,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   511,
     512,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,   131,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     140,    -1,    -1,    -1,   144,    -1,    -1,   147,   148,    -1,
      -1,   151,    -1,    -1,    -1,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     170,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    34,    -1,    -1,    -1,   186,   187,   188,    -1,
     190,    -1,   192,   193,   155,   156,   157,   158,   159,   160,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   524,   525,   133,   143,   167,   168,   199,   202,
     204,   231,   235,   240,   241,   349,   505,   506,   680,   681,
     682,   683,   684,   686,   687,   688,   694,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   736,   747,   748,   749,
     750,   770,   808,   809,   810,   811,   812,   813,   814,   815,
     870,   871,   881,   894,   895,   896,   897,   898,   899,     0,
       3,    35,    45,    47,    48,    70,   131,   133,   134,   136,
     138,   140,   141,   143,   155,   156,   157,   158,   159,   160,
     202,   208,   214,   215,   504,   513,   526,   527,   580,   582,
     583,   584,   594,   631,   633,   634,   636,   637,   650,   653,
     663,   664,   665,   720,   723,   737,   740,   751,   757,   766,
     769,   773,   774,   817,   818,   820,   822,   823,   828,   859,
     862,   872,   873,   882,   885,   892,   893,   902,   905,   906,
      13,    15,    16,    17,    18,    19,    20,    21,    28,    29,
      33,    45,    47,    48,    99,   100,   113,   114,   120,   121,
     122,   125,   131,   137,   514,   521,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   577,   578,
     579,   599,   615,   617,   618,   619,   621,   623,    20,    21,
     144,   717,   717,   717,   200,   201,   717,   717,     3,   176,
     177,   205,   212,   232,   234,   242,   257,   353,   443,   457,
     153,   174,   176,   177,   236,   237,   238,   239,    37,   144,
     517,   706,   717,   235,    21,   266,   499,   501,   502,   900,
       3,    20,    20,    20,   623,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    89,    90,    91,    92,    93,    94,
     585,   514,   139,   176,   191,   503,   161,    20,    21,   176,
     553,   140,   212,   213,   214,   651,   652,   884,   167,   446,
     494,   151,   145,   195,   242,   257,   349,   353,   407,   412,
     413,   443,   457,   461,   510,   772,   858,    20,    46,   638,
     138,   142,   143,   146,   150,   197,   202,   266,   518,   634,
     639,   640,   645,   667,   638,   638,   638,    47,    48,    77,
     108,   145,   146,   155,   156,   157,   158,   168,   171,   172,
     211,   215,   241,   242,   249,   250,   252,   266,   272,   274,
     276,   277,   280,   281,   282,   297,   298,   303,   304,   311,
     315,   318,   319,   321,   323,   327,   328,   330,   518,   639,
     758,   759,   765,   638,   638,    44,   360,   361,   362,   363,
     390,   397,   400,   403,   518,   634,   639,   776,   777,   778,
     779,   780,   638,   169,   408,   409,   410,   411,   518,   639,
     645,   819,   517,   113,   147,   148,   151,   162,   341,   518,
     639,   641,   638,   638,   638,   212,   266,   315,   518,   639,
     645,   876,   877,   215,   258,   400,   461,   507,   508,   509,
     518,   639,   645,   883,   904,   638,   638,   146,   508,   518,
     639,   907,    15,    20,    30,   514,   520,   614,   616,   621,
      31,   533,    31,    17,    18,   534,   535,   514,   130,    29,
     130,   623,    15,   517,   517,   514,   514,   514,   514,   514,
     514,   514,   101,   102,   103,   104,   604,   623,    15,    16,
      18,    19,    20,   514,   534,   535,   542,   599,   600,   603,
     605,   606,   607,   609,   611,   612,   217,   217,    46,    51,
     105,   106,   108,   109,   110,   111,   112,   206,   269,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   313,
     314,   356,   357,   358,   359,   441,   442,   455,   456,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   511,   512,   622,
     719,     3,     8,     9,    10,    11,    12,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    34,    37,   144,   517,
     668,    21,   554,   554,   717,   717,     3,    37,   144,   517,
     671,    20,    21,   144,   718,     3,   233,     3,   689,     3,
     695,   256,   153,   177,   238,   270,    20,   146,   238,   389,
     405,   406,   685,   177,   238,   685,     3,     3,     3,     3,
       3,     3,     3,     3,    77,   143,   491,   492,   493,   494,
     495,   496,   497,   890,   891,    15,   707,   554,   771,   900,
     900,     3,     3,   446,   901,    23,   595,   581,    20,    88,
      20,    15,    17,    20,    46,   514,   632,   668,    15,    20,
     514,   528,    36,    37,    38,    39,   163,   528,   530,   671,
     513,    21,   209,   513,   490,   498,   553,   888,   216,   528,
     529,   529,    20,   354,   355,   821,   444,    46,    20,   517,
     139,   530,   668,   666,   553,   553,   671,   267,   513,   517,
     643,   513,   513,   517,   517,   517,   216,   284,   296,   513,
      21,    45,   332,    45,   332,    45,   332,    45,   332,   285,
     553,   530,   333,   167,   212,   301,   326,   215,   530,   513,
     528,    17,    18,    20,   531,   753,   531,   752,   267,   273,
     275,   283,   273,   272,   287,   288,   258,   283,   299,   300,
     299,   530,   305,   312,   258,   258,   320,   318,   252,   287,
     530,   329,   331,   528,   513,   517,   763,   513,   517,   517,
     404,   632,   530,   138,   528,   530,   139,   388,   530,   332,
     775,   643,   513,   517,   517,   530,    46,   173,    15,   217,
     243,   147,   148,   513,   513,   528,   131,   132,   144,   149,
     163,   169,   591,   647,   163,   647,    20,   646,   163,   151,
     513,   513,   517,   517,   517,    18,    19,    20,   545,   548,
     267,   151,   513,   513,    76,   278,   308,   317,   458,   459,
     460,   874,   875,   517,   880,   167,   528,   324,   151,   530,
     273,   530,   513,   513,   517,   517,   908,   912,   273,   513,
       7,   616,   616,   623,   616,   616,    14,    15,    15,    31,
     623,   627,   628,    28,    29,   130,    29,   574,   574,   646,
     623,   623,   623,   623,   623,   623,    15,   516,   515,   516,
      30,   602,   604,   623,    28,    29,   517,     7,   516,   522,
     516,   522,    15,    15,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,    50,    57,
      81,    83,   107,   115,   116,   118,   119,   126,   127,   128,
     152,   153,   154,   174,   175,   177,   669,   670,     3,     3,
       3,     3,     3,   152,   203,   672,   673,     3,   718,     3,
       3,     3,   131,   140,   144,   147,   148,   151,   170,   186,
     187,   188,   190,   192,   193,   548,   591,   692,     3,    20,
      70,   131,   140,   141,   151,   685,   685,   685,   685,   685,
     685,   685,   816,   144,   685,   144,   685,     3,   685,   685,
       3,   516,   518,     3,     3,     3,   131,   151,   173,   591,
       3,   901,   528,     3,   623,   514,   592,   585,   586,   587,
     589,   593,   513,   516,   660,   661,   623,   513,   623,   529,
     513,   528,   210,   211,   500,   886,   528,   887,   144,   517,
     889,   528,    40,    41,    42,   198,   635,   638,    20,   632,
     654,   657,   658,   530,   642,   644,   722,   739,   273,   273,
     531,   513,    77,   337,   513,   513,   215,   334,   273,   325,
     530,   310,   530,   203,   513,   513,   513,    32,   532,    43,
     219,   513,   532,    43,   219,   513,   530,   528,   273,   273,
     528,   273,   528,   528,   530,   273,   530,   139,   530,   513,
     530,   530,   530,   530,   530,   530,   219,   530,   513,   530,
     530,   513,   762,   764,   768,   530,   530,   163,   528,   530,
     644,   781,    15,    15,   529,   529,    20,   589,   590,   623,
      37,   528,   649,   170,   649,   649,   646,   827,   861,   530,
     646,    21,   531,   531,    45,   242,   391,   429,   874,   879,
     513,   530,   530,   528,   528,   658,   659,   528,    15,   515,
      46,    15,   516,   515,   130,    29,   575,   576,   515,   516,
     515,   516,   516,   516,   516,   515,   623,   623,   516,     7,
     516,   516,   515,    15,    17,    18,   514,   600,   607,   611,
     219,   219,   514,   516,   518,   516,   518,     3,   590,    20,
     151,    20,   144,    17,    18,    19,    20,   534,   535,   536,
     537,   538,   690,   691,    20,     3,   554,   554,   554,   554,
     554,   554,     3,    20,    57,   138,   267,   279,   360,   395,
     396,   685,   554,   685,   554,   554,   554,   891,   590,    21,
     646,   553,     3,   513,   515,   586,   588,   593,    20,   513,
     517,   553,   658,   513,   515,   515,    21,    41,    42,    41,
      42,   553,   553,   890,   513,   513,    29,   656,   516,   513,
     518,   641,   146,   249,   250,   518,   639,   721,   146,   271,
     518,   639,   645,   738,   528,   528,   513,   530,   517,   530,
     754,   167,   273,   528,   513,   513,   530,   513,   530,    20,
     753,   528,   528,   752,   528,   528,   513,   513,   528,   528,
     513,   528,   513,   513,   513,   528,   513,   632,   513,   513,
     513,   513,   513,   513,   513,   513,   528,   513,   513,   513,
      52,   121,   147,   211,   215,   306,   315,   316,   322,   326,
     518,   641,   761,   131,   151,   350,   351,   352,   518,   591,
     639,   767,   528,   146,   233,   280,   362,   380,   382,   386,
     388,   392,   393,   518,   782,   789,   792,   164,   648,   530,
     513,    82,   146,   431,   432,   435,   440,   518,   639,   645,
     824,   146,   390,   445,   518,   639,   645,   860,   513,   513,
     532,    45,    15,   550,   551,   530,   528,   530,    20,    71,
      72,    73,    74,    75,    76,    77,    78,    95,    98,   113,
     135,   518,   619,   620,   624,   629,   878,   163,   903,   517,
     911,   616,    18,   627,    29,    29,   572,   573,   623,   623,
     623,   623,   623,   516,   515,   516,    30,   602,   623,   602,
      30,   602,   602,   516,   623,    15,    15,   623,   670,   673,
      20,    46,    17,    18,    34,     3,     3,     3,     3,     3,
       3,    15,   632,   632,   632,   554,     3,   554,     3,     3,
       3,   513,   515,   587,   596,   597,   629,   515,   518,    21,
     554,   655,   657,   513,   724,   730,   724,   731,   531,   735,
     513,   741,   746,   138,   513,   516,   513,   513,    82,   201,
     337,   339,   341,   342,   345,   755,   756,   513,   325,   530,
     528,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   513,   268,   324,   151,   333,   167,   307,   151,   145,
     317,   530,    52,   513,   590,    21,   646,   553,   528,   121,
     513,   801,   807,   530,   364,   365,   392,   364,   530,   783,
     267,    20,   542,   547,   785,   786,   784,   394,   530,   513,
     397,   802,   165,   166,   167,   168,    20,   535,   546,   838,
     843,   829,   837,   825,   826,   546,   153,   513,   863,   869,
     530,   528,   513,   551,    31,    23,   514,   514,   623,   623,
     623,    23,   514,   622,   719,   513,   623,   625,   626,   528,
     910,    31,    29,    43,    49,    50,    51,    52,    54,    55,
      56,    59,    61,    62,    67,   518,   557,   558,   559,   560,
     562,   570,    68,   518,   558,   559,   560,   561,   562,   571,
     516,   515,   515,   515,   515,   623,   623,   515,   516,     7,
     515,   516,   515,   516,     7,   515,   516,   516,    15,   515,
      34,    18,    45,    47,    48,   155,   156,   157,   158,   159,
     160,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   693,     3,     3,   588,   518,   629,    17,    18,
      20,   534,   535,   549,   659,   517,   729,    32,   251,   732,
     659,   139,   528,   163,   348,   124,   340,   344,   343,   346,
     347,   516,   518,   513,   513,   513,   169,   279,   296,   245,
     246,   530,   530,   215,   334,   530,   279,   308,   309,   646,
     268,   281,   658,   803,   528,   528,   530,   528,   517,   632,
     517,   517,   528,   528,   517,   517,   842,   659,   517,   531,
     844,   849,    21,   517,   850,   855,   530,   659,   163,    15,
     623,   628,   619,   513,    96,   517,   623,   630,    23,    23,
      34,   516,   513,   425,   518,   909,    15,    29,    53,    57,
      58,    60,     8,     9,    10,    23,    24,    25,    99,   100,
     528,   555,   563,   564,   565,    33,   566,   567,   567,   569,
     547,   513,   563,   566,   569,   566,   546,   513,   623,   515,
     515,    30,   602,    30,   602,    30,   602,     7,    30,   602,
      30,   602,   518,   693,   729,   728,   725,    20,   553,   252,
     733,   517,   745,   530,   513,   338,   236,   756,   335,   336,
     530,   760,   760,   531,   167,   273,   530,   530,   804,   517,
     806,   794,   787,   794,   790,   841,   840,   517,   836,   845,
     851,   517,   868,   528,   513,   515,   719,   517,   598,   629,
     613,   513,   623,   623,   623,   121,   122,   125,   130,   131,
     626,   531,   513,     7,   528,    11,    12,   556,   516,    12,
     516,   556,   528,    63,    64,    65,    66,   568,   516,   556,
      69,   515,   515,   515,   515,   516,     7,   515,   515,   515,
     516,   514,   515,     7,   515,   515,     7,   515,   725,   171,
     172,   196,   243,   244,   247,   248,   253,   518,   674,   676,
     677,   726,   531,   249,   734,   744,   742,   530,   528,   802,
     805,   518,   547,   795,   796,   233,   364,   381,   518,   788,
     518,   216,   253,   260,   366,   367,   368,   518,   674,   791,
     424,   425,   428,   429,   430,   518,   839,   835,   834,   848,
     854,   867,   864,   515,   596,    97,     6,    15,    16,   514,
     518,   599,   601,   603,   605,   606,   608,   610,   630,   513,
     513,   514,   514,   514,   513,   514,   528,   565,   555,   564,
     567,   567,    31,   567,   567,    15,    30,   602,    30,   602,
     602,     7,   602,   553,   530,   517,   245,   246,   246,   529,
     528,   149,   179,   254,   255,   727,   517,   513,   530,    43,
      52,    57,   163,   245,   246,   259,   260,   261,   266,   518,
     743,    57,   216,   238,   242,   245,   246,   253,   260,   265,
     266,   267,   319,   328,   362,   364,   366,   367,   368,   374,
     379,   390,   398,   518,   674,   793,   381,   387,   797,   530,
     528,   530,   513,   528,   149,   254,   377,   528,   528,   283,
     188,   528,   513,   427,   427,   530,   530,   530,   513,    82,
     212,   217,   243,   267,   280,   415,   416,   420,   421,   423,
     431,   432,   518,   830,   427,   433,   518,   846,   427,   434,
     518,   852,    43,   172,   242,   245,   246,   253,   258,   261,
     266,   296,   319,   390,   411,   446,   447,   448,   449,   451,
     518,   674,   865,   513,   518,   598,   596,   623,     7,   516,
     519,   515,   623,   623,   623,   623,   528,   528,   528,   528,
     568,   568,   515,   515,   515,   516,   515,   514,   515,   675,
     676,   247,   247,   247,   181,   182,   179,    46,    75,   139,
     173,   178,   194,   678,   528,   268,   262,   263,   528,   264,
      61,    62,   207,   265,   662,   528,   247,   247,   267,   513,
     369,   370,   371,   372,   373,   374,   375,   376,   528,   517,
     530,   264,    61,   265,   662,   149,   254,   377,   528,   528,
     267,   401,   320,   371,   530,   528,   528,   283,   188,   528,
     399,   528,   391,   369,   513,   528,   513,   528,   528,   528,
     528,   418,   843,   113,   418,   427,   414,   283,   414,   419,
     113,   427,   530,   417,   273,   422,   268,   252,   831,   252,
     832,   513,   426,   528,   856,   844,   847,   513,   856,   850,
     853,   513,   528,   530,   530,   264,    61,   265,   662,   149,
     181,   377,   454,   866,   528,   273,   267,   453,   531,   320,
     391,   332,   369,   273,   273,   383,   528,   450,   452,   513,
     515,   514,   601,   608,   596,   513,   515,   515,   515,   515,
      31,    31,   602,   602,   518,   513,   529,   529,   529,   181,
     182,    21,   552,    46,   173,   528,   552,   179,   180,   679,
      46,   173,   518,   155,   156,   528,   528,   528,   528,   528,
     529,   529,   530,   798,   384,   385,   528,   528,   528,   530,
     402,   246,   530,   530,   528,   528,   530,   528,   530,   436,
     857,   857,   273,   437,   438,   439,   833,   273,   528,   247,
     528,   247,   528,   833,   528,   530,   528,   528,   163,   530,
     849,   530,   855,   528,   528,   528,   528,   528,   530,   530,
     246,   530,   528,   528,   528,   530,   530,   530,   623,   513,
     513,   513,   513,   528,   528,   515,   516,   675,   513,   552,
     552,   513,   513,   181,   182,   183,   184,   185,   181,   182,
     183,   184,   185,   513,   552,   552,   531,   531,   518,   531,
     800,   530,   383,   530,   528,   528,   857,   528,   528,   857,
     528,   383,   602,   678,   513,   513,   678,   678,   678,   513,
     513,   378,   799,   516,   678,   678,   678,   678,   513,   602,
     515
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 1085 "obj/conf/cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 1086 "obj/conf/cf-parse.y"
    { return 0; ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 1102 "obj/conf/cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 1112 "obj/conf/cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 1113 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 1120 "obj/conf/cf-parse.y"
    { (yyval.time) = (yyvsp[(1) - (2)].i) S_; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 1121 "obj/conf/cf-parse.y"
    { (yyval.time) = (yyvsp[(1) - (2)].i) MS_; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 1122 "obj/conf/cf-parse.y"
    { (yyval.time) = (yyvsp[(1) - (2)].i) US_; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 1128 "obj/conf/cf-parse.y"
    { (yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 1129 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 1130 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 1131 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 1132 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 1133 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 1140 "obj/conf/cf-parse.y"
    { (yyval.a) = ipa_from_ip4((yyvsp[(1) - (1)].ip4)); ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 1141 "obj/conf/cf-parse.y"
    { (yyval.a) = ipa_from_ip6((yyvsp[(1) - (1)].ip6)); ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 1142 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).ip;
   ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 1149 "obj/conf/cf-parse.y"
    { (yyval.iface) = NULL; ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 1150 "obj/conf/cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 1157 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) > IP4_MAX_PREFIX_LENGTH) cf_error("Invalid prefix length %u", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 1164 "obj/conf/cf-parse.y"
    {
  net_fill_ip4(&((yyval.net)), (yyvsp[(1) - (2)].ip4), (yyvsp[(2) - (2)].i));

  net_addr_ip4 *n = (void *) &((yyval.net));
  if (!net_validate_ip4(n))
    cf_error("Invalid IPv4 prefix %I4/%d, maybe you wanted %I4/%d",
	     n->prefix, n->pxlen, ip4_and(n->prefix, ip4_mkmask(n->pxlen)), n->pxlen);
;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 1174 "obj/conf/cf-parse.y"
    {
  if ((yyvsp[(3) - (3)].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[(3) - (3)].i));

  net_fill_ip6(&((yyval.net)), (yyvsp[(1) - (3)].ip6), (yyvsp[(3) - (3)].i));

  net_addr_ip6 *n = (void *) &((yyval.net));
  if (!net_validate_ip6(n))
    cf_error("Invalid IPv6 prefix %I6/%d, maybe you wanted %I6/%d",
	     n->prefix, n->pxlen, ip6_and(n->prefix, ip6_mkmask(n->pxlen)), n->pxlen);
;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 1187 "obj/conf/cf-parse.y"
    {
  if ((yyvsp[(3) - (7)].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[(3) - (7)].i));

  if ((yyvsp[(7) - (7)].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[(7) - (7)].i));

  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
  net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[(1) - (7)].ip6), (yyvsp[(3) - (7)].i), (yyvsp[(5) - (7)].ip6), (yyvsp[(7) - (7)].i));

  net_addr_ip6_sadr *n = (void *) (yyval.net_ptr);
  if (!net_validate_ip6_sadr(n))
    cf_error("Invalid SADR IPv6 prefix %I6/%d from %I6/%d, maybe you wanted %I6/%d from %I6/%d",
	     n->dst_prefix, n->dst_pxlen, n->src_prefix, n->src_pxlen,
	     ip6_and(n->dst_prefix, ip6_mkmask(n->dst_pxlen)), n->dst_pxlen,
	     ip6_and(n->src_prefix, ip6_mkmask(n->src_pxlen)), n->src_pxlen);
;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 1206 "obj/conf/cf-parse.y"
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
  net_fill_vpn4((yyval.net_ptr), net4_prefix(&(yyvsp[(2) - (2)].net)), net4_pxlen(&(yyvsp[(2) - (2)].net)), (yyvsp[(1) - (2)].i64));
;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 1212 "obj/conf/cf-parse.y"
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
  net_fill_vpn6((yyval.net_ptr), net6_prefix(&(yyvsp[(2) - (2)].net)), net6_pxlen(&(yyvsp[(2) - (2)].net)), (yyvsp[(1) - (2)].i64));
;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 1218 "obj/conf/cf-parse.y"
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa4));
  net_fill_roa4((yyval.net_ptr), net4_prefix(&(yyvsp[(1) - (5)].net)), net4_pxlen(&(yyvsp[(1) - (5)].net)), (yyvsp[(3) - (5)].i), (yyvsp[(5) - (5)].i));
  if ((yyvsp[(3) - (5)].i) < net4_pxlen(&(yyvsp[(1) - (5)].net)) || (yyvsp[(3) - (5)].i) > IP4_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[(3) - (5)].i));
;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 1226 "obj/conf/cf-parse.y"
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_roa6((yyval.net_ptr), net6_prefix(&(yyvsp[(1) - (5)].net)), net6_pxlen(&(yyvsp[(1) - (5)].net)), (yyvsp[(3) - (5)].i), (yyvsp[(5) - (5)].i));
  if ((yyvsp[(3) - (5)].i) < net6_pxlen(&(yyvsp[(1) - (5)].net)) || (yyvsp[(3) - (5)].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[(3) - (5)].i));
;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 1234 "obj/conf/cf-parse.y"
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_mpls((yyval.net_ptr), (yyvsp[(2) - (2)].i));
;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 1244 "obj/conf/cf-parse.y"
    { (yyval.net_ptr) = cfg_alloc((yyvsp[(1) - (1)].net).length); net_copy((yyval.net_ptr), &((yyvsp[(1) - (1)].net))); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 1257 "obj/conf/cf-parse.y"
    {
     if (((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[(1) - (1)].s)).net->type != NET_IP6))
       cf_error("IPv6 network expected");
     (yyval.net) = * SYM_VAL((yyvsp[(1) - (1)].s)).net;
   ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 1266 "obj/conf/cf-parse.y"
    {
     if (((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_NET)) || !net_is_ip(SYM_VAL((yyvsp[(1) - (1)].s)).net))
       cf_error("IP network expected");
     (yyval.net) = * SYM_VAL((yyvsp[(1) - (1)].s)).net;
   ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 1275 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_NET))
       cf_error("Network expected");
     (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[(1) - (1)].s)).net; /* Avoid const warning */
   ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 1285 "obj/conf/cf-parse.y"
    { net_fill_ip4(&((yyval.net)), (yyvsp[(1) - (1)].ip4), IP4_MAX_PREFIX_LENGTH); ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 1286 "obj/conf/cf-parse.y"
    { net_fill_ip6(&((yyval.net)), (yyvsp[(1) - (1)].ip6), IP6_MAX_PREFIX_LENGTH); ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 1287 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP))
       net_fill_ip_host(&((yyval.net)), SYM_VAL((yyvsp[(1) - (1)].s)).ip);
     else if (((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_NET)) && net_is_ip(SYM_VAL((yyvsp[(1) - (1)].s)).net))
       (yyval.net) = * SYM_VAL((yyvsp[(1) - (1)].s)).net;
     else
       cf_error("IP address or network expected");
   ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 1298 "obj/conf/cf-parse.y"
    {
  (yyval.mls) = cfg_allocz(sizeof(mpls_label_stack));
  (yyval.mls)->len = 1;
  (yyval.mls)->stack[0] = (yyvsp[(1) - (1)].i);
;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1306 "obj/conf/cf-parse.y"
    {
    if ((yyvsp[(1) - (3)].mls)->len >= MPLS_MAX_LABEL_STACK)
      cf_error("Too many labels in stack");
    (yyvsp[(1) - (3)].mls)->stack[(yyvsp[(1) - (3)].mls)->len++] = (yyvsp[(3) - (3)].i);
    (yyval.mls) = (yyvsp[(1) - (3)].mls);
  ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1315 "obj/conf/cf-parse.y"
    {
     (yyval.time) = tm_parse_time((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date/time");
   ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1324 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1332 "obj/conf/cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1341 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_TRUE; ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1342 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_EQ;  ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1343 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_NEQ; ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1344 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_LT;  ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1345 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_LEQ; ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1346 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_GT;  ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1347 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_GEQ; ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1348 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_FALSE; ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1352 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_OR; ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1353 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_OP_AND; ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1357 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_IP_PROTOCOL; ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1358 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_NEXT_HEADER; ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1359 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_PORT; ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1360 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_DST_PORT; ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1361 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_SRC_PORT; ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1362 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_ICMP_TYPE; ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1363 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_ICMP_CODE; ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1364 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_PACKET_LENGTH; ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1365 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_DSCP; ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1368 "obj/conf/cf-parse.y"
    { flow_builder_set_type(this_flow, (yyvsp[(1) - (1)].i32)); ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1369 "obj/conf/cf-parse.y"
    { flow_builder_set_type(this_flow, FLOW_TYPE_TCP_FLAGS); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1370 "obj/conf/cf-parse.y"
    { flow_builder_set_type(this_flow, FLOW_TYPE_FRAGMENT); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1371 "obj/conf/cf-parse.y"
    { flow_builder_set_type(this_flow, FLOW_TYPE_LABEL); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1374 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_DST_PREFIX; ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1375 "obj/conf/cf-parse.y"
    { (yyval.i32) = FLOW_TYPE_SRC_PREFIX; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1379 "obj/conf/cf-parse.y"
    {
     flow_check_cf_value_length(this_flow, (yyvsp[(2) - (2)].i));
     flow_builder_add_op_val(this_flow, (yyvsp[(1) - (2)].i32), (yyvsp[(2) - (2)].i));
   ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1383 "obj/conf/cf-parse.y"
    {
     flow_check_cf_value_length(this_flow, (yyvsp[(4) - (4)].i));
     flow_builder_add_op_val(this_flow, (yyvsp[(2) - (4)].i32) | (yyvsp[(3) - (4)].i32), (yyvsp[(4) - (4)].i));
   ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1392 "obj/conf/cf-parse.y"
    {
     flow_check_cf_value_length(this_flow, (yyvsp[(1) - (1)].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_EQ, (yyvsp[(1) - (1)].i));
   ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1396 "obj/conf/cf-parse.y"
    {
     flow_check_cf_value_length(this_flow, (yyvsp[(1) - (3)].i));
     flow_check_cf_value_length(this_flow, (yyvsp[(3) - (3)].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_GEQ, (yyvsp[(1) - (3)].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_AND | FLOW_OP_LEQ, (yyvsp[(3) - (3)].i));
   ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1410 "obj/conf/cf-parse.y"
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[(1) - (4)].i32), (yyvsp[(2) - (4)].i), (yyvsp[(4) - (4)].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[(1) - (4)].i32), (yyvsp[(2) - (4)].i), (yyvsp[(4) - (4)].i));
   ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1414 "obj/conf/cf-parse.y"
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[(3) - (6)].i32), (yyvsp[(4) - (6)].i), (yyvsp[(6) - (6)].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[(2) - (6)].i32) | (yyvsp[(3) - (6)].i32), (yyvsp[(4) - (6)].i), (yyvsp[(6) - (6)].i));
   ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1418 "obj/conf/cf-parse.y"
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[(3) - (6)].i32), (yyvsp[(4) - (6)].i), (yyvsp[(6) - (6)].i));
     flow_builder_add_val_mask(this_flow, 0x40 | (yyvsp[(3) - (6)].i32), (yyvsp[(4) - (6)].i), (yyvsp[(6) - (6)].i)); /* AND */
   ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1425 "obj/conf/cf-parse.y"
    { (yyval.i32) = 0x00; ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1426 "obj/conf/cf-parse.y"
    { (yyval.i32) = 0x02; ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1430 "obj/conf/cf-parse.y"
    { (yyval.i32) = 1; ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1431 "obj/conf/cf-parse.y"
    { (yyval.i32) = 2; ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1432 "obj/conf/cf-parse.y"
    { (yyval.i32) = 4; ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1433 "obj/conf/cf-parse.y"
    { (yyval.i32) = 8; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1437 "obj/conf/cf-parse.y"
    {
     flow_builder_add_val_mask(this_flow, 0, ((yyvsp[(1) - (2)].i32) ? 0 : (yyvsp[(2) - (2)].i32)), (yyvsp[(2) - (2)].i32));
   ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1440 "obj/conf/cf-parse.y"
    {
     flow_builder_add_val_mask(this_flow, (yyvsp[(2) - (4)].i32), ((yyvsp[(3) - (4)].i32) ? 0 : (yyvsp[(4) - (4)].i32)), (yyvsp[(4) - (4)].i32));
   ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1443 "obj/conf/cf-parse.y"
    {
     flow_builder_add_val_mask(this_flow, 0x40, ((yyvsp[(3) - (4)].i32) ? 0 : (yyvsp[(4) - (4)].i32)), (yyvsp[(4) - (4)].i32)); /* AND */
   ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1449 "obj/conf/cf-parse.y"
    {
     flow_builder_set_type(this_flow, (yyvsp[(1) - (2)].i32));
     flow_builder4_add_pfx(this_flow, (net_addr_ip4 *) &((yyvsp[(2) - (2)].net)));
   ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1459 "obj/conf/cf-parse.y"
    {
     flow_builder_set_type(this_flow, (yyvsp[(1) - (2)].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[(2) - (2)].net)), 0);
   ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1463 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(4) - (4)].i) > (yyvsp[(2) - (4)].net).pxlen)
       cf_error("Prefix offset is higher than prefix length");
     flow_builder_set_type(this_flow, (yyvsp[(1) - (4)].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[(2) - (4)].net)), (yyvsp[(4) - (4)].i));
   ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1486 "obj/conf/cf-parse.y"
    {
  if (this_flow == NULL)
    this_flow = flow_builder_init(&root_pool);
  else
    flow_builder_clear(this_flow);
;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1493 "obj/conf/cf-parse.y"
    { this_flow->ipv6 = 0; ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1494 "obj/conf/cf-parse.y"
    { this_flow->ipv6 = 1; ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1497 "obj/conf/cf-parse.y"
    {
  (yyval.net_ptr) = (net_addr *) flow_builder4_finalize(this_flow, cfg_mem);
  flow4_validate_cf((net_addr_flow4 *) (yyval.net_ptr));
;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1503 "obj/conf/cf-parse.y"
    {
  (yyval.net_ptr) = (net_addr *) flow_builder6_finalize(this_flow, cfg_mem);
  flow6_validate_cf((net_addr_flow6 *) (yyval.net_ptr));
;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1515 "obj/conf/cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1516 "obj/conf/cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1526 "obj/conf/cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1530 "obj/conf/cf-parse.y"
    {
  cf_define_symbol((yyvsp[(3) - (4)].s), SYM_ATTRIBUTE, ca_lookup(new_config->pool, (yyvsp[(3) - (4)].s)->name, (yyvsp[(2) - (4)].i))->fda);
;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1536 "obj/conf/cf-parse.y"
    {
  if (!((yyvsp[(3) - (6)].s)->class & SYM_FUNCTION))
    cf_error("Function expected");

  struct f_bt_test_suite *t = cfg_alloc(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[(3) - (6)].s)->def;
  t->fn_name = (yyvsp[(3) - (6)].s)->name;
  t->dsc = (yyvsp[(5) - (6)].t);

  add_tail(&new_config->tests, &t->n);
 ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1550 "obj/conf/cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1551 "obj/conf/cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1552 "obj/conf/cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1553 "obj/conf/cf-parse.y"
    { (yyval.i) = T_RD; ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1554 "obj/conf/cf-parse.y"
    { (yyval.i) = T_NET; ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1555 "obj/conf/cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1556 "obj/conf/cf-parse.y"
    { (yyval.i) = T_QUAD; ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1557 "obj/conf/cf-parse.y"
    { (yyval.i) = T_EC; ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1558 "obj/conf/cf-parse.y"
    { (yyval.i) = T_LC; ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1559 "obj/conf/cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1560 "obj/conf/cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1561 "obj/conf/cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1562 "obj/conf/cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1563 "obj/conf/cf-parse.y"
    { (yyval.i) = T_ECLIST; ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1564 "obj/conf/cf-parse.y"
    { (yyval.i) = T_LCLIST; ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1565 "obj/conf/cf-parse.y"
    {
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_RD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_NET:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1588 "obj/conf/cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1599 "obj/conf/cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1600 "obj/conf/cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1607 "obj/conf/cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1608 "obj/conf/cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1615 "obj/conf/cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1624 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1632 "obj/conf/cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1653 "obj/conf/cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1654 "obj/conf/cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1658 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1671 "obj/conf/cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1674 "obj/conf/cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name);
     cf_pop_scope();
   ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1687 "obj/conf/cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1688 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1691 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1692 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1696 "obj/conf/cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1699 "obj/conf/cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1708 "obj/conf/cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[(1) - (1)].ip4)); ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1709 "obj/conf/cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[(1) - (1)].ip6)); ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1722 "obj/conf/cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1723 "obj/conf/cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1724 "obj/conf/cf-parse.y"
    { (yyval.v).type = T_RD; (yyval.v).val.ec = (yyvsp[(1) - (1)].i64); ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1725 "obj/conf/cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1726 "obj/conf/cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1730 "obj/conf/cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1738 "obj/conf/cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1739 "obj/conf/cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1740 "obj/conf/cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1741 "obj/conf/cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1745 "obj/conf/cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1748 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1749 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1750 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), 0, CC_ALL); ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1751 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1752 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1753 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, CC_ALL); ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1754 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1755 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1756 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1758 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (11)].i32), (yyvsp[(8) - (11)].i32), (yyvsp[(4) - (11)].i32), (yyvsp[(10) - (11)].i32)); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1762 "obj/conf/cf-parse.y"
    { (yyval.i) = EC_RT; ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1763 "obj/conf/cf-parse.y"
    { (yyval.i) = EC_RO; ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1764 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1765 "obj/conf/cf-parse.y"
    { (yyval.i) = EC_GENERIC; ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1769 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1770 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1771 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1775 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1776 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1777 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, LC_ALL); ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1778 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), 0, LC_ALL); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1779 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), 0, LC_ALL, 0, LC_ALL); ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1780 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), 0, LC_ALL, 0, LC_ALL); ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1781 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1783 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (15)].i32), (yyvsp[(10) - (15)].i32), (yyvsp[(4) - (15)].i32), (yyvsp[(12) - (15)].i32), (yyvsp[(6) - (15)].i32), (yyvsp[(14) - (15)].i32)); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1790 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1791 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1798 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1799 "obj/conf/cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1804 "obj/conf/cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1809 "obj/conf/cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1813 "obj/conf/cf-parse.y"
    { (yyval.px).net = (yyvsp[(1) - (1)].net); (yyval.px).lo = (yyvsp[(1) - (1)].net).pxlen; (yyval.px).hi = (yyvsp[(1) - (1)].net).pxlen; ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1814 "obj/conf/cf-parse.y"
    { (yyval.px).net = (yyvsp[(1) - (2)].net); (yyval.px).lo = (yyvsp[(1) - (2)].net).pxlen; (yyval.px).hi = net_max_prefix_length[(yyvsp[(1) - (2)].net).type]; ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1815 "obj/conf/cf-parse.y"
    { (yyval.px).net = (yyvsp[(1) - (2)].net); (yyval.px).lo = 0; (yyval.px).hi = (yyvsp[(1) - (2)].net).pxlen; ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1816 "obj/conf/cf-parse.y"
    {
     (yyval.px).net = (yyvsp[(1) - (6)].net); (yyval.px).lo = (yyvsp[(3) - (6)].i); (yyval.px).hi = (yyvsp[(5) - (6)].i);
     if (((yyvsp[(3) - (6)].i) > (yyvsp[(5) - (6)].i)) || ((yyvsp[(5) - (6)].i) > net_max_prefix_length[(yyvsp[(1) - (6)].net).type]))
       cf_error("Invalid prefix pattern range: {%u, %u}", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
   ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1824 "obj/conf/cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_prefix((yyval.trie), &((yyvsp[(1) - (1)].px).net), (yyvsp[(1) - (1)].px).lo, (yyvsp[(1) - (1)].px).hi); ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1825 "obj/conf/cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_prefix((yyval.trie), &((yyvsp[(3) - (3)].px).net), (yyvsp[(3) - (3)].px).lo, (yyvsp[(3) - (3)].px).hi); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1828 "obj/conf/cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1829 "obj/conf/cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1836 "obj/conf/cf-parse.y"
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1848 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1849 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1853 "obj/conf/cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1857 "obj/conf/cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1858 "obj/conf/cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(4) - (4)].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[(1) - (4)].i); (yyval.h)->val2 = (yyvsp[(3) - (4)].i); ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1859 "obj/conf/cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1860 "obj/conf/cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1861 "obj/conf/cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1862 "obj/conf/cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1866 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1867 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1868 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1869 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1870 "obj/conf/cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1871 "obj/conf/cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); val->type = T_RD; val->val.ec = (yyvsp[(1) - (1)].i64); (yyval.x)->a1.p = val; ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1872 "obj/conf/cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); val->type = T_NET; val->val.net = (yyvsp[(1) - (1)].net_ptr); (yyval.x)->a1.p = val; ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1873 "obj/conf/cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1874 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1875 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1879 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1880 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1881 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_lc((yyvsp[(2) - (7)].x), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1882 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_path_mask((yyvsp[(1) - (1)].h)); ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1890 "obj/conf/cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1912 "obj/conf/cf-parse.y"
    {
     switch ((yyvsp[(1) - (1)].s)->class & 0xffff) {
       case SYM_CONSTANT_RANGE:
         (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT);
	 goto cv_common;
       case SYM_VARIABLE_RANGE:
         (yyval.x) = f_new_inst(FI_VARIABLE);
       cv_common:
         (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
         (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       case SYM_ATTRIBUTE:
         (yyval.x) = f_new_inst_da(FI_EA_GET, *((struct f_dynamic_attr *) (yyvsp[(1) - (1)].s)->def));
	 break;
       default:
         cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }
   ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1932 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1933 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1934 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_NET,	  SA_NET,	0); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1935 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1936 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1937 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1938 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1939 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	1); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1940 "obj/conf/cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1944 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1945 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1946 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1947 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1948 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1949 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1950 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1951 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1952 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1953 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1954 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1955 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1956 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1957 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1958 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1959 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1960 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1962 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1963 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1964 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1966 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PREF_GET); ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1968 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[(2) - (2)].fsa)); ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1970 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[(2) - (2)].fda)); ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1972 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_IS_V4); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1973 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_TYPE); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1974 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1975 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_ROUTE_DISTINGUISHER); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_RD; ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1976 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1977 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_ROA_MAXLEN); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1978 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_ROA_ASN); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1979 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_SADR_SRC); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1980 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1981 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1982 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1983 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1993 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1994 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1995 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1996 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1997 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1998 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1999 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2000 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2002 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].r), NULL, NULL); ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2003 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].r), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2005 "obj/conf/cf-parse.y"
    {  (yyval.x) = f_new_inst(FI_FORMAT); (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2010 "obj/conf/cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2032 "obj/conf/cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2033 "obj/conf/cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2034 "obj/conf/cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2035 "obj/conf/cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2036 "obj/conf/cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2037 "obj/conf/cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2041 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2044 "obj/conf/cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2045 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2046 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2054 "obj/conf/cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2060 "obj/conf/cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2068 "obj/conf/cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2069 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2073 "obj/conf/cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2078 "obj/conf/cf-parse.y"
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2086 "obj/conf/cf-parse.y"
    {
     DBG( "Ook, we'll set value\n" );
     if ((yyvsp[(1) - (4)].s)->class == SYM_ATTRIBUTE) {
       (yyval.x) = f_new_inst_da(FI_EA_SET, *((struct f_dynamic_attr *) (yyvsp[(1) - (4)].s)->def));
       (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
     } else if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) == SYM_VARIABLE) {
       (yyval.x) = f_new_inst(FI_SET);
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
     } else
       cf_error( "Symbol `%s' is read-only.", (yyvsp[(1) - (4)].s)->name );
   ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2098 "obj/conf/cf-parse.y"
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2103 "obj/conf/cf-parse.y"
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[(2) - (5)].fda));
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2107 "obj/conf/cf-parse.y"
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[(2) - (5)].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2113 "obj/conf/cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2117 "obj/conf/cf-parse.y"
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[(4) - (6)].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2122 "obj/conf/cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2123 "obj/conf/cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2124 "obj/conf/cf-parse.y"
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2130 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].fda)); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2131 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2132 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2133 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2134 "obj/conf/cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2135 "obj/conf/cf-parse.y"
    { (yyval.x) = assert_done((yyvsp[(4) - (7)].x), (yyvsp[(3) - (7)].t) + 1, (yyvsp[(5) - (7)].t) - 1); ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2139 "obj/conf/cf-parse.y"
    {
  (yyval.t) = cf_text;
;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2151 "obj/conf/cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2152 "obj/conf/cf-parse.y"
    { new_config->router_id_from = this_ipatt; ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2156 "obj/conf/cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2157 "obj/conf/cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2158 "obj/conf/cf-parse.y"
    { (yyval.i32) = ip4_to_u32((yyvsp[(1) - (1)].ip4)); ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2159 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[(1) - (1)].s)).i;
     else if (((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP)) && ipa_is_ip4(SYM_VAL((yyvsp[(1) - (1)].s)).ip))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[(1) - (1)].s)).ip);
     else
       cf_error("Number or IPv4 address constant expected");
   ;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2171 "obj/conf/cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2177 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_IP4; ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2178 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_IP6; ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2179 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_IP6_SADR; ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2180 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_VPN4; ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2181 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_VPN6; ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2182 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_ROA4; ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2183 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_ROA6; ;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2184 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_FLOW4; ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2185 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_FLOW6; ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2186 "obj/conf/cf-parse.y"
    { (yyval.i) = NET_MPLS; ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2197 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2198 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2201 "obj/conf/cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(3) - (4)].s), (yyvsp[(1) - (4)].i));
   cf->sorted = (yyvsp[(4) - (4)].i);
   ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2211 "obj/conf/cf-parse.y"
    { proto_postconfig(); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2214 "obj/conf/cf-parse.y"
    { (yyval.i) = SYM_PROTO; ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2215 "obj/conf/cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2219 "obj/conf/cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2225 "obj/conf/cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2229 "obj/conf/cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[(2) - (2)].s)->class != SYM_TEMPLATE) && ((yyvsp[(2) - (2)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(2) - (2)].s)->def);
   ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2238 "obj/conf/cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2249 "obj/conf/cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2250 "obj/conf/cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2251 "obj/conf/cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2252 "obj/conf/cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2253 "obj/conf/cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2254 "obj/conf/cf-parse.y"
    { this_proto->vrf = if_get_by_name((yyvsp[(2) - (2)].t)); ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2259 "obj/conf/cf-parse.y"
    {
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[(1) - (1)].i)], (yyvsp[(1) - (1)].i), this_proto);
;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2264 "obj/conf/cf-parse.y"
    {
     if (this_channel->net_type && ((yyvsp[(2) - (2)].r)->addr_type != this_channel->net_type))
       cf_error("Incompatible table type");
     this_channel->table = (yyvsp[(2) - (2)].r);
   ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2269 "obj/conf/cf-parse.y"
    { this_channel->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2270 "obj/conf/cf-parse.y"
    { this_channel->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2271 "obj/conf/cf-parse.y"
    { this_channel->rx_limit = (yyvsp[(3) - (3)].cl); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2272 "obj/conf/cf-parse.y"
    { this_channel->in_limit = (yyvsp[(3) - (3)].cl); ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2273 "obj/conf/cf-parse.y"
    { this_channel->out_limit = (yyvsp[(3) - (3)].cl); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2274 "obj/conf/cf-parse.y"
    { this_channel->preference = (yyvsp[(2) - (2)].i); check_u16((yyvsp[(2) - (2)].i)); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2275 "obj/conf/cf-parse.y"
    { this_channel->in_keep_filtered = (yyvsp[(4) - (4)].i); ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2289 "obj/conf/cf-parse.y"
    {
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2300 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2307 "obj/conf/cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2309 "obj/conf/cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2310 "obj/conf/cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2314 "obj/conf/cf-parse.y"
    { (yyval.i) = PLA_DISABLE; ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2315 "obj/conf/cf-parse.y"
    { (yyval.i) = PLA_WARN; ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2316 "obj/conf/cf-parse.y"
    { (yyval.i) = PLA_BLOCK; ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2317 "obj/conf/cf-parse.y"
    { (yyval.i) = PLA_RESTART; ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2318 "obj/conf/cf-parse.y"
    { (yyval.i) = PLA_DISABLE; ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2322 "obj/conf/cf-parse.y"
    { (yyval.cl) = (struct channel_limit){ .limit = (yyvsp[(1) - (2)].i), (yyval.cl).action = (yyvsp[(2) - (2)].i) }; ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2323 "obj/conf/cf-parse.y"
    { (yyval.cl) = (struct channel_limit){}; ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2330 "obj/conf/cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2331 "obj/conf/cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2339 "obj/conf/cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2340 "obj/conf/cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2341 "obj/conf/cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2342 "obj/conf/cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2346 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2347 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (s64) (yyvsp[(3) - (4)].i) S_}; ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2348 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = TM_ISO_SHORT_S; ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2349 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = TM_ISO_SHORT_MS; ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2350 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = TM_ISO_SHORT_US; ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2351 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = TM_ISO_LONG_S; ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2352 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = TM_ISO_LONG_MS; ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2353 "obj/conf/cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = TM_ISO_LONG_US; ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2364 "obj/conf/cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2372 "obj/conf/cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); /* this_ipn->prefix stays zero */ ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2373 "obj/conf/cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].net); ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2377 "obj/conf/cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2378 "obj/conf/cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2392 "obj/conf/cf-parse.y"
    { iface_patt_check(); ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2394 "obj/conf/cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2406 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if ((yyvsp[(2) - (2)].i) > 255) cf_error("TX class must be in range 0-255"); ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2407 "obj/conf/cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if ((yyvsp[(2) - (2)].i) > 63)  cf_error("TX DSCP must be in range 0-63"); ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2414 "obj/conf/cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2425 "obj/conf/cf-parse.y"
    { DIRECT_CFG->check_link = (yyvsp[(4) - (5)].i); ;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2429 "obj/conf/cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2443 "obj/conf/cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2444 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2445 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2450 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2454 "obj/conf/cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2455 "obj/conf/cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2456 "obj/conf/cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2457 "obj/conf/cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2458 "obj/conf/cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2459 "obj/conf/cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2465 "obj/conf/cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2466 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2467 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2472 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2476 "obj/conf/cf-parse.y"
    { (yyval.i) = MD_STATES; ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2477 "obj/conf/cf-parse.y"
    { (yyval.i) = MD_MESSAGES; ;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 2498 "obj/conf/cf-parse.y"
    {
     if (!this_p_list) {
	this_p_list = cfg_alloc(sizeof(list));
	init_list(this_p_list);
	password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->length = strlen((yyvsp[(2) - (2)].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 2518 "obj/conf/cf-parse.y"
    { ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 2519 "obj/conf/cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 2520 "obj/conf/cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 2521 "obj/conf/cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 2522 "obj/conf/cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 2523 "obj/conf/cf-parse.y"
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[(2) - (4)].time); ;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 2524 "obj/conf/cf-parse.y"
    { this_p_item->gento = this_p_item->accto = (yyvsp[(2) - (4)].time); ;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 2525 "obj/conf/cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 2526 "obj/conf/cf-parse.y"
    { this_p_item->alg = (yyvsp[(2) - (4)].i); ;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 2530 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_MD5; ;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 2531 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_SHA1; ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 2532 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_SHA256; ;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 2533 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_SHA384; ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 2534 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_SHA512; ;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 2535 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_HMAC_MD5; ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 2536 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA1; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 2537 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA256; ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 2538 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA384; ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 2539 "obj/conf/cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA512; ;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 2547 "obj/conf/cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 2551 "obj/conf/cf-parse.y"
    { cmd_show_memory(); ;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 2555 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); ;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 2559 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); ;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 2563 "obj/conf/cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 2568 "obj/conf/cf-parse.y"
    { if_show(); ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 2572 "obj/conf/cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 2577 "obj/conf/cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 2580 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     init_list(&((yyval.ra)->tables));
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->running_on_config = new_config->fallback;
   ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 2586 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[(2) - (2)].net_ptr);
   ;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 2591 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->show_for = 1;
     (yyval.ra)->addr = (yyvsp[(3) - (3)].net_ptr);
   ;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 2597 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     rt_show_add_table((yyval.ra), ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   ;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 2603 "obj/conf/cf-parse.y"
    {
     struct rtable_config *t;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     WALK_LIST(t, config->tables)
       rt_show_add_table((yyval.ra), t->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_ALL;
   ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 2610 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (6)].ra);
     struct proto_config *cf = (void *) (yyvsp[(4) - (6)].s)->def;
     if ((yyvsp[(4) - (6)].s)->class != SYM_PROTO || !cf->proto) cf_error("%s is not a protocol", (yyvsp[(4) - (6)].s)->name);
     struct channel *c = proto_find_channel_by_name(cf->proto, (yyvsp[(6) - (6)].t));
     if (!c) cf_error("Channel %s.%s not found", (yyvsp[(4) - (6)].s)->name, (yyvsp[(6) - (6)].t));
     if (!c->in_table) cf_error("No import table in channel %s.%s", (yyvsp[(4) - (6)].s)->name, (yyvsp[(6) - (6)].t));
     rt_show_add_table((yyval.ra), c->in_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   ;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 2620 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 2625 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 2630 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 2634 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 2638 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   ;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 2642 "obj/conf/cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   ;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 2651 "obj/conf/cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (5)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (5)].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if ((yyvsp[(3) - (5)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (5)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (5)].i);
     (yyval.ra)->export_channel = proto_find_channel_by_name(c->proto, (yyvsp[(5) - (5)].t));
     if (!(yyval.ra)->export_channel) cf_error("Export channel not found");
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   ;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 2661 "obj/conf/cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 2669 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 2673 "obj/conf/cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 2680 "obj/conf/cf-parse.y"
    {
    (yyval.net_ptr) = cfg_alloc((yyvsp[(1) - (1)].net).length);
    net_copy((yyval.net_ptr), &(yyvsp[(1) - (1)].net));
  ;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 2687 "obj/conf/cf-parse.y"
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
    net_fill_vpn4((yyval.net_ptr), (yyvsp[(2) - (2)].ip4), IP4_MAX_PREFIX_LENGTH, (yyvsp[(1) - (2)].i64));
  ;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 2691 "obj/conf/cf-parse.y"
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
    net_fill_vpn6((yyval.net_ptr), (yyvsp[(2) - (2)].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[(1) - (2)].i64));
  ;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 2695 "obj/conf/cf-parse.y"
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
    net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[(1) - (3)].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[(3) - (3)].ip6), IP6_MAX_PREFIX_LENGTH);
  ;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 2699 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP))
     {
       (yyval.net_ptr) = cfg_alloc(ipa_is_ip4(SYM_VAL((yyvsp[(1) - (1)].s)).ip) ? sizeof(net_addr_ip4) : sizeof(net_addr_ip6));
       net_fill_ip_host((yyval.net_ptr), SYM_VAL((yyvsp[(1) - (1)].s)).ip);
     }
     else if (((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_NET)) && net_type_match(SYM_VAL((yyvsp[(1) - (1)].s)).net, NB_IP | NB_VPN))
       (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[(1) - (1)].s)).net; /* Avoid const warning */
     else
       cf_error("IP address or network expected");
   ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 2715 "obj/conf/cf-parse.y"
    { net_fill_ip4(&((yyval.net)), (yyvsp[(1) - (1)].ip4), IP4_MAX_PREFIX_LENGTH); ;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 2716 "obj/conf/cf-parse.y"
    { net_fill_ip6(&((yyval.net)), (yyvsp[(1) - (1)].ip6), IP6_MAX_PREFIX_LENGTH); ;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 2719 "obj/conf/cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 2720 "obj/conf/cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 2721 "obj/conf/cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 2726 "obj/conf/cf-parse.y"
    { (yyval.t) = "ipv4"; ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 2727 "obj/conf/cf-parse.y"
    { (yyval.t) = "ipv4-mc"; ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 2728 "obj/conf/cf-parse.y"
    { (yyval.t) = "ipv4-mpls"; ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 2729 "obj/conf/cf-parse.y"
    { (yyval.t) = "ipv6"; ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 2730 "obj/conf/cf-parse.y"
    { (yyval.t) = "ipv6-mc"; ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 2731 "obj/conf/cf-parse.y"
    { (yyval.t) = "ipv6-mpls"; ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 2732 "obj/conf/cf-parse.y"
    { (yyval.t) = "ipv6-sadr"; ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 2733 "obj/conf/cf-parse.y"
    { (yyval.t) = "vpn4"; ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 2734 "obj/conf/cf-parse.y"
    { (yyval.t) = "vpn4-mc"; ;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 2735 "obj/conf/cf-parse.y"
    { (yyval.t) = "vpn4-mpls"; ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 2736 "obj/conf/cf-parse.y"
    { (yyval.t) = "vpn6"; ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 2737 "obj/conf/cf-parse.y"
    { (yyval.t) = "vpn6-mc"; ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 2738 "obj/conf/cf-parse.y"
    { (yyval.t) = "vpn6-mpls"; ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 2739 "obj/conf/cf-parse.y"
    { (yyval.t) = "roa4"; ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 2740 "obj/conf/cf-parse.y"
    { (yyval.t) = "roa6"; ;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 2741 "obj/conf/cf-parse.y"
    { (yyval.t) = "flow4"; ;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 2742 "obj/conf/cf-parse.y"
    { (yyval.t) = "flow6"; ;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 2743 "obj/conf/cf-parse.y"
    { (yyval.t) = "mpls"; ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 2744 "obj/conf/cf-parse.y"
    { (yyval.t) = "pri"; ;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 2745 "obj/conf/cf-parse.y"
    { (yyval.t) = "sec"; ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 2751 "obj/conf/cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 2754 "obj/conf/cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 2757 "obj/conf/cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; ;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 2758 "obj/conf/cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 2759 "obj/conf/cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; ;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 2760 "obj/conf/cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; ;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 2761 "obj/conf/cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; ;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 2762 "obj/conf/cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); ;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 2769 "obj/conf/cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 2772 "obj/conf/cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 2775 "obj/conf/cf-parse.y"
    { io_log_dump(); cli_msg(0, ""); ;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 2778 "obj/conf/cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 2781 "obj/conf/cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 2784 "obj/conf/cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 2787 "obj/conf/cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 2790 "obj/conf/cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 2794 "obj/conf/cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 2798 "obj/conf/cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 2804 "obj/conf/cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 2805 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 2806 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 2810 "obj/conf/cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 2811 "obj/conf/cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 2819 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); ;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 2822 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); ;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 2825 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); ;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 2828 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); ;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 2831 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); ;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 2834 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); ;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 2839 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 2844 "obj/conf/cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 2848 "obj/conf/cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); ;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 2851 "obj/conf/cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 2852 "obj/conf/cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 2853 "obj/conf/cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 2857 "obj/conf/cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 2858 "obj/conf/cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 2859 "obj/conf/cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 2862 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); ;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 2870 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 2897 "obj/conf/cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 2911 "obj/conf/cf-parse.y"
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 2931 "obj/conf/cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].time); ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 2932 "obj/conf/cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].time); ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 2933 "obj/conf/cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].time); ;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 2934 "obj/conf/cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].time); ;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 2935 "obj/conf/cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); ;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 2936 "obj/conf/cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); ;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 2937 "obj/conf/cf-parse.y"
    { BFD_IFACE->auth_type = (yyvsp[(2) - (2)].i); ;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 2938 "obj/conf/cf-parse.y"
    {;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 2942 "obj/conf/cf-parse.y"
    { (yyval.i) = BFD_AUTH_NONE; ;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 2943 "obj/conf/cf-parse.y"
    { (yyval.i) = BFD_AUTH_SIMPLE; ;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 2944 "obj/conf/cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_MD5; ;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 2945 "obj/conf/cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; ;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 2946 "obj/conf/cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; ;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 2947 "obj/conf/cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; ;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 2965 "obj/conf/cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; ;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 2969 "obj/conf/cf-parse.y"
    { (yyval.iface) = NULL; ;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 2970 "obj/conf/cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); ;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 2971 "obj/conf/cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); ;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 2975 "obj/conf/cf-parse.y"
    { (yyval.a) = IPA_NONE; ;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 2976 "obj/conf/cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); ;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 2980 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 2981 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); ;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 2985 "obj/conf/cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 3005 "obj/conf/cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); ;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 3012 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[(1) - (2)].i));
  init_list(&BABEL_CFG->iface_list);
  BABEL_CFG->hold_time = 1 S_;
;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 3022 "obj/conf/cf-parse.y"
    { BABEL_CFG->randomize_router_id = (yyvsp[(4) - (4)].i); ;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 3035 "obj/conf/cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->limit = BABEL_HELLO_LIMIT;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 3049 "obj/conf/cf-parse.y"
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);

  BABEL_CFG->hold_time = MAX_(BABEL_CFG->hold_time, BABEL_IFACE->update_interval*BABEL_HOLD_TIME_FACTOR);
;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 3075 "obj/conf/cf-parse.y"
    { BABEL_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); ;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 3076 "obj/conf/cf-parse.y"
    { BABEL_IFACE->rxcost = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid rxcost"); ;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 3077 "obj/conf/cf-parse.y"
    { BABEL_IFACE->limit = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>16)) cf_error("Limit must be in range 1-16"); ;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 3078 "obj/conf/cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; ;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 3079 "obj/conf/cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; ;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 3080 "obj/conf/cf-parse.y"
    { BABEL_IFACE->hello_interval = (yyvsp[(3) - (3)].time); if (((yyvsp[(3) - (3)].time)<BABEL_MIN_INTERVAL) || ((yyvsp[(3) - (3)].time)>BABEL_MAX_INTERVAL)) cf_error("Hello interval must be in range 10 ms - 655 s"); ;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 3081 "obj/conf/cf-parse.y"
    { BABEL_IFACE->update_interval = (yyvsp[(3) - (3)].time); if (((yyvsp[(3) - (3)].time)<BABEL_MIN_INTERVAL) || ((yyvsp[(3) - (3)].time)>BABEL_MAX_INTERVAL)) cf_error("Update interval must be in range 10 ms - 655 s"); ;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 3082 "obj/conf/cf-parse.y"
    { BABEL_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX buffer must be in range 256-65535"); ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 3083 "obj/conf/cf-parse.y"
    { BABEL_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); ;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 3084 "obj/conf/cf-parse.y"
    { BABEL_IFACE->tx_tos = (yyvsp[(2) - (2)].i); ;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 3085 "obj/conf/cf-parse.y"
    { BABEL_IFACE->tx_priority = (yyvsp[(3) - (3)].i); ;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 3086 "obj/conf/cf-parse.y"
    { BABEL_IFACE->check_link = (yyvsp[(3) - (3)].i); ;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 3087 "obj/conf/cf-parse.y"
    { BABEL_IFACE->next_hop_ip4 = (yyvsp[(4) - (4)].a); if (!ipa_is_ip4((yyvsp[(4) - (4)].a))) cf_error("Must be an IPv4 address"); ;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 3088 "obj/conf/cf-parse.y"
    { BABEL_IFACE->next_hop_ip6 = (yyvsp[(4) - (4)].a); if (!ipa_is_ip6((yyvsp[(4) - (4)].a))) cf_error("Must be an IPv6 address"); ;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 3105 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_BABEL_METRIC); ;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 3111 "obj/conf/cf-parse.y"
    { babel_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 3115 "obj/conf/cf-parse.y"
    { babel_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 3119 "obj/conf/cf-parse.y"
    { babel_show_entries(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel)); ;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 3123 "obj/conf/cf-parse.y"
    { babel_show_routes(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel)); ;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 3129 "obj/conf/cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[(1) - (2)].i));
     BGP_CFG->local_port = BGP_PORT;
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
     BGP_CFG->check_link = -1;
   ;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 3159 "obj/conf/cf-parse.y"
    { BGP_CFG->local_port = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Invalid port number"); ;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 3160 "obj/conf/cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(3) - (3)].i); ;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 3165 "obj/conf/cf-parse.y"
    { BGP_CFG->remote_port = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Invalid port number"); ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 3166 "obj/conf/cf-parse.y"
    { BGP_CFG->remote_as = (yyvsp[(3) - (3)].i); ;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 3171 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i) ? ~(1 << 7) : 0; ;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 3172 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 3177 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 3181 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 0; ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 3182 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 1; ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 3183 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 2; ;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 3184 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 3; ;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 3185 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 4; ;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 3186 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 5; ;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 3187 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 6; ;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 3188 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 7; ;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 3189 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << 8; ;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 3197 "obj/conf/cf-parse.y"
    {
     BGP_CFG->local_ip = (yyvsp[(3) - (6)].a);
     if ((yyvsp[(4) - (6)].iface)) BGP_CFG->iface = (yyvsp[(4) - (6)].iface);
   ;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 3202 "obj/conf/cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     if ((yyvsp[(4) - (6)].iface)) BGP_CFG->iface = (yyvsp[(4) - (6)].iface);
   ;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 3208 "obj/conf/cf-parse.y"
    { BGP_CFG->iface = if_get_by_name((yyvsp[(3) - (4)].t)); ;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 3209 "obj/conf/cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); ;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 3210 "obj/conf/cf-parse.y"
    { BGP_CFG->rr_client = (yyvsp[(4) - (5)].i); ;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 3211 "obj/conf/cf-parse.y"
    { BGP_CFG->rs_client = (yyvsp[(4) - (5)].i); ;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 3212 "obj/conf/cf-parse.y"
    { BGP_CFG->confederation = (yyvsp[(3) - (4)].i); ;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 3213 "obj/conf/cf-parse.y"
    { BGP_CFG->confederation_member = (yyvsp[(4) - (5)].i); ;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 3214 "obj/conf/cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 3215 "obj/conf/cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 3216 "obj/conf/cf-parse.y"
    { BGP_CFG->multihop = 0; ;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 3217 "obj/conf/cf-parse.y"
    { BGP_CFG->multihop = 64; ;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 3218 "obj/conf/cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); ;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 3219 "obj/conf/cf-parse.y"
    { BGP_CFG->strict_bind = (yyvsp[(4) - (5)].i); ;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 3220 "obj/conf/cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 3221 "obj/conf/cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 3222 "obj/conf/cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 3223 "obj/conf/cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 3224 "obj/conf/cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 3225 "obj/conf/cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 3226 "obj/conf/cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 3227 "obj/conf/cf-parse.y"
    { BGP_CFG->local_ip = (yyvsp[(4) - (5)].a); ;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 3228 "obj/conf/cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); ;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 3229 "obj/conf/cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 3230 "obj/conf/cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 3231 "obj/conf/cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 3232 "obj/conf/cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 3233 "obj/conf/cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 3234 "obj/conf/cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 3235 "obj/conf/cf-parse.y"
    { BGP_CFG->disable_after_cease = (yyvsp[(5) - (6)].i); ;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 3236 "obj/conf/cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 3237 "obj/conf/cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 3238 "obj/conf/cf-parse.y"
    { BGP_CFG->enable_extended_messages = (yyvsp[(5) - (6)].i); ;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 3239 "obj/conf/cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 3240 "obj/conf/cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 3241 "obj/conf/cf-parse.y"
    { BGP_CFG->setkey = (yyvsp[(3) - (4)].i); ;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 3242 "obj/conf/cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 3243 "obj/conf/cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); ;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 3244 "obj/conf/cf-parse.y"
    { BGP_CFG->allow_local_as = -1; ;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 3245 "obj/conf/cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); ;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 3246 "obj/conf/cf-parse.y"
    { BGP_CFG->allow_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 3247 "obj/conf/cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); ;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 3248 "obj/conf/cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; ;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 3249 "obj/conf/cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 3250 "obj/conf/cf-parse.y"
    { BGP_CFG->llgr_mode = (yyvsp[(6) - (7)].i); ;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 3251 "obj/conf/cf-parse.y"
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; ;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 3252 "obj/conf/cf-parse.y"
    { BGP_CFG->llgr_time = (yyvsp[(6) - (7)].i); ;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 3253 "obj/conf/cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); ;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 3254 "obj/conf/cf-parse.y"
    { BGP_CFG->check_link = (yyvsp[(4) - (5)].i); ;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 3255 "obj/conf/cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); ;}
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 3256 "obj/conf/cf-parse.y"
    { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); ;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 3260 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_IPV4; ;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 3261 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_IPV6; ;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 3262 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_IPV4_MC; ;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 3263 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_IPV6_MC; ;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 3264 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_IPV4_MPLS; ;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 3265 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_IPV6_MPLS; ;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 3266 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_VPN4_MPLS; ;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 3267 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_VPN6_MPLS; ;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 3268 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_VPN4_MC; ;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 3269 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_VPN6_MC; ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 3270 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_FLOW4; ;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 3271 "obj/conf/cf-parse.y"
    { (yyval.i32) = BGP_AF_FLOW6; ;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 3275 "obj/conf/cf-parse.y"
    {
  const struct bgp_af_desc *desc = bgp_get_af_desc((yyvsp[(1) - (1)].i32));

  if (!desc)
    cf_error("Unknown AFI/SAFI");

  this_channel = channel_config_get(&channel_bgp, desc->name, desc->net, this_proto);

  /* New channel */
  if (!BGP_CC->desc)
  {
    BGP_CC->c.in_filter = FILTER_UNDEF;
    BGP_CC->c.out_filter = FILTER_UNDEF;
    BGP_CC->c.ra_mode = RA_UNDEF;
    BGP_CC->afi = (yyvsp[(1) - (1)].i32);
    BGP_CC->desc = desc;
    BGP_CC->next_hop_keep = 0xff; /* undefined */
    BGP_CC->gr_able = 0xff;	/* undefined */
    BGP_CC->llgr_able = 0xff;	/* undefined */
    BGP_CC->llgr_time = ~0U;	/* undefined */
  }
;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 3299 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 3300 "obj/conf/cf-parse.y"
    { (yyval.i) = NH_IBGP; ;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 3301 "obj/conf/cf-parse.y"
    { (yyval.i) = NH_EBGP; ;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 3305 "obj/conf/cf-parse.y"
    { BGP_CC->next_hop_addr = (yyvsp[(4) - (4)].a); ;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 3306 "obj/conf/cf-parse.y"
    { BGP_CC->next_hop_self = (yyvsp[(4) - (4)].i); ;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 3307 "obj/conf/cf-parse.y"
    { BGP_CC->next_hop_keep = (yyvsp[(4) - (4)].i); ;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 3308 "obj/conf/cf-parse.y"
    { BGP_CC->missing_lladdr = MLL_SELF; ;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 3309 "obj/conf/cf-parse.y"
    { BGP_CC->missing_lladdr = MLL_DROP; ;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 3310 "obj/conf/cf-parse.y"
    { BGP_CC->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 3311 "obj/conf/cf-parse.y"
    { BGP_CC->gw_mode = GW_DIRECT; ;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 3312 "obj/conf/cf-parse.y"
    { BGP_CC->gw_mode = GW_RECURSIVE; ;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 3313 "obj/conf/cf-parse.y"
    { BGP_CC->secondary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 3314 "obj/conf/cf-parse.y"
    { BGP_CC->gr_able = (yyvsp[(3) - (3)].i); ;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 3315 "obj/conf/cf-parse.y"
    { BGP_CC->llgr_able = (yyvsp[(5) - (5)].i); ;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 3316 "obj/conf/cf-parse.y"
    { BGP_CC->llgr_time = (yyvsp[(5) - (5)].i); ;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 3317 "obj/conf/cf-parse.y"
    { BGP_CC->ext_next_hop = (yyvsp[(4) - (4)].i); ;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 3318 "obj/conf/cf-parse.y"
    { BGP_CC->add_path = BGP_ADD_PATH_RX; ;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 3319 "obj/conf/cf-parse.y"
    { BGP_CC->add_path = BGP_ADD_PATH_TX; ;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 3320 "obj/conf/cf-parse.y"
    { BGP_CC->add_path = (yyvsp[(3) - (3)].i) ? BGP_ADD_PATH_FULL : 0; ;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 3321 "obj/conf/cf-parse.y"
    { BGP_CC->import_table = (yyvsp[(3) - (3)].i); ;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 3322 "obj/conf/cf-parse.y"
    {
    if (BGP_CC->desc->no_igp)
      cf_error("IGP table not allowed here");

    if ((yyvsp[(3) - (3)].r)->addr_type == NET_IP4)
      BGP_CC->igp_table_ip4 = (yyvsp[(3) - (3)].r);
    else if ((yyvsp[(3) - (3)].r)->addr_type == NET_IP6)
      BGP_CC->igp_table_ip6 = (yyvsp[(3) - (3)].r);
    else
      cf_error("Mismatched IGP table type");
   ;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 3346 "obj/conf/cf-parse.y"
    {
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 3357 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(PROTOCOL_BGP, BA_ORIGIN)); ;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 3359 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH)); ;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 3361 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(PROTOCOL_BGP, BA_NEXT_HOP)); ;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 3363 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 3365 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 3367 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 3369 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_AGGREGATOR)); ;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 3371 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_COMMUNITY)); ;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 3373 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(PROTOCOL_BGP, BA_ORIGINATOR_ID)); ;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 3375 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_CLUSTER_LIST)); ;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 3377 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(PROTOCOL_BGP, BA_EXT_COMMUNITY)); ;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 3379 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(PROTOCOL_BGP, BA_LARGE_COMMUNITY)); ;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 3390 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[(1) - (2)].i));
;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 3396 "obj/conf/cf-parse.y"
    { MRT_CFG->table_cf = (yyvsp[(2) - (2)].r); ;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 3397 "obj/conf/cf-parse.y"
    { MRT_CFG->table_expr = (yyvsp[(2) - (2)].t); ;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 3398 "obj/conf/cf-parse.y"
    { MRT_CFG->filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 3399 "obj/conf/cf-parse.y"
    { MRT_CFG->filter = (yyvsp[(1) - (1)].f); ;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 3400 "obj/conf/cf-parse.y"
    { MRT_CFG->filename = (yyvsp[(2) - (2)].t); ;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 3401 "obj/conf/cf-parse.y"
    { MRT_CFG->period = (yyvsp[(2) - (2)].i); ;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 3402 "obj/conf/cf-parse.y"
    { MRT_CFG->always_add_path = (yyvsp[(4) - (4)].i); ;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 3411 "obj/conf/cf-parse.y"
    { mrt_check_config(this_proto); ;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 3416 "obj/conf/cf-parse.y"
    { mrt_dump_cmd((yyvsp[(3) - (4)].md)); ;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 3419 "obj/conf/cf-parse.y"
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); ;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 3420 "obj/conf/cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->table_ptr = (yyvsp[(3) - (3)].r)->table; ;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 3421 "obj/conf/cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->table_expr = (yyvsp[(3) - (3)].t); ;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 3422 "obj/conf/cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->filter = (yyvsp[(3) - (3)].f); ;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 3423 "obj/conf/cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (2)].md); (yyval.md)->filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 3424 "obj/conf/cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->filename = (yyvsp[(3) - (3)].t); ;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 3430 "obj/conf/cf-parse.y"
    { ospf_proto_finish(); ;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 3433 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 3434 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 3435 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 3439 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_ospf, (yyvsp[(1) - (2)].i));
  this_proto->net_type = (yyvsp[(2) - (2)].i) ? NET_IP4 : 0;

  init_list(&OSPF_CFG->area_list);
  init_list(&OSPF_CFG->vlink_list);
  OSPF_CFG->ecmp = rt_default_ecmp;
  OSPF_CFG->tick = OSPF_DEFAULT_TICK;
  OSPF_CFG->ospf2 = (yyvsp[(2) - (2)].i);
  OSPF_CFG->af_ext = !(yyvsp[(2) - (2)].i);
;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 3457 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 3458 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 3463 "obj/conf/cf-parse.y"
    {
  /* TODO: change name for multicast channels */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[(1) - (2)].i)], (yyvsp[(1) - (2)].i), this_proto);

  /* Save the multicast flag */
  if (this_channel == proto_cf_main_channel(this_proto))
    OSPF_CFG->af_mc = (yyvsp[(2) - (2)].i);
;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 3476 "obj/conf/cf-parse.y"
    { this_proto->net_type = (yyvsp[(1) - (1)].cc)->net_type; ;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 3477 "obj/conf/cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 3478 "obj/conf/cf-parse.y"
    { OSPF_CFG->af_ext = (yyvsp[(2) - (2)].i); if (!ospf_cfg_is_v3()) cf_error("RFC5838 option requires OSPFv3"); ;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 3479 "obj/conf/cf-parse.y"
    { OSPF_CFG->vpn_pe = (yyvsp[(3) - (3)].i); ;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 3480 "obj/conf/cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); ;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 3481 "obj/conf/cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; ;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 3482 "obj/conf/cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; ;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 3483 "obj/conf/cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); ;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 3484 "obj/conf/cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i) <= 0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 3485 "obj/conf/cf-parse.y"
    { OSPF_CFG->instance_id = (yyvsp[(3) - (3)].i); OSPF_CFG->instance_id_set = 1; if ((yyvsp[(3) - (3)].i) > 255) cf_error("Instance ID must be in range 0-255"); ;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 3489 "obj/conf/cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 3504 "obj/conf/cf-parse.y"
    { ospf_area_finish(); ;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 3513 "obj/conf/cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ ;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 3514 "obj/conf/cf-parse.y"
    { this_area->type = OPT_N; ;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 3515 "obj/conf/cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 3516 "obj/conf/cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); ;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 3517 "obj/conf/cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 3518 "obj/conf/cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 3519 "obj/conf/cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 3520 "obj/conf/cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); ;}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 3521 "obj/conf/cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); ;}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 3522 "obj/conf/cf-parse.y"
    { this_nets = &this_area->net_list; ;}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 3523 "obj/conf/cf-parse.y"
    { this_nets = &this_area->enet_list; ;}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 3535 "obj/conf/cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->prefix = (yyvsp[(1) - (1)].net);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 3549 "obj/conf/cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 3550 "obj/conf/cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 3551 "obj/conf/cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 3555 "obj/conf/cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 3556 "obj/conf/cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 3565 "obj/conf/cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 3566 "obj/conf/cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); ;}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 3567 "obj/conf/cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 3568 "obj/conf/cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); ;}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 3569 "obj/conf/cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 3570 "obj/conf/cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 3571 "obj/conf/cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  ;}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 3572 "obj/conf/cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); ;}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 3573 "obj/conf/cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ;}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 3578 "obj/conf/cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 ;}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 3596 "obj/conf/cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 3597 "obj/conf/cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 3598 "obj/conf/cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 3599 "obj/conf/cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); ;}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 3600 "obj/conf/cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); ;}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 3601 "obj/conf/cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 3602 "obj/conf/cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 3603 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 3604 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 3605 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 3606 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 3607 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 3608 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 3609 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 3610 "obj/conf/cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 3611 "obj/conf/cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); ;}
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 3612 "obj/conf/cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); ;}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 3613 "obj/conf/cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 3614 "obj/conf/cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)>255) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 3615 "obj/conf/cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 3616 "obj/conf/cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 3617 "obj/conf/cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); ;}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 3618 "obj/conf/cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); ;}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 3619 "obj/conf/cf-parse.y"
    { OSPF_PATT->link_lsa_suppression = (yyvsp[(4) - (4)].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); ;}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 3621 "obj/conf/cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE; ;}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 3622 "obj/conf/cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); ;}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 3623 "obj/conf/cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ;}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 3624 "obj/conf/cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; ;}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 3625 "obj/conf/cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; ;}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 3626 "obj/conf/cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); ;}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 3627 "obj/conf/cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); ;}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 3628 "obj/conf/cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); ;}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 3629 "obj/conf/cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); ;}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 3630 "obj/conf/cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); ;}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 3631 "obj/conf/cf-parse.y"
    { OSPF_PATT->ttl_security = 2; ;}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 3632 "obj/conf/cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); ;}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 3644 "obj/conf/cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->prefix = (yyvsp[(1) - (1)].net);
 ;}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 3653 "obj/conf/cf-parse.y"
    { this_pref->hidden = 1; ;}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 3654 "obj/conf/cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); ;}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 3663 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 3664 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 3668 "obj/conf/cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 ;}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 3677 "obj/conf/cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->check_link = 1;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 ;}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 3700 "obj/conf/cf-parse.y"
    { OSPF_PATT->instance_id = (yyvsp[(2) - (2)].i); OSPF_PATT->instance_id_set = 1; if ((yyvsp[(2) - (2)].i) > 255) cf_error("Instance ID must be in range 0-255"); ;}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 3704 "obj/conf/cf-parse.y"
    { if (ospf_cfg_is_v3()) iface_patt_check(); ;}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 3718 "obj/conf/cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 3721 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 3722 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 3723 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_TAG); ;}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 3724 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_OSPF_ROUTER_ID); ;}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 3729 "obj/conf/cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 3733 "obj/conf/cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 3737 "obj/conf/cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 3743 "obj/conf/cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); ;}
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 3747 "obj/conf/cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); ;}
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 3753 "obj/conf/cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); ;}
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 3757 "obj/conf/cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); ;}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 3762 "obj/conf/cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); ;}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 3765 "obj/conf/cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   ;}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 3768 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; ;}
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 3769 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 3770 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ ;}
    break;

  case 1009:

/* Line 1455 of yacc.c  */
#line 3771 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1010:

/* Line 1455 of yacc.c  */
#line 3772 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 1011:

/* Line 1455 of yacc.c  */
#line 3773 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; ;}
    break;

  case 1012:

/* Line 1455 of yacc.c  */
#line 3774 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 3775 "obj/conf/cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); ;}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 3783 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_perf, (yyvsp[(1) - (2)].i));
  PERF_CFG->from = 10;
  PERF_CFG->to = 20;
  PERF_CFG->repeat = 4;
  PERF_CFG->threshold_max = 500 MS_;
  PERF_CFG->threshold_min = 1 MS_;
  PERF_CFG->keep = 0;
  PERF_CFG->mode = PERF_MODE_IMPORT;
;}
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 3801 "obj/conf/cf-parse.y"
    { this_proto->net_type = (yyvsp[(1) - (1)].cc)->net_type; ;}
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 3802 "obj/conf/cf-parse.y"
    { PERF_CFG->from = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 3803 "obj/conf/cf-parse.y"
    { PERF_CFG->to = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 3804 "obj/conf/cf-parse.y"
    { PERF_CFG->repeat = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 3805 "obj/conf/cf-parse.y"
    { PERF_CFG->threshold_min = (yyvsp[(3) - (3)].time); ;}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 3806 "obj/conf/cf-parse.y"
    { PERF_CFG->threshold_max = (yyvsp[(3) - (3)].time); ;}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 3807 "obj/conf/cf-parse.y"
    { PERF_CFG->keep = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 3808 "obj/conf/cf-parse.y"
    { PERF_CFG->mode = PERF_MODE_IMPORT; ;}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 3809 "obj/conf/cf-parse.y"
    { PERF_CFG->mode = PERF_MODE_EXPORT; ;}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 3815 "obj/conf/cf-parse.y"
    { this_channel = NULL; ;}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 3818 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_pipe, (yyvsp[(1) - (2)].i));
;}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 3822 "obj/conf/cf-parse.y"
    {
  this_channel = proto_cf_main_channel(this_proto);
  if (!this_channel) {
    this_channel = channel_config_new(NULL, NULL, 0, this_proto);
    this_channel->in_filter = FILTER_ACCEPT;
    this_channel->out_filter = FILTER_ACCEPT;
  }
;}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 3835 "obj/conf/cf-parse.y"
    { PIPE_CFG->peer = (yyvsp[(4) - (5)].r); ;}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 3843 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[(1) - (2)].i));

  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
;}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 3856 "obj/conf/cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); ;}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 3857 "obj/conf/cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 3857 "obj/conf/cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); ;}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 3858 "obj/conf/cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 3858 "obj/conf/cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); ;}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 3859 "obj/conf/cf-parse.y"
    { RADV_CFG->trigger = (yyvsp[(2) - (2)].net); ;}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 3860 "obj/conf/cf-parse.y"
    { RADV_CFG->propagate_routes = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 3873 "obj/conf/cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = (u32) -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = (u32) -1;
  RADV_IFACE->route_linger_time = (u32) -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = (u32) -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = (u32) -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
;}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 3896 "obj/conf/cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); ;}
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 3897 "obj/conf/cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); ;}
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 3898 "obj/conf/cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); ;}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 3899 "obj/conf/cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 3900 "obj/conf/cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 3901 "obj/conf/cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 3902 "obj/conf/cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) > 3600000) cf_error("Reachable time must be in range 0-3600000"); ;}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 3903 "obj/conf/cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 3904 "obj/conf/cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) > 255) cf_error("Current hop limit must be in range 0-255"); ;}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 3905 "obj/conf/cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) > 9000)  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != (uint) -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   ;}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 3910 "obj/conf/cf-parse.y"
    {
     RADV_IFACE->route_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(4) - (4)].i) != (uint) -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   ;}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 3914 "obj/conf/cf-parse.y"
    { RADV_IFACE->default_preference = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 3915 "obj/conf/cf-parse.y"
    { RADV_IFACE->route_preference = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 3916 "obj/conf/cf-parse.y"
    { RADV_IFACE->prefix_linger_time = (yyvsp[(4) - (4)].i); ;}
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 3917 "obj/conf/cf-parse.y"
    { RADV_IFACE->route_linger_time = (yyvsp[(4) - (4)].i); ;}
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 3918 "obj/conf/cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); ;}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 3919 "obj/conf/cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 3919 "obj/conf/cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); ;}
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 3920 "obj/conf/cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 3920 "obj/conf/cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); ;}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 3921 "obj/conf/cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 3922 "obj/conf/cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 3926 "obj/conf/cf-parse.y"
    { (yyval.i) = RA_PREF_LOW; ;}
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 3927 "obj/conf/cf-parse.y"
    { (yyval.i) = RA_PREF_MEDIUM; ;}
    break;

  case 1075:

/* Line 1455 of yacc.c  */
#line 3928 "obj/conf/cf-parse.y"
    { (yyval.i) = RA_PREF_HIGH; ;}
    break;

  case 1076:

/* Line 1455 of yacc.c  */
#line 3931 "obj/conf/cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval");

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
;}
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 3984 "obj/conf/cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = *(net_addr_ip6 *) &((yyvsp[(1) - (1)].net));

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
;}
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 3995 "obj/conf/cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 3996 "obj/conf/cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 3997 "obj/conf/cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 3998 "obj/conf/cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(4) - (4)].i) != (uint) -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   ;}
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 4002 "obj/conf/cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(4) - (4)].i) != (uint) -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   ;}
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 4009 "obj/conf/cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
;}
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 4033 "obj/conf/cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
;}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 4042 "obj/conf/cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
;}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 4049 "obj/conf/cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; ;}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 4053 "obj/conf/cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
;}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 4077 "obj/conf/cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
;}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 4089 "obj/conf/cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
;}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 4096 "obj/conf/cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; ;}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 4100 "obj/conf/cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
;}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 4124 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; ;}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 4125 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); ;}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 4129 "obj/conf/cf-parse.y"
    { (yyval.i) = (uint) -1; ;}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 4130 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 4133 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); ;}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 4134 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); ;}
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 4141 "obj/conf/cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 4142 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 4146 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[(1) - (2)].i));
  this_proto->net_type = (yyvsp[(2) - (2)].i) ? NET_IP4 : NET_IP6;

  init_list(&RIP_CFG->patt_list);
  RIP_CFG->rip2 = (yyvsp[(2) - (2)].i);
  RIP_CFG->ecmp = rt_default_ecmp;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;
  RIP_CFG->min_timeout_time = 60 S_;
  RIP_CFG->max_garbage_time = 60 S_;
;}
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 4161 "obj/conf/cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (2)].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; ;}
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 4162 "obj/conf/cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; ;}
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 4163 "obj/conf/cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 4177 "obj/conf/cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->check_link = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
;}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 4201 "obj/conf/cf-parse.y"
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
;}
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 4231 "obj/conf/cf-parse.y"
    { RIP_IFACE->metric = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Metric must be in range 1-255"); ;}
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 4232 "obj/conf/cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_MULTICAST; ;}
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 4233 "obj/conf/cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); ;}
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 4234 "obj/conf/cf-parse.y"
    { RIP_IFACE->passive = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 4235 "obj/conf/cf-parse.y"
    { RIP_IFACE->address = (yyvsp[(2) - (2)].a); if (ipa_is_ip4((yyvsp[(2) - (2)].a)) != rip_cfg_is_v2()) cf_error("IP address version mismatch"); ;}
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 4236 "obj/conf/cf-parse.y"
    { RIP_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); ;}
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 4237 "obj/conf/cf-parse.y"
    { RIP_IFACE->version = (yyvsp[(2) - (2)].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[(2) - (2)].i) != RIP_V1) && ((yyvsp[(2) - (2)].i) != RIP_V2)) cf_error("Unsupported version");
			;}
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 4241 "obj/conf/cf-parse.y"
    { RIP_IFACE->version_only = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 4242 "obj/conf/cf-parse.y"
    { RIP_IFACE->split_horizon = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 4243 "obj/conf/cf-parse.y"
    { RIP_IFACE->poison_reverse = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 4244 "obj/conf/cf-parse.y"
    { RIP_IFACE->check_zero = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 4245 "obj/conf/cf-parse.y"
    { RIP_IFACE->update_time = (yyvsp[(3) - (3)].i) S_; if ((yyvsp[(3) - (3)].i)<=0) cf_error("Update time must be positive"); ;}
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 4246 "obj/conf/cf-parse.y"
    { RIP_IFACE->timeout_time = (yyvsp[(3) - (3)].i) S_; if ((yyvsp[(3) - (3)].i)<=0) cf_error("Timeout time must be positive"); ;}
    break;

  case 1148:

/* Line 1455 of yacc.c  */
#line 4247 "obj/conf/cf-parse.y"
    { RIP_IFACE->garbage_time = (yyvsp[(3) - (3)].i) S_; if ((yyvsp[(3) - (3)].i)<=0) cf_error("Garbage time must be positive"); ;}
    break;

  case 1149:

/* Line 1455 of yacc.c  */
#line 4248 "obj/conf/cf-parse.y"
    { RIP_IFACE->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); ;}
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 4249 "obj/conf/cf-parse.y"
    { RIP_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX length must be in range 256-65535"); ;}
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 4250 "obj/conf/cf-parse.y"
    { RIP_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); ;}
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 4251 "obj/conf/cf-parse.y"
    { RIP_IFACE->tx_tos = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 4252 "obj/conf/cf-parse.y"
    { RIP_IFACE->tx_priority = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 4253 "obj/conf/cf-parse.y"
    { RIP_IFACE->ttl_security = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 4254 "obj/conf/cf-parse.y"
    { RIP_IFACE->ttl_security = 2; ;}
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 4255 "obj/conf/cf-parse.y"
    { RIP_IFACE->check_link = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 4256 "obj/conf/cf-parse.y"
    { RIP_IFACE->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); ;}
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 4257 "obj/conf/cf-parse.y"
    { RIP_IFACE->auth_type = (yyvsp[(2) - (2)].i); if ((yyvsp[(2) - (2)].i)) rip_check_auth(); ;}
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 4258 "obj/conf/cf-parse.y"
    { rip_check_auth(); ;}
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 4262 "obj/conf/cf-parse.y"
    { (yyval.i) = RIP_AUTH_NONE; ;}
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 4263 "obj/conf/cf-parse.y"
    { (yyval.i) = RIP_AUTH_PLAIN; ;}
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 4264 "obj/conf/cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; ;}
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 4265 "obj/conf/cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; ;}
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 4282 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_METRIC); ;}
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 4283 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_TAG); ;}
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 4289 "obj/conf/cf-parse.y"
    { rip_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 4293 "obj/conf/cf-parse.y"
    { rip_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 4301 "obj/conf/cf-parse.y"
    {
  this_proto = proto_config_new(&proto_static, (yyvsp[(1) - (2)].i));
  init_list(&STATIC_CFG->routes);
;}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 4309 "obj/conf/cf-parse.y"
    { this_proto->net_type = (yyvsp[(2) - (3)].cc)->net_type; ;}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 4310 "obj/conf/cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); ;}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 4311 "obj/conf/cf-parse.y"
    {
    if ((yyvsp[(4) - (5)].r)->addr_type == NET_IP4)
      STATIC_CFG->igp_table_ip4 = (yyvsp[(4) - (5)].r);
    else if ((yyvsp[(4) - (5)].r)->addr_type == NET_IP6)
      STATIC_CFG->igp_table_ip6 = (yyvsp[(4) - (5)].r);
    else
      cf_error("Incompatible IGP table type");
   ;}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 4319 "obj/conf/cf-parse.y"
    { static_route_finish(); ;}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 4323 "obj/conf/cf-parse.y"
    {
      this_snh = static_nexthop_new();
      this_snh->via = (yyvsp[(2) - (3)].a);
      this_snh->iface = (yyvsp[(3) - (3)].iface);
    ;}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 4328 "obj/conf/cf-parse.y"
    {
      this_snh = static_nexthop_new();
      this_snh->via = IPA_NONE;
      this_snh->iface = if_get_by_name((yyvsp[(2) - (2)].t));
    ;}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 4333 "obj/conf/cf-parse.y"
    {
    this_snh->mls = (yyvsp[(3) - (3)].mls);
  ;}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 4336 "obj/conf/cf-parse.y"
    {
    this_snh->onlink = (yyvsp[(3) - (3)].i);
  ;}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 4339 "obj/conf/cf-parse.y"
    {
    this_snh->weight = (yyvsp[(3) - (3)].i) - 1;
    if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256");
  ;}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 4343 "obj/conf/cf-parse.y"
    {
    this_snh->use_bfd = (yyvsp[(3) - (3)].i); cf_check_bfd((yyvsp[(3) - (3)].i));
  ;}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 4353 "obj/conf/cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].net_ptr);
     this_srt_last_cmd = &(this_srt->cmds);
     this_srt->mp_next = NULL;
     this_snh = NULL;
  ;}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 4365 "obj/conf/cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 4369 "obj/conf/cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (5)].a);
      this_srt->mls = (yyvsp[(5) - (5)].mls);
   ;}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 4374 "obj/conf/cf-parse.y"
    { this_srt->dest = RTD_NONE; ;}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 4375 "obj/conf/cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 4376 "obj/conf/cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 4377 "obj/conf/cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 4378 "obj/conf/cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 4379 "obj/conf/cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 4383 "obj/conf/cf-parse.y"
    { *this_srt_last_cmd = (yyvsp[(1) - (1)].x); this_srt_last_cmd = &((yyvsp[(1) - (1)].x)->next); ;}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 4399 "obj/conf/cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 4406 "obj/conf/cf-parse.y"
    { THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 4407 "obj/conf/cf-parse.y"
    { THIS_KRT->sys.metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 4410 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); ;}
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 4411 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); ;}
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 4412 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); ;}
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 4414 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); ;}
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 4415 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); ;}
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 4416 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); ;}
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 4417 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); ;}
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 4418 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); ;}
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 4419 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); ;}
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 4420 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); ;}
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 4421 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); ;}
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 4422 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); ;}
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 4423 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); ;}
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 4424 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); ;}
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 4425 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); ;}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 4426 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); ;}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 4428 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); ;}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 4429 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); ;}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 4430 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); ;}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 4431 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); ;}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 4432 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); ;}
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 4433 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); ;}
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 4434 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); ;}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 4435 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); ;}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 4436 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); ;}
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 4437 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); ;}
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 4439 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); ;}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 4440 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); ;}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 4447 "obj/conf/cf-parse.y"
    { this_log = cfg_allocz(sizeof(struct log_config)); ;}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 4449 "obj/conf/cf-parse.y"
    {
    this_log->mask = (yyvsp[(4) - (5)].i);
    add_tail(&new_config->logfiles, &this_log->n);
  ;}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 4456 "obj/conf/cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); ;}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 4457 "obj/conf/cf-parse.y"
    { (yyval.t) = bird_name; ;}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 4462 "obj/conf/cf-parse.y"
    { this_log->limit = (yyvsp[(1) - (2)].i); this_log->backup = (yyvsp[(2) - (2)].t); ;}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 4466 "obj/conf/cf-parse.y"
    {
     this_log->rf = rf_open(new_config->pool, (yyvsp[(1) - (2)].t), "a");
     if (!this_log->rf) cf_error("Unable to open log file '%s': %m", (yyvsp[(1) - (2)].t));
     this_log->fh = rf_file(this_log->rf);
     this_log->pos = -1;
     this_log->filename = (yyvsp[(1) - (2)].t);
   ;}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 4473 "obj/conf/cf-parse.y"
    { this_log->fh = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); ;}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 4474 "obj/conf/cf-parse.y"
    { this_log->fh = stderr; ;}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 4478 "obj/conf/cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 4479 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 4483 "obj/conf/cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 4484 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 4488 "obj/conf/cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 4489 "obj/conf/cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 4490 "obj/conf/cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 4491 "obj/conf/cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 4492 "obj/conf/cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 4493 "obj/conf/cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 4494 "obj/conf/cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 4495 "obj/conf/cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 4496 "obj/conf/cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 4503 "obj/conf/cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); ;}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 4504 "obj/conf/cf-parse.y"
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = rf_fileno(f);
   ;}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 4515 "obj/conf/cf-parse.y"
    { new_config->latency_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 4516 "obj/conf/cf-parse.y"
    { new_config->latency_limit = (yyvsp[(4) - (4)].time); ;}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 4517 "obj/conf/cf-parse.y"
    { new_config->watchdog_warning = (yyvsp[(3) - (3)].time); ;}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 4518 "obj/conf/cf-parse.y"
    { new_config->watchdog_timeout = ((yyvsp[(3) - (3)].time) + 999999) TO_S; ;}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 4528 "obj/conf/cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 4532 "obj/conf/cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); ;}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 4540 "obj/conf/cf-parse.y"
    { cmd_reconfig_confirm(); ;}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 4544 "obj/conf/cf-parse.y"
    { cmd_reconfig_undo(); ;}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 4548 "obj/conf/cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); ;}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 4552 "obj/conf/cf-parse.y"
    { cmd_shutdown(); ;}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 4555 "obj/conf/cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 4560 "obj/conf/cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 4561 "obj/conf/cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; ;}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 4562 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 4571 "obj/conf/cf-parse.y"
    {
     this_proto = krt_init_config((yyvsp[(1) - (2)].i));
;}
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 4580 "obj/conf/cf-parse.y"
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; ;}
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 4581 "obj/conf/cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) <= 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); ;}
    break;

  case 1294:

/* Line 1455 of yacc.c  */
#line 4586 "obj/conf/cf-parse.y"
    { this_proto->net_type = (yyvsp[(1) - (1)].cc)->net_type; ;}
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 4587 "obj/conf/cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 4588 "obj/conf/cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i) S_;
   ;}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 4592 "obj/conf/cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   ;}
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 4599 "obj/conf/cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); ;}
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 4600 "obj/conf/cf-parse.y"
    {
      THIS_KRT->merge_paths = (yyvsp[(3) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[(3) - (4)].i))
	cf_error("Path merging not supported on this platform");
#endif
   ;}
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 4613 "obj/conf/cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); ;}
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 4622 "obj/conf/cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i) S_;
   ;}
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 4629 "obj/conf/cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct kif_iface_config));
  add_tail(&THIS_KIF->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
;}
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 4636 "obj/conf/cf-parse.y"
    { kif_set_preferred((yyvsp[(2) - (2)].a)); ;}
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 4653 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SOURCE); ;}
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 4654 "obj/conf/cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_METRIC); ;}
    break;



/* Line 1455 of yacc.c  */
#line 13767 "obj/conf/cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 4657 "obj/conf/cf-parse.y"

/* C Code from conf/confbase.Y */

/* C Code from conf/flowspec.Y */

/* C Code from nest/config.Y */

/* C Code from proto/bfd/config.Y */

/* C Code from proto/babel/config.Y */

/* C Code from proto/bgp/config.Y */

/* C Code from proto/mrt/config.Y */

/* C Code from proto/ospf/config.Y */

/* C Code from proto/perf/config.Y */

/* C Code from proto/pipe/config.Y */

/* C Code from proto/radv/config.Y */

/* C Code from proto/rip/config.Y */

/* C Code from proto/static/config.Y */

/* C Code from sysdep/linux/netlink.Y */

/* C Code from sysdep/unix/config.Y */

/* C Code from sysdep/unix/krt.Y */


